'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 28 July 2002 at 5:07:39 pm'!
"Change Set:		MaObjectSerialization
Date:			15 July 2002
Author:			Chris Muller

<your descriptive text goes here>"!

MaMutatingProxy subclass: #MaBufferedObjectProxy
	instanceVariableNames: 'oid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaObject subclass: #MaAbstractClassIdManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaObject subclass: #MaAbstractObjectBuffer
	instanceVariableNames: 'byteArray startPos '
	classVariableNames: 'BufferClasses '
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaObject subclass: #MaAbstractOidManager
	instanceVariableNames: 'serializer '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaAbstractClassIdManager subclass: #MaDefaultClassIdManager
	instanceVariableNames: 'classesById idsByClass nextClassId classDefinitionsById '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaAbstractOidManager subclass: #MaDefaultOidManager
	instanceVariableNames: 'objects oids nextOid '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaAbstractObjectBuffer subclass: #MaFloatBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!

!MaFloatBuffer commentStamp: '<historical>' prior: 0!
My instances represent a Float serialized into a ByteArray.  Squeak Floats are represented with 32-bits.

My buffer fields are (these are 0-based indexes, sorry):

	(see my superclass)
	12 = the float as an IEEE32BitWord (see asIEEE32BitWord)

Notice we overwrite the bufferType.  We can identify this buffer as a Float buffer because its physicalSize will only be 16 bytes.  No other object is stored this compactly (except for the atomics, of course, which don't even need buffers).

This is done to optimize storage of Floats.  One of Magma's optimizations is every object buffer is a multiple of 8 bytes in size.  Otherwise, if we allowed the buffer-type, that would require us to start the 32-bit word in 1-based position 13, running us up to 24-bytes per float.

This way, we're only at 16 bytes per Float, which can be a heavily used class in financial programs.

So code that checks the buffer type must be sure to check the physicalSize first.!

MaAbstractObjectBuffer subclass: #MaObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!

!MaObjectBuffer commentStamp: '<historical>' prior: 0!
This class encapsulates a single object into its byteArray.  The object
it encapsulates can be any normal or byte-object (String, ByteArray, etc.).

My buffer fields are (these are 0-based indexes, sorry):

	(see superclass)
	15 = logicalSize
	19 = classId (2 bytes)
	21 = classVersion
!

MaObjectBuffer subclass: #MaByteObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!

!MaByteObjectBuffer commentStamp: '<historical>' prior: 0!
I encapsulate objects that represented as a series of bytes; such as Strings, ByteArrays, CompiledMethods, etc.

!

MaByteObjectBuffer subclass: #MaClassObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!

!MaClassObjectBuffer commentStamp: '<historical>' prior: 0!
This class encapsulates a single object into its byteArray.  The object
it encapsulates can be any normal or byte-object (String, ByteArray, etc.).

My buffer fields are (these are 0-based indexes, sorry):

	(see superclass)
	21 = represented class id (2 bytes)
!

MaObjectBuffer subclass: #MaNormalObjectBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!

!MaNormalObjectBuffer commentStamp: '<historical>' prior: 0!
This class encapsulates a single object into its byteArray.  The object
it encapsulates can be any normal or byte-object (String, ByteArray, etc.).

My buffer fields are (these are 0-based indexes, sorry):

	(see superclass)
	21 = class version
	23 = boolean flags
	24 = inst var #1!

MaSecurityViolation subclass: #MaObjectSerializationSecurityViolation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaSoftwareError subclass: #MaObjectSerializationSoftwareError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Exceptions Kernel'!
MaError subclass: #MaObjectSerializationUserError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaObject subclass: #MaObjectSerializer
	instanceVariableNames: 'oidManager classIdManager preMadeObjectBuffers graphBuffer createProxyBlock traversalStrategy preMadeByteArray bufferDescriptions amBusy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaSingleton subclass: #MaOidCalculator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Client private'!

!MaOidCalculator commentStamp: '<historical>' prior: 0!
The oid ranges are as follows:

0 to: 16r0000FFFFFFFFFFFF
	Integers from -140737488355328 to: 140737488355327

16r0001000000000000 to: 16rFFFE999999999999
	Oids for user objects

16rFFFF000000000000 to: (16rFFFF000000000000 + 65535)
	DBCS character set

16rFFFF000000000000 + 65536
	nil

16rFFFF000000000000 + 65537
	true

16rFFFF000000000000 + 65538
	false

16rFFFF000000000000 + 65539
	MaStorageForClass class ("metaclass")

16rFFFF000000000000 + 65540
	oid of the anchor of a repository

16rFFFF000000000000 + 65541
	unused slot in a MaHashIndex

16rFFFF000000000000 + 65542 to: 16rFFFF000000000000 + 65999
	future use?

16rFFFF000000000000 + 66000 to: 16rFFFFFFFFFFFFFFFF
	new objects
!

MaObject subclass: #MaSerializedGraphBuffer
	instanceVariableNames: 'byteArray '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!

!MaSerializedGraphBuffer commentStamp: '<historical>' prior: 0!
Header:

	total physical size of this buffer.  Necessary because we otherwise have no
	way of knowing where the actual end of the buffer is.
!

MaObject subclass: #MaStorageForGlobal
	instanceVariableNames: 'globalName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaStorageForGlobal subclass: #MaStorageForClass
	instanceVariableNames: 'id '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaObject subclass: #MaUpgradeableObject
	instanceVariableNames: 'definition namedObjects indexedObjects '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Object serialization'!
MaDefaultClassIdManager class
	instanceVariableNames: 'MinimumClasses '!

!MaMinimalObject methodsFor: 'testing'!
maIsBufferedObjectProxy

	^false
! !

!MaMinimalObject methodsFor: 'testing'!
maIsImmutableInBuffer

	^true
! !


!MaBufferedObjectProxy methodsFor: 'testing' stamp: 'cmm 5/20/2002 22:49'!
becomeForward: anObject
	"Squeak copies the identityHash of the receiver to anObject.  If anObject is a Symbol, this will necessitate a rehash of the SymbolTable and, potentially, Smalltalk."

	"self maMarked: 'performance'."  'performance'.
	"This has a potential for a significant issue if we were to materialize an indirect-collection of Symbol proxies, one-by-one.."
	anObject class == Symbol
		ifTrue:
			[ super becomeForward: anObject.
			Symbol rehash.
			Smalltalk rehash "in case a Class name" ]
		ifFalse:
			[ super becomeForward: anObject ]
! !

!MaBufferedObjectProxy methodsFor: 'testing'!
maIsBufferedObjectProxy

	^true
! !

!MaBufferedObjectProxy methodsFor: 'testing'!
maRequiresOwnBuffer

	^false
! !

!MaBufferedObjectProxy methodsFor: 'testing'!
oid

	^oid
! !

!MaBufferedObjectProxy methodsFor: 'private actions'!
mutant

	^self
! !

!MaBufferedObjectProxy methodsFor: 'private building'!
oid: anInteger

	oid _ anInteger
! !


!Object methodsFor: 'accessing'!
maAsStorageObject
	"Some objects should be converted to another object before being stored
	in a buffer."

	^self
! !

!Object methodsFor: 'accessing'!
maBufferInstSize
	"Answer the size of the buffer that contains the meat of the object
	(i.e., minus header info)."

	^self maInstSize
! !

!Object methodsFor: 'accessing'!
maDefaultGrowthSize
	"Answer the total physicalSize of the receiver (a.k.a. its
	basicSize).  Note this is not the difference between the size
	and it's basicSize, it is always the total basicSize."

	^0
! !

!Object methodsFor: 'accessing'!
maInstVarStorageSize
	"Answer the size of the buffer that contains the meat of the object
	(i.e., minus header info)."

	^self maBufferInstSize * MaNormalObjectBuffer addressSize! !

!Object methodsFor: 'accessing'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeNormalObjectBuffer
! !

!Object methodsFor: 'accessing'!
maStorageSize
	"Answer the size of the buffer that contains the meat of the object
	(i.e., minus header info)."

	^self maAsStorageObject maInstVarStorageSize
! !

!Object methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:30'!
size
	"Primitive. Answer the number of indexable variables in the receiver. 
	This value is the same as the largest legal subscript. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 62>
	^ 0! !

!Object methodsFor: 'testing'!
maCanGrow

	^true
! !

!Object methodsFor: 'testing'!
maIsBufferedObjectProxy

	^false
! !

!Object methodsFor: 'testing'!
maIsHashedCollection

	^false
! !

!Object methodsFor: 'testing'!
maIsImmutableInBuffer
	^false! !

!Object methodsFor: 'testing'!
maIsUpgradeableObject

	^false
! !

!Object methodsFor: 'testing' stamp: 'cmm 2/16/2002 17:29'!
maRequiresOwnBuffer
	"Answers whether the receiver has a special loid to represent it, such as nil, true, false and other immutables do."

	^true
! !

!Object methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer

	1
		to: self maInstSize
		do:
			[ :instVarIndex | | oid |
			self
				instVarAt: instVarIndex
				put: (
					aMaObjectSerializer
						objectWithOid: (oid _ self instVarAt: instVarIndex)
						ifAbsent: [ aMaObjectSerializer proxyFor: oid ]) ]
! !

!Object methodsFor: 'actions'!
maStreamInto: aMaNormalObjectBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaNormalObjectBuffer as they fit."

	1
		to: self maInstSize
		do:
			[ :index |
			aMaNormalObjectBuffer
				maInstVarAt: index
				put: (aMaObjectSerializer oidFor: (self instVarAt: index)) ]
! !


!Boolean methodsFor: 'testing'!
maIsImmutableInBuffer

	^true
! !

!Boolean methodsFor: 'testing'!
maRequiresOwnBuffer

	^false
! !


!Character methodsFor: 'accessing'!
maOid

	^MaOidCalculator oidForCharacter: self
! !

!Character methodsFor: 'testing'!
maIsImmutableInBuffer
	^true! !

!Character methodsFor: 'testing'!
maRequiresOwnBuffer

	^false
! !


!Class methodsFor: 'accessing'!
maAsStorageObject

	^self name
! !

!Class methodsFor: 'testing'!
maIsImmutableInBuffer

	^true
! !

!Class methodsFor: 'actions'!
maPopulateUsing: aMaObjectSerializer
	"Nothing to do with classes."
! !

!Class methodsFor: 'actions'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeClassObjectBuffer
! !


!Collection methodsFor: 'accessing'!
maBufferInstSize

	^self size
! !

!Collection methodsFor: 'actions' stamp: 'cmm 7/1/2002 00:37'!
maPopulateUsing: aMaObjectSerializer

	| fullOfOidsCopy |

	self isEmpty ifTrue: [ ^self ]. "performance, avoid the copy if possible.."
	"removeAll first or we end up or we end up with unwanted
	physicalSize growth and different hash pattern than the original."
self maMarked: 'performance'.
"This implementation would be inefficient with a Bag of a billion characters.."
	self removeAll: (fullOfOidsCopy _ self copy).
	fullOfOidsCopy do:
		[ :each |
		self
			add: (
				aMaObjectSerializer
					objectWithOid: each
					ifAbsent:
						[ MaObjectSerializationSoftwareError signal:
							'In Collection>>maPopulateUsing:, DefaultReadStrategy should have prevented need for proxy.  We don''t support automatic rehashing.' ]) ]
! !

!Collection methodsFor: 'actions'!
maStreamInto: aMaNormalObjectBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaNormalObjectBuffer as they fit."

	| index |

	index _ 1.
	self do:
		[ :eachLinkedObject |
		aMaNormalObjectBuffer
			maInstVarAt: index
			put: (aMaObjectSerializer oidFor: eachLinkedObject).
		index _ index + 1 ]
! !


!ArrayedCollection methodsFor: 'testing'!
maCanGrow

	^false
! !

!ArrayedCollection methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer

	self doWithIndex:
		[ :each :index |
		self
			at: index
			put: (
				aMaObjectSerializer
					objectWithOid: each
					ifAbsent: [ aMaObjectSerializer proxyFor: each ]) ]
! !


!Bag methodsFor: 'accessing' stamp: 'cmm 1/24/2002 15:23'!
maDefaultGrowthSize

	^contents maDefaultGrowthSize / 2
! !


!ByteArray methodsFor: 'accessing' stamp: 'cmm 7/14/2002 23:27'!
maInstVarStorageSize

	^self size
! !

!ByteArray methodsFor: 'accessing'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeByteObjectBuffer
! !

!ByteArray methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer
	"Nothing to do for this class.."
! !

!ByteArray methodsFor: 'actions'!
maStreamInto: aMaByteObjectBuffer for: aMaObjectSerializer

	aMaByteObjectBuffer storeDirectly: self
! !

!ByteArray methodsFor: 'testing' stamp: 'cmm 2/16/2002 17:23'!
maIsImmutableInBuffer

	^true
! !


!False methodsFor: 'accessing'!
maOid

	^MaOidCalculator oidForFalse
! !


!Interval methodsFor: 'accessing'!
maBufferInstSize
	"Intervals are stored efficiently, override with implementation from Object."

	^self maInstSize
! !

!Interval methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer

	1
		to: self maInstSize
		do:
			[ :instVarIndex | | oid |
			self
				instVarAt: instVarIndex
				put: (
					aMaObjectSerializer
						objectWithOid: (oid _ self instVarAt: instVarIndex)
						ifAbsent: [ aMaObjectSerializer proxyFor: oid ]) ]
! !

!Interval methodsFor: 'actions'!
maStreamInto: aMaNormalObjectBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaNormalObjectBuffer as they fit."

	1
		to: self maInstSize
		do:
			[ :index |
			aMaNormalObjectBuffer
				maInstVarAt: index
				put: (aMaObjectSerializer oidFor: (self instVarAt: index)) ]
! !


!MaAbstractClassIdManager methodsFor: 'framework'!
classForId: anInteger

	self subclassResponsibility
! !

!MaAbstractClassIdManager methodsFor: 'framework'!
idForClass: aClass

	self subclassResponsibility
! !


!MaAbstractObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:58'!
oid

	^self 
		uint: 64
		at: self bufferPositionOfOid
! !

!MaAbstractObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:44'!
physicalSize
	"See method comment for more info."

	^self 
		uint: 32
		at: self bufferPositionOfPhysicalSize
! !

!MaAbstractObjectBuffer methodsFor: 'accessing'!
startPos

	^startPos! !

!MaAbstractObjectBuffer methodsFor: 'accessing' stamp: 'cmm 7/9/2002 23:59'!
type
	"Answer the type of buffer this is.
		1=MaByteObjectBuffer
		2=MaNormalObjectBuffer
		3=MaClassObjectBuffer
		4=MaFloatBuffer"

	^self 
		uint: 8
		at: self bufferPositionOfBufferType
! !

!MaAbstractObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:41'!
oid: anInteger

	self
		uint: 64
		at: self bufferPositionOfOid
		put: anInteger
! !

!MaAbstractObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:34'!
physicalSize: anInteger

	^self
		uint: 32
		at: self bufferPositionOfPhysicalSize
		put: anInteger
! !

!MaAbstractObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 14:42'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer
	"physicalSize was already set in ensureSpaceFor:, no need to calculate it again."
	self
		oid: (aMaObjectSerializer oidFor: anObject);
		type: self bufferType
! !

!MaAbstractObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:41'!
type: anInteger

	self
		uint: 8
		at: self bufferPositionOfBufferType
		put: anInteger
! !

!MaAbstractObjectBuffer methodsFor: 'creation'!
independentCopy

	^self copyWithAttributes: #('byteArray')
! !

!MaAbstractObjectBuffer methodsFor: 'debugging'!
equals: aMaObjectBuffer

	^(self byteArray
		copyFrom: startPos + 1
		to: startPos + self physicalSize) = (
		aMaObjectBuffer byteArray
			copyFrom: startPos + 1
			to: startPos + self physicalSize)
! !

!MaAbstractObjectBuffer methodsFor: 'printing'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(oid)
		on: aStream
! !

!MaAbstractObjectBuffer methodsFor: 'required overrides' stamp: 'cmm 7/12/2002 11:56'!
physicalDataSizeNeededFor: anObject

	"Answers the number of bytes required to store anObject in my ByteArray, not including my header.  The total physical size (this + the header) must be a multiple of 8 to be compatible with a Magma optimization."! !

!MaAbstractObjectBuffer methodsFor: 'testing'!
isNormalObjectBuffer

	^false
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfBufferType

	^self class bufferPositionOfBufferType
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfOid
	"Zero-based position within a buffer that the oid is at."

	^0
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfPhysicalSize
	"Zero-based logical position within the byteArray that contains the
	physical size of this portion of the buffer (e.g., not including continuations)."

	^self class bufferPositionOfPhysicalSize
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
bufferType

	^self class bufferClasses indexOf: self class
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
byteArray

	^byteArray! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
headerSize
	"The number of bytes in each object record before the addresses of its
	'data' (instance variables, in the case of a NormalObjectBuffer) begins.
	The zero-based position in any buffer where the value of the object
	is stored, either the actual value or the address to it."

	^self class headerSize
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
oidSize
	"Answer the size, in bytes, of the sizes of the ids of objects that
	this buffer links to.  Most objects will be 8, but Strings would be 1.
	However, we don't actually need this method for Strings or other
	byte objects because we materialize those directly in maMaterializeFrom:"

	^self class addressSize
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
physicalSizeFor: anObject

	^self headerSize + (self physicalDataSizeNeededFor: anObject)
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
uint: numberOfBits at: position

	^self byteArray
		uint: numberOfBits
		at: self startPos + position
! !

!MaAbstractObjectBuffer methodsFor: 'private actions'!
ensureSpaceFor: anObject

	| requiredPhysicalSize totalSize |

	requiredPhysicalSize _ self physicalSizeFor: anObject.
	(totalSize _ requiredPhysicalSize + self startPos) > self byteArray size
		ifTrue:
			[ totalSize > (self byteArray size * 2)
				ifTrue:
					[ self growTo: totalSize ]
				ifFalse:
					[ self growByteArray ] ].
	self physicalSize: requiredPhysicalSize
! !

!MaAbstractObjectBuffer methodsFor: 'private building'!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaAbstractObjectBuffer methodsFor: 'private building'!
growByteArray

	self growTo: self byteArray size * 2
! !

!MaAbstractObjectBuffer methodsFor: 'private building'!
growTo: anInteger

	self byteArray: (
		(ByteArray new: anInteger)
			replaceFrom: 1
			to: self byteArray size
			with: self byteArray
			startingAt: 1)
! !

!MaAbstractObjectBuffer methodsFor: 'private building'!
startPos: anInteger

	startPos _ anInteger
! !

!MaAbstractObjectBuffer methodsFor: 'private building' stamp: 'cmm 1/24/2002 13:37'!
uint: numberOfBits at: zeroBasedIndexPosition put: valueInteger

	^self byteArray
		uint: numberOfBits
		at: self startPos + zeroBasedIndexPosition
		put: valueInteger
! !

!MaAbstractObjectBuffer methodsFor: 'private initializing'!
initialize

	super initialize.
	startPos _ 0
! !


!MaAbstractOidManager methodsFor: 'private accessing'!
serializer

	^serializer! !

!MaAbstractOidManager methodsFor: 'private building'!
serializer: anObject

	serializer _ anObject
! !


!MaBufferedObjectProxy class methodsFor: 'creation'!
oid: anInteger

	^self new oid: anInteger
! !


!MaDefaultClassIdManager methodsFor: 'building'!
addClassDefinition: aMaOdbmsClassDefinition

	nextClassId _ nextClassId max: aMaOdbmsClassDefinition id. "safety, may not be necessary"
	(self classDefinitionsById
		at: aMaOdbmsClassDefinition id
		ifAbsentPut: [ OrderedCollection new: 1 ])
			add: aMaOdbmsClassDefinition.
	^aMaOdbmsClassDefinition
! !

!MaDefaultClassIdManager methodsFor: 'building' stamp: 'cmm 7/8/2002 09:56'!
addNewClass: aClass
	"Answer the storage created for aClass."

	| answer |

	answer _ nil.
	aClass withAllSuperclassesDo:
		[ :eachClass |
		(self includesIdForClass: eachClass)
			ifFalse:
				[ | storage |
				storage _
					self
						addNewClass: eachClass
						withId: self nextUniqueId.
				answer isNil ifTrue: [ answer _ storage ] ] ].
	^answer
! !

!MaDefaultClassIdManager methodsFor: 'building'!
classDefinitionsById: aDictionary

	classDefinitionsById _ aDictionary
! !

!MaDefaultClassIdManager methodsFor: 'building' stamp: 'cmm 5/7/2002 23:33'!
idOfClass: aClass is: anInteger

	nextClassId _ nextClassId max: anInteger.
	self classesById
		at: anInteger
		put: aClass.
	^self idsByClass
		at: aClass
		put: anInteger
! !

!MaDefaultClassIdManager methodsFor: 'private building' stamp: 'cmm 3/27/2002 23:09'!
addNewClass: aClass withId: anInteger

	| definition |

	self
		idOfClass: aClass
		is: anInteger.
	definition _
		self addClassDefinition:
			(self classStorageClass
				className: aClass name
				id: anInteger).
	^definition
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
classDefinitionsById

	^classDefinitionsById
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
classForId: anInteger

	anInteger = self idOfMetaclass ifTrue: [ ^Class ].
	^anInteger <= self minimumClasses size
		ifTrue:
			[ self minimumClasses at: anInteger ]
		ifFalse:
			[ self classesById at: anInteger ]
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
classesById

	^classesById
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
currentVersionOfClass: aClass

	^self currentVersionOfClassWithId: (self idForClass: aClass)
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
currentVersionOfClassWithId: anInteger
	"classDefinitions should always have a class with id anInteger because,
	even if another session added a new class for the first time, other sessions
	will have their 'classDefinitions' object refreshed with that new class."

	^(self classDefinitionsById
		at: anInteger
		ifAbsent: [ ^1 ])
			size
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
definitionForClassId: classIdInteger version: classVersionInteger

	^(self classDefinitionsById at: classIdInteger) at: classVersionInteger
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
idForClass: aClass

	| index |

	aClass == Class ifTrue: [ ^self idOfMetaclass ].
	(index _ self minimumClasses indexOf: aClass) > 0 ifTrue: [ ^index ].
	^self
		idForClass: aClass
		ifAbsent: [ (self addNewClass: aClass) id ]
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
idForClass: aClass ifAbsent: aBlock

	| index |

	(index _ self minimumClasses indexOf: aClass) > 0 ifTrue: [ ^index ].
	^self idsByClass
		at: aClass
		ifAbsent: aBlock
! !

!MaDefaultClassIdManager methodsFor: 'accessing'!
minimumClasses

	^self class minimumClasses
! !

!MaDefaultClassIdManager methodsFor: 'private accessing' stamp: 'cmm 3/27/2002 23:10'!
classStorageClass

	^MaStorageForClass
! !

!MaDefaultClassIdManager methodsFor: 'private accessing'!
idOfMetaclass

	^0
! !

!MaDefaultClassIdManager methodsFor: 'private accessing'!
idsByClass

	^idsByClass! !

!MaDefaultClassIdManager methodsFor: 'private accessing'!
nextUniqueId

	^nextClassId _ nextClassId + 1
! !

!MaDefaultClassIdManager methodsFor: 'testing'!
includesIdForClass: aClass

	^(self idsByClass includesKey: aClass) or: [ self minimumClasses includes: aClass ]
! !

!MaDefaultClassIdManager methodsFor: 'creation'!
independentCopy

	^self copyWithAttributes: #('classesById' 'idsByClass')
! !

!MaDefaultClassIdManager methodsFor: 'creation'!
upgradeClassFor: aMaUpgradeableObject
	"Answer either the domain class or MaUpgradeableObject class if aMaUpgradeableObject
	is more than one version back."

	^(self isExactlyOneVersionBack: aMaUpgradeableObject)
		ifTrue:
			[ "this guy's classObject will be the same as the current versions
			classObject"
			aMaUpgradeableObject definition classObject ]
		ifFalse:
			[ MaUpgradeableObject definition: (
				self
					definitionForClassId: aMaUpgradeableObject classId
					version: aMaUpgradeableObject version + 1) ]
! !

!MaDefaultClassIdManager methodsFor: 'private initializing' stamp: 'cmm 4/21/2002 23:11'!
initialize

	super initialize.
	idsByClass _ Dictionary new.
	classesById _ Dictionary new.
	self classDefinitionsById: Dictionary new.
	nextClassId _ 100 "Leave plenty of room for any other 'base' classes users may want to have."
! !

!MaDefaultClassIdManager methodsFor: 'private testing'!
isExactlyOneVersionBack: aMaUpgradeableObject

	^((self currentVersionOfClassWithId: aMaUpgradeableObject classId) - aMaUpgradeableObject version) =
		1
! !


!MaDefaultOidManager methodsFor: 'building' stamp: 'cmm 7/8/2002 12:41'!
clean: oid

	^objects
		removeKey: oid
		ifAbsent: [ nil ]
! !

!MaDefaultOidManager methodsFor: 'building'!
oidOf: anObject is: anInteger

	self objects
		at: anInteger
		put: anObject.	
	^self oids
		at: anObject
		put: anInteger
! !

!MaDefaultOidManager methodsFor: 'building'!
retainIdentityOfProxy: aMaBufferedObjectProxy

	^self objects
		at: aMaBufferedObjectProxy oid
		put: aMaBufferedObjectProxy
! !

!MaDefaultOidManager methodsFor: 'private accessing'!
getNextOid

	^nextOid _ nextOid + 1
! !

!MaDefaultOidManager methodsFor: 'private accessing'!
objects

	^objects
! !

!MaDefaultOidManager methodsFor: 'private accessing'!
oids

	^oids
! !

!MaDefaultOidManager methodsFor: 'creation'!
independentCopy

	^self copyWithAttributes: #('objects' 'oids')
! !

!MaDefaultOidManager methodsFor: 'private initializing'!
initialize

	super initialize.
	self
		reset;
		resetNextOid
! !

!MaDefaultOidManager methodsFor: 'accessing' stamp: 'cmm 7/17/2002 22:51'!
hasOidFor: anObject

	^oids includesKey: anObject! !

!MaDefaultOidManager methodsFor: 'accessing'!
objectWithOid: anInteger

	^self
		objectWithOid: anInteger
		ifAbsent:
			[ self maSignalApplicationError:
				'Object with oid ' , anInteger printString , ' was not found.' ]
! !

!MaDefaultOidManager methodsFor: 'accessing' stamp: 'cmm 7/8/2002 12:41'!
objectWithOid: anInteger ifAbsent: aBlock

	^MaOidCalculator
		objectWithOid: anInteger
		ifNone:
			[ objects
				maAt: anInteger
				ifPresent:
					[ :obj |
					obj == nil
						ifTrue:
							[ self clean: anInteger.
							^aBlock value ]
						ifFalse:
							[ obj ] ]
				ifAbsent: [ ^aBlock value ] ]
! !

!MaDefaultOidManager methodsFor: 'accessing' stamp: 'cmm 7/8/2002 12:41'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^MaOidCalculator
		objectWithOid: anInteger
		ifNone:
			[ objects
				maAt: anInteger
				ifPresent:
					[ :obj |
					obj == nil
						ifTrue:
							[ self clean: anInteger.
							aBlock value ]
						ifFalse:
							[ oneArgBlock value: obj ] ]
				ifAbsent: [ aBlock value ] ]
! !

!MaDefaultOidManager methodsFor: 'accessing'!
oidFor: anObject

	^self
		oidFor: anObject
		ifAbsent:
			[ self
				oidOf: anObject
				is: self getNextOid ]
! !

!MaDefaultOidManager methodsFor: 'accessing'!
oidFor: anObject ifAbsent: aBlock

	anObject maIsBufferedObjectProxy ifTrue: [ ^anObject oid ].
	^anObject maRequiresOwnBuffer
		ifTrue:
			[ self oids
				maAt: anObject
				ifPresent: [ :oid | oid ]
				ifAbsent: aBlock ]
		ifFalse:
			[ anObject maOid ]
! !

!MaDefaultOidManager methodsFor: 'actions'!
rehashForRefresh

	oids rehash
! !

!MaDefaultOidManager methodsFor: 'actions'!
rehashOids

	oids rehash
! !

!MaDefaultOidManager methodsFor: 'actions'!
reset
	"When dealing with other serializers, their oid managers have different ideas on what
	oids of objects should be.  That's why we clear out all the oids from the previous serialization
	activity."

	oids _ WeakIdentityKeyDictionary new.
	objects _ WeakValueDictionary new
! !

!MaDefaultOidManager methodsFor: 'private actions'!
resetNextOid

	nextOid _ MaOidCalculator newOidMinimum
! !


!MaFloatBuffer methodsFor: 'accessing' stamp: 'cmm 7/12/2002 13:09'!
bufferPositionOfFloat

	^12! !

!MaFloatBuffer methodsFor: 'accessing' stamp: 'cmm 7/11/2002 00:13'!
float

	^Float fromIEEE32Bit:
		(self
			uint: 32
			at: self bufferPositionOfFloat)
! !

!MaFloatBuffer methodsFor: 'accessing' stamp: 'cmm 7/10/2002 20:11'!
float: aFloat

	self
		uint: 32
		at: self bufferPositionOfFloat
		put: aFloat asIEEE32BitWord
! !

!MaFloatBuffer methodsFor: 'accessing' stamp: 'cmm 7/12/2002 12:00'!
physicalDataSizeNeededFor: anObject
	"Number of bytes to store just the Float.  Header size is 12. for a total of 16 bytes per Float."

	^4! !

!MaFloatBuffer methodsFor: 'accessing' stamp: 'cmm 7/10/2002 20:10'!
populateHeaderFor: aFloat storageObject: storageObject using: aMaObjectSerializer

	super
		populateHeaderFor: aFloat
		storageObject: storageObject
		using: aMaObjectSerializer.
	self float: aFloat! !

!MaFloatBuffer methodsFor: 'accessing' stamp: 'cmm 7/11/2002 00:13'!
skeletonObjectUsing: aMaObjectSerializer
	"Floats don't need interim 'skeletons' like other objects do.  We are able to answer the real float right here, right now."

	^self float! !

!MaFloatBuffer methodsFor: 'printing' stamp: 'cmm 7/12/2002 12:36'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(float)
		on: aStream! !


!MaObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfClassId
	"Zero-based logical position within a buffer that the class id is at."

	^19
! !

!MaObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfClassVersion

	^21
! !

!MaObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfLogicalSize
	"Zero-based logical position within the byteArray that contains the
	total logical size of this buffer."

	^15
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:57'!
classId

	^self 
		uint: 16
		at: self bufferPositionOfClassId
! !

!MaObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:44'!
logicalSize
	"This is the size of the portion of the buffer required by the object itself,
	excluding the header.  This is used to help us reconstitute the object with
	the proper new: parameter."

	^self 
		uint: 32
		at: self bufferPositionOfLogicalSize
! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:38'!
classId: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassId
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:40'!
logicalSize: anInteger
	"Answer the logical size of the buffer, which is the same as the size of the object
	this buffer represents."

	self
		uint: 32
		at: self bufferPositionOfLogicalSize
		put: anInteger
! !

!MaObjectBuffer methodsFor: 'building'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer

	super
		populateHeaderFor: anObject
		storageObject: storageObject
		using: aMaObjectSerializer.
	self
		classId:
			(aMaObjectSerializer classIdManager idForClass: (aMaObjectSerializer classFor: anObject));
		setLogicalSizeFrom: anObject
! !

!MaObjectBuffer methodsFor: 'printing'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(classId)
		on: aStream.
	self class = MaObjectBuffer
		ifTrue:
			[ self
				maPrintAttributes: #(bufferType)
				on: aStream ]
! !

!MaObjectBuffer methodsFor: 'private building'!
setLogicalSizeFrom: anObject

	self logicalSize: anObject maStorageSize
! !


!MaByteObjectBuffer methodsFor: 'converting'!
asByteArray

	^self fillByteObject: (ByteArray new: self logicalSize)
! !

!MaByteObjectBuffer methodsFor: 'converting'!
asString

	^self fillByteObject: (String new: self logicalSize)
! !

!MaByteObjectBuffer methodsFor: 'private converting'!
fillByteObject: byteObject

	^byteObject
		replaceFrom: 1
		to: byteObject size
		with: self byteArray
		startingAt: self startPos + self headerSize + 1.
! !

!MaByteObjectBuffer methodsFor: 'accessing' stamp: 'cmm 7/12/2002 11:38'!
physicalDataSizeNeededFor: anObject
	"Calculate the physical size to accomodate anObject.  Ensure we always calculate a multiple of 8."

	^(anObject maStorageSize + 3) roundTo: 8 "Formula to round up to the next multiple of 8."
! !

!MaByteObjectBuffer methodsFor: 'printing'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(logicalSize)
		on: aStream
! !

!MaByteObjectBuffer methodsFor: 'private building'!
replaceFrom: startInteger to: endInteger with: byteObject startingAt: startingInteger

	self byteArray
		replaceFrom: self startPos + self headerSize + startInteger
		to: self startPos + self headerSize + endInteger
		with: byteObject
		startingAt: startingInteger
! !

!MaByteObjectBuffer methodsFor: 'creation'!
skeletonObjectUsing: aMaObjectSerializer

	^(aMaObjectSerializer classIdManager classForId: self classId) maMaterializeFrom: self
! !

!MaByteObjectBuffer methodsFor: 'actions'!
storeDirectly: byteObject

	self
		replaceFrom: 1
		to: byteObject size
		with: byteObject
		startingAt: 1
! !


!MaClassObjectBuffer methodsFor: 'private accessing' stamp: 'cmm 3/5/2002 22:47'!
bufferPositionOfRepresentedClassId

	^13
! !

!MaClassObjectBuffer methodsFor: 'accessing'!
populateHeaderFor: aClass storageObject: storageObject using: aMaObjectSerializer

	super
		populateHeaderFor: aClass
		storageObject: storageObject
		using: aMaObjectSerializer.
	self representedClassId: (aMaObjectSerializer classIdManager idForClass: aClass)
! !

!MaClassObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:57'!
representedClassId

	^self 
		uint: 16
		at: self bufferPositionOfRepresentedClassId
! !

!MaClassObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:38'!
representedClassId: anInteger

	^self
		uint: 16
		at: self bufferPositionOfRepresentedClassId
		put: anInteger
! !

!MaClassObjectBuffer methodsFor: 'accessing'!
skeletonObjectUsing: aMaObjectSerializer

	| class |

	class _ super skeletonObjectUsing: aMaObjectSerializer.
	aMaObjectSerializer classIdManager
		idOfClass: class
		is: self representedClassId.
	^class
! !


!MaNormalObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfBooleanFlags

	^23
! !

!MaNormalObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfInstVarAt: anInteger
	"Answer the physical 0-based byte-position within the receivers byteArray
	where the instVar with index anInteger is located."

	^self headerSize + ((anInteger - 1) * self oidSize)
! !

!MaNormalObjectBuffer methodsFor: 'building'!
bytesNeededForSlots: anInteger

	^anInteger * self class addressSize
! !

!MaNormalObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:38'!
classVersion: anInteger

	self
		uint: 16
		at: self bufferPositionOfClassVersion
		put: anInteger
! !

!MaNormalObjectBuffer methodsFor: 'building' stamp: 'cmm 1/24/2002 13:41'!
maInstVarAt: anInteger put: oid

	self
		uint: 64
		at: (self bufferPositionOfInstVarAt: anInteger)
		put: oid
! !

!MaNormalObjectBuffer methodsFor: 'building'!
populateHeaderFor: anObject storageObject: storageObject using: aMaObjectSerializer

	super
		populateHeaderFor: anObject
		storageObject: storageObject
		using: aMaObjectSerializer.
	self
		classVersion: (
			aMaObjectSerializer classIdManager
				currentVersionOfClass: (aMaObjectSerializer classFor: anObject));
		setGrowthIndicatorFor: anObject
			using: aMaObjectSerializer
! !

!MaNormalObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:57'!
classVersion

	^self 
		uint: 16
		at: self bufferPositionOfClassVersion
! !

!MaNormalObjectBuffer methodsFor: 'accessing' stamp: 'cmm 2/15/2002 00:25'!
didGrow

	^(self 
		uint: 8
		at: self bufferPositionOfBooleanFlags) maIsBitSet: 1
! !

!MaNormalObjectBuffer methodsFor: 'accessing'!
logicalInstSize
	"This is correct and meaningful only for non-byte objects, i.e., not for Strings
	and ByteArrays."

	^self logicalSize / MaAbstractObjectBuffer addressSize
! !

!MaNormalObjectBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 13:58'!
maInstVarAt: anInteger 
	"Answer the physical 0-based byte-position within the receivers byteArray
	where the instVar with index anInteger is located."

	^self 
		uint: 64
		at: (self bufferPositionOfInstVarAt: anInteger)
! !

!MaNormalObjectBuffer methodsFor: 'accessing'!
physicalDataSizeNeededFor: anObject

	^anObject maStorageSize max: (self bytesNeededForSlots: anObject maDefaultGrowthSize)
! !

!MaNormalObjectBuffer methodsFor: 'accessing'!
physicalInstSize
	"Answer the capacity of this buffer to hold references to other objects.
	This is only meaningful for non-byte objects."

	^(self physicalSize - self headerSize) / self oidSize
! !

!MaNormalObjectBuffer methodsFor: 'private building' stamp: 'cmm 1/24/2002 14:19'!
didGrow: aBoolean

	self
		uint: 8
		at: self bufferPositionOfBooleanFlags
		put: (
			aBoolean
				ifTrue:
					[ (self 
						uint: 8
						at: self bufferPositionOfBooleanFlags) maSetBit: 1 ]
				ifFalse:
					[ (self 
						uint: 8
						at: self bufferPositionOfBooleanFlags) maClearBit: 1 ])
! !

!MaNormalObjectBuffer methodsFor: 'private building' stamp: 'cmm 7/16/2002 23:50'!
setGrowthIndicatorFor: anObject using: aMaObjectSerializer
	"Be sure to set the physicalSize of the receiver prior to calling this method."

	self didGrow: (
		anObject maCanGrow
			ifTrue:
				[ | didGrow |
				didGrow _
					(aMaObjectSerializer hasBufferDescriptionFor: anObject) and:
						[ self physicalSize > (aMaObjectSerializer previousPhysicalSizeFor: anObject) ].
				didGrow ]
			ifFalse:
				[ false ]).
	"In Magma, if this is a new object, we need to remember its make aMaObjectSerializer remember its physicalSize in case this same client makes anObject grow.  If it is new, it shouldn't have a bufferDescription.."
	(aMaObjectSerializer hasBufferDescriptionFor: anObject)
		ifFalse:
			[ aMaObjectSerializer
				physicalBufferSizeFor: anObject
				is: self physicalSize "this has already been set.." ]! !

!MaNormalObjectBuffer methodsFor: 'actions'!
instVarsDoWithIndex: twoArgBlock

	1
		to: self logicalInstSize
		do:
			[ :index |
			twoArgBlock
				value: (self maInstVarAt: index)
				value: index ]
! !

!MaNormalObjectBuffer methodsFor: 'testing'!
isNormalObjectBuffer

	^true
! !

!MaNormalObjectBuffer methodsFor: 'private printing'!
oids

	| oids |

	self physicalInstSize maIsFraction ifTrue: [ ^'** invalid **' ].
	oids _ OrderedCollection new.
	1
		to: self logicalInstSize
		do: [ :index | oids add: (self maInstVarAt: index) ].
	^oids
! !

!MaNormalObjectBuffer methodsFor: 'printing'!
printOn: aStream

	super printOn: aStream.
	self
		maPrintAttributes: #(oids logicalInstSize classId physicalInstSize didGrow)
		on: aStream
! !

!MaNormalObjectBuffer methodsFor: 'creation'!
skeletonObjectUsing: aMaObjectSerializer

	| classOrUpgradeableObject classId |

	classOrUpgradeableObject _
		(aMaObjectSerializer classIdManager currentVersionOfClassWithId: (classId _ self classId)) >
			self classVersion
				ifTrue:
					[ MaUpgradeableObject definition: (
						aMaObjectSerializer classIdManager
							definitionForClassId: classId
							version: self classVersion) ]
				ifFalse:
					[ aMaObjectSerializer classIdManager classForId: classId ].
	^classOrUpgradeableObject maMaterializeFrom: self
! !


!MaObjectSerializer methodsFor: 'accessing'!
byteArray

	^self graphBuffer byteArray
! !

!MaObjectSerializer methodsFor: 'accessing'!
byteArray: aByteArray

	self graphBuffer byteArray: aByteArray.
	preMadeObjectBuffers do: [ :each | each byteArray: aByteArray ]
! !

!MaObjectSerializer methodsFor: 'accessing'!
classDefinitions

	^self classIdManager classDefinitionsById
! !

!MaObjectSerializer methodsFor: 'accessing'!
classDefinitionsByteArray
	"Answer a ByteArray that can be used to reinitialize a new instance of the
	receiver so that it can materialize the objects it has serialized.  See method
	comment for implementation details."

	| buffer |

	buffer _ self copyWithNewBuffer serializeGraph: self storableClassDefinitions.
	^buffer byteArray
		copyFrom: 1
		to: buffer bufferSize
! !

!MaObjectSerializer methodsFor: 'accessing'!
classIdManager

	^classIdManager
! !

!MaObjectSerializer methodsFor: 'accessing'!
graphBuffer

	^graphBuffer
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 7/17/2002 22:49'!
hasOidFor: anObject

	^oidManager hasOidFor: anObject! !

!MaObjectSerializer methodsFor: 'accessing'!
objectWithOid: anInteger ifAbsent: aBlock

	^self oidManager
		objectWithOid: anInteger
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'accessing'!
objectWithOid: anInteger ifFound: oneArgBlock ifAbsent: aBlock

	^self oidManager
		objectWithOid: anInteger
		ifFound: oneArgBlock
		ifAbsent: aBlock
! !

!MaObjectSerializer methodsFor: 'accessing'!
oidFor: anObject

	^self oidManager oidFor: anObject
! !

!MaObjectSerializer methodsFor: 'accessing' stamp: 'cmm 7/16/2002 23:32'!
previousPhysicalSizeFor: anObject
	
	^bufferDescriptions at: anObject
! !

!MaObjectSerializer methodsFor: 'accessing'!
proxyFor: oid

	^self oidManager retainIdentityOfProxy: (self createProxyBlock value: oid)
! !

!MaObjectSerializer methodsFor: 'accessing'!
traversalStrategy

	^traversalStrategy
! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 5/29/2002 00:46'!
materializeGraph: aByteArray

	^self
		materializeGraph: aByteArray
		do: [ :each | "do nothing" ]
! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 7/23/2002 19:55'!
materializeGraph: aByteArray do: oneArgBlock
	"Guard against stepping on my own buffers if I'm busy serializing or materializing already."

	^amBusy
		ifTrue:
			[ self copyWithNewBuffer
				byteArray: aByteArray;
				materializeGraphDo: oneArgBlock ]
		ifFalse:
			[ self
				byteArray: aByteArray;
				materializeGraphDo: oneArgBlock ]
! !

!MaObjectSerializer methodsFor: 'actions'!
reset

	self
		resetByteArray;
		resetOidManager
! !

!MaObjectSerializer methodsFor: 'actions'!
resetByteArray
	"Make the byteArray its proper size in case it previously had to
	grow."

	(preMadeObjectBuffers first byteArray ~~ self graphBuffer byteArray
		or: [ preMadeObjectBuffers first byteArray ~~ self preMadeByteArray ])
			ifTrue:
				[ self byteArray: self preMadeByteArray ].
	self graphBuffer resetBufferSize
! !

!MaObjectSerializer methodsFor: 'actions'!
resetOidManager
	"If receiving a byteArray from another serializer, this method should
	be invoked prior to materializing here so cached oids in the oidManager
	that may not match the objects that were serialized by the other
	serializer."

	self oidManager reset
! !

!MaObjectSerializer methodsFor: 'actions'!
serializeGraph: anObject
	"Answer a MaSerializedGraphBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	^self
		serializeGraph: anObject
		do: [ :each | nil ]
! !

!MaObjectSerializer methodsFor: 'actions' stamp: 'cmm 7/23/2002 19:56'!
serializeGraph: anObject do: oneArgBlock
	"Answer a MaSerializedGraphBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	^amBusy
		ifTrue:
			[ self copyWithNewBuffer
				resetByteArray;
				appendGraph: anObject
				do: oneArgBlock ]
		ifFalse:
			[ self
				resetByteArray;
				appendGraph: anObject
				do: oneArgBlock ]
! !

!MaObjectSerializer methodsFor: 'magma'!
classDefinitions: aDictionary
	"aDictionary keys are the classId (an Integer), values are a collection
	of MaClassDefinition, progressive versions."

	self classIdManager classDefinitionsById: aDictionary.
	aDictionary do:
		[ :each |
		self classIdManager
			idOfClass: each first classObject
			is: each first id ]
! !

!MaObjectSerializer methodsFor: 'initializing' stamp: 'cmm 5/29/2002 01:16'!
classDefinitionsByteArray: aByteArray
	"Initialize the receiver with aByteArray to an object that will eventually lead to a Dictionary of
	classDefinitions used to work with objects that were being used when the user saved off the
	byteArray obtained by calling the getter, classDefinitionsByteArray.  By setting this Array back,
	the receiver is properly initialized to be able to work with the serialized buffers that were serialized
	in the last session.  See #classDefinitionsByteArray for more info."

	| definitionsByteArray saveOffByteArray |

	saveOffByteArray _ self byteArray.
	definitionsByteArray _ (self materializeGraph: aByteArray) at: 2.
	self
		materializeGraph: definitionsByteArray;
		byteArray: saveOffByteArray
! !

!MaObjectSerializer methodsFor: 'building'!
classIdManager: aMaClassIdManager

	classIdManager _ aMaClassIdManager
! !

!MaObjectSerializer methodsFor: 'building'!
graphBuffer: aMaSerializedGraphBuffer

	graphBuffer _ aMaSerializedGraphBuffer
! !

!MaObjectSerializer methodsFor: 'building'!
initializeTraversalStrategy

	traversalStrategy _
		ObjectGraphTraversalStrategy new
			traverseWhen: [ :path :parent :index | path last maIsImmutableInBuffer not ]
! !

!MaObjectSerializer methodsFor: 'building'!
oidManager: aMaOidManager

	oidManager _ aMaOidManager
! !

!MaObjectSerializer methodsFor: 'building'!
optimumByteArraySize: anInteger

	anInteger ~= preMadeByteArray size ifTrue: [ preMadeByteArray _ ByteArray new: anInteger ].
	self resetByteArray
! !

!MaObjectSerializer methodsFor: 'building' stamp: 'cmm 7/16/2002 23:32'!
physicalBufferSizeFor: anObject is: anInteger

	bufferDescriptions
		at: anObject
		put: anInteger
! !

!MaObjectSerializer methodsFor: 'building'!
toCreateProxies: oneArgBlock

	createProxyBlock _ oneArgBlock
! !

!MaObjectSerializer methodsFor: 'copying' stamp: 'cmm 5/29/2002 23:31'!
copyWithNewBuffer

	^(self copyWithAttributes: #('preMadeByteArray' 'graphBuffer'))
		initializePreMadeObjectBuffers;
		resetByteArray;
		beBored! !

!MaObjectSerializer methodsFor: 'copying'!
independentCopy
	"Answer a completely independent copy of the receiver.  This will probably
	mostly be used during debugging."

	| copy |

	copy _
		self copy
			oidManager: self oidManager independentCopy;
			classIdManager: self classIdManager independentCopy;
			resetByteArray.
	^copy
		copyAttributes: #(
			'preMadeByteArray' 'graphBuffer' 'preMadeObjectBuffer' 'traversalStrategy' 'substitutes'
			'bufferDescriptions')
		from: self
! !

!MaObjectSerializer methodsFor: 'private'!
append: anObject
	"Append only anObject to the receiver."

	self graphBuffer increaseBufferSizeBy:
		(self
			bufferFor: anObject
			byteArray: self byteArray
			startingAt: self graphBuffer bufferSize)
				physicalSize
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:43'!
appendGraph: anObject do: oneArgBlock
	"Answer a MaSerializedObjectBuffer containing anObject and all objects
	it can reach, serialized into aByteArray."

	self beBusy.
	oneArgBlock value: anObject.
	self append: anObject.
	anObject
		maGraphDo:
			[ :path :parent :index |
			path last ~~ anObject
				ifTrue:
					[ oneArgBlock value: path last.
					path last maRequiresOwnBuffer ifTrue: [ self append: path last ] ] ]
		using: self traversalStrategy.
	self beBored.
	^self graphBuffer
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:22'!
beBored

	amBusy _ false
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:33'!
beBusy

	amBusy _ true
! !

!MaObjectSerializer methodsFor: 'private'!
bufferFor: anObject byteArray: aByteArray startingAt: anInteger

	| buffer storageObject |

	storageObject _ anObject maAsStorageObject.
	buffer _
		(self preMadeObjectBufferFor: anObject)
			startPos: anInteger;
			ensureSpaceFor: storageObject.
	buffer byteArray == aByteArray
		ifFalse:
			[ "aByteArray may not have been big enough.."
			self byteArray: buffer byteArray ].
	buffer
		populateHeaderFor: anObject
		storageObject: storageObject
		using: self.
	storageObject
		maStreamInto: buffer
		for: self.
	^buffer
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 1/24/2002 14:10'!
classFor: anObject

	^anObject maIsClass ifTrue: [ Class ] ifFalse: [ anObject class ]
! !

!MaObjectSerializer methodsFor: 'private'!
createProxyBlock

	^createProxyBlock
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 7/16/2002 23:32'!
hasBufferDescriptionFor: anObject

	^bufferDescriptions includesKey: anObject
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 5/29/2002 23:22'!
initialize

	super initialize.
	self
		oidManager: (MaDefaultOidManager serializer: self);
		classIdManager: MaDefaultClassIdManager new;
		initializeTraversalStrategy;
		toCreateProxies: [ :oid | MaBufferedObjectProxy oid: oid ].
	self graphBuffer: MaSerializedGraphBuffer new.
	self initializePreMadeObjectBuffers.
	bufferDescriptions _ WeakIdentityKeyDictionary new.
	self beBored
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 7/12/2002 11:25'!
initializePreMadeObjectBuffers

	preMadeObjectBuffers _ MaAbstractObjectBuffer bufferClasses collect:
		[ :each |
		each
			byteArray: (ByteArray new: 50)
			startPos: 0 ]
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 6/29/2002 14:37'!
materializeGraphDo: oneArgBlock
	"Materialize as much as the object in the receivers byteArray as possible.  For each object *materialized*, value oneArgBlock.  oneArgBlock is not valued for objects encountered in the materialized graph if they were already present in the receivers oidManager, that way we know when objects are exactly materialized."

	| skeletons rootObject |

	skeletons _ OrderedCollection new: 48.
	rootObject _ nil.
	self beBusy.
	self graphBuffer buffersDo:
		[ :each | | object |
		object _
			self
				objectWithOid: each oid
				ifFound:
					[ :foundObj |
					foundObj maIsBufferedObjectProxy "true when materializing a proxy"
						ifTrue:
							[ | skel |
							skel _ self newSkeletonFor: each.
							foundObj becomeForward: skel.
							skeletons add: foundObj ].
					foundObj ]
				ifAbsent: [ skeletons add: (self newSkeletonFor: each) ].
		rootObject isNil ifTrue: [ rootObject _ object ].
		object maCanGrow
			ifTrue:
				[ self
					physicalBufferSizeFor: object
					is: each physicalSize ] ].
	self beBored.
	"Do not merge these do's.."
	skeletons do: [ :eachObject | eachObject maPopulateUsing: self ].
	skeletons do:
		[ :eachFormedObject | eachFormedObject maIsUpgradeableObject ifTrue: [ eachFormedObject upgradeUsing: self ] ].
	skeletons do:
		[ :eachFormedAndUpgradedObject |
		eachFormedAndUpgradedObject maIsHashedCollection
			ifTrue:
				[ eachFormedAndUpgradedObject rehash ] ].
	skeletons do: [ :eachFullyFormedObject | oneArgBlock value: eachFullyFormedObject ].
	^rootObject
! !

!MaObjectSerializer methodsFor: 'private'!
newSkeletonFor: aMaObjectBuffer

	| skel |

	self oidManager
		oidOf: (skel _ aMaObjectBuffer skeletonObjectUsing: self)
		is: aMaObjectBuffer oid.
	^skel
! !

!MaObjectSerializer methodsFor: 'private'!
oidManager

	^oidManager
! !

!MaObjectSerializer methodsFor: 'private'!
optimumByteArraySize

	^self preMadeByteArray size
! !

!MaObjectSerializer methodsFor: 'private'!
preMadeByteArray

	^preMadeByteArray! !

!MaObjectSerializer methodsFor: 'private'!
preMadeByteObjectBuffer

	^preMadeObjectBuffers at: 1
! !

!MaObjectSerializer methodsFor: 'private'!
preMadeClassObjectBuffer

	^preMadeObjectBuffers at: 3
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 7/11/2002 00:00'!
preMadeFloatObjectBuffer

	^preMadeObjectBuffers at: 4
! !

!MaObjectSerializer methodsFor: 'private'!
preMadeNormalObjectBuffer

	^preMadeObjectBuffers at: 2
! !

!MaObjectSerializer methodsFor: 'private'!
preMadeObjectBufferFor: anObject

	^anObject maSelectPreMadeObjectBufferFrom: self
! !

!MaObjectSerializer methodsFor: 'private' stamp: 'cmm 3/27/2002 23:30'!
storableClassDefinitions
	"Answer a two-element Array.  The first element is an Array of MaStorageForClass'.
	The second is a ByteArray that can be used to then materialize a dictionary of
	MaClassDefinitions.  This is how we solve the chicken-and-egg problem of materializing
	the complex classDefinitions (since the very act of attempting to materialize them
	cannot be done until we know all of the classes that make up the definitions themselves)."

	| definitionsBuffer cleanSerializer classesForDefinitions answer |

	answer _ Array new: 2.
	cleanSerializer _
		self class new
			serializeGraph: self classIdManager classDefinitionsById;
			yourself.
	"Whatever classes cleanSerializer discovered while serializing the definitions
	are what we need to serialize in the first part of the Array."
	classesForDefinitions _
		answer
			at: 1
			put:
				(cleanSerializer classDefinitions collect: [ :each | each last asSimpleStorage ])
					asArray.
	"To be safe, ensure we have the same classId as the one corresponding in the
	receiver."
	classesForDefinitions do:
		[ :eachStorageForClass |
		eachStorageForClass id: (self classIdManager idForClass: eachStorageForClass classObject) ].
	definitionsBuffer _
		self copyWithNewBuffer serializeGraph: self classIdManager classDefinitionsById.
	answer
		at: 2
		put: (
			definitionsBuffer byteArray
				copyFrom: 1
				to: definitionsBuffer bufferSize).
	^answer
! !


!MaSerializedGraphBuffer methodsFor: 'private actions' stamp: 'cmm 1/24/2002 13:44'!
bufferPositionsDo: oneArgBlock

	"Value oneArgBlock with the value of the starting position of each
	buffer in the receiver."

	| pos end |

	pos _ self headerSize.
	end _ self bufferSize - 1.
	[ pos <= end ] whileTrue:
		[ oneArgBlock value: pos.
		pos _
			pos +
				(self byteArray 
					uint: 32 
					at: pos + MaAbstractObjectBuffer bufferPositionOfPhysicalSize) ]
! !

!MaSerializedGraphBuffer methodsFor: 'creation'!
buffers

	| coll |

	coll _ OrderedCollection new.
	self buffersDo: [ :each | coll add: each copy ].
	^coll
! !

!MaSerializedGraphBuffer methodsFor: 'actions'!
buffersDo: oneArgBlock
	"Value oneArgBlock with each ObjectBuffer in the
	receiver.  There is one ObjectBuffer for each object in the graph that
	the receiver represents."

	| preMadeBuffers |

	preMadeBuffers _ self newPremadeBuffers.
	self bufferPositionsDo:
		[ :eachPosition | | buffer |
		buffer _ (preMadeBuffers at: (self bufferTypeAt: eachPosition)).
		buffer
			byteArray: self byteArray;
			startPos: eachPosition.
		oneArgBlock value: buffer ]
! !

!MaSerializedGraphBuffer methodsFor: 'accessing' stamp: 'cmm 1/24/2002 14:01'!
bufferSize

	^self byteArray 
		uint: 32
		at: 0
! !

!MaSerializedGraphBuffer methodsFor: 'accessing'!
byteArray
	"One ByteArray holds the entire graph of objects."

	^byteArray
! !

!MaSerializedGraphBuffer methodsFor: 'private building' stamp: 'cmm 1/24/2002 13:40'!
bufferSize: anInteger

	self byteArray
		uint: 32
		at: 0
		put: anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'private building' stamp: 'cmm 5/1/2002 23:04'!
growByteArray
	"Don't allow growth beyond 20Meg, if something is wrong it could crash
	this image.."

	self byteArray size * 2 > 20000000
		ifTrue:
			[ MaObjectSerializationSecurityViolation signal: 'Serializations beyond 10 megabytes are not allowed.' ]
		ifFalse:
			[ self byteArray: (
				(ByteArray new: self byteArray size * 2)
					replaceFrom: 1
					to: self byteArray size
					with: self byteArray
					startingAt: 1) ]
! !

!MaSerializedGraphBuffer methodsFor: 'private accessing' stamp: 'cmm 7/12/2002 13:36'!
bufferTypeAt: startPositionOfObjectBuffer

	"Check for special-case 16-byte buffer can only be a FloatBuffer because the FloatBuffer does not specify a bufferType because we only allow buffer sizes a multiple of 8.."
	(self physicalSizeAt: startPositionOfObjectBuffer) = MaFloatBuffer physicalSize
		ifTrue:
			[ ^MaAbstractObjectBuffer bufferClasses indexOf: MaFloatBuffer ].
	^self byteArray
		uint: 8
		at: startPositionOfObjectBuffer + MaAbstractObjectBuffer bufferPositionOfBufferType! !

!MaSerializedGraphBuffer methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 21:42'!
headerSize

	^self class headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'private accessing' stamp: 'cmm 7/12/2002 13:59'!
physicalSizeAt: startPositionOfObjectBuffer

	^self byteArray
		uint: 32
		at: startPositionOfObjectBuffer + MaAbstractObjectBuffer bufferPositionOfPhysicalSize! !

!MaSerializedGraphBuffer methodsFor: 'building'!
byteArray: aByteArray

	byteArray _ aByteArray
! !

!MaSerializedGraphBuffer methodsFor: 'building'!
increaseBufferSizeBy: anInteger

	self bufferSize: self bufferSize + anInteger
! !

!MaSerializedGraphBuffer methodsFor: 'building'!
resetBufferSize
	"Reset the current pointer (which is the bufferSize) back to the beginning."

	self bufferSize: self headerSize
! !

!MaSerializedGraphBuffer methodsFor: 'building'!
resetByteArray: aByteArray

	self
		byteArray: aByteArray;
		resetBufferSize
! !

!MaSerializedGraphBuffer methodsFor: 'building'!
trimFat

	self byteArray: (
		self byteArray
			copyFrom: 1
			to: self bufferSize).
	^self
! !

!MaSerializedGraphBuffer methodsFor: 'private creation' stamp: 'cmm 4/23/2002 19:46'!
copy

	^self copyWithAttributes: #('byteArray')
! !

!MaSerializedGraphBuffer methodsFor: 'private creation'!
newPremadeBuffers

	^MaAbstractObjectBuffer bufferClasses collect: [ :each | each new ]
! !

!MaSerializedGraphBuffer methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:13'!
printOn: aStream

	| buffers |

	super printOn: aStream.
	self byteArray notNil
		ifTrue:
			[ buffers _ self buffers.
			aStream
				nextPutAll: ' (';
				maPrint: buffers size;
				nextPutAll: ' objects in ';
				maPrint: self bufferSize;
				nextPutAll: ' bytes)'.
			buffers notEmpty
				ifTrue:
					[ aStream tab.
					buffers first maPrintAbbreviatedOn: aStream ] ]
! !


!MaStorageForGlobal methodsFor: 'private accessing'!
globalName

	^globalName! !

!MaStorageForGlobal methodsFor: 'private building'!
globalName: aSymbol

	globalName _ aSymbol
! !

!MaStorageForGlobal methodsFor: 'accessing' stamp: 'cmm 7/23/2002 19:59'!
globalObject
	"Why the double at:?  Because, when the globalName is a proxy, for some reason, Squeak can't send the message just after materializing a Symbol.  rehasing issue?"

	^Smalltalk
		at: self globalName
		ifAbsent:
			[ Smalltalk
				at: self globalName
				ifAbsent: [ MaSoftwareError signal: 'was not expecting to miss ', self globalName ] ]
! !

!MaStorageForGlobal methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream nextPutAll: self globalName
! !


!MaStorageForClass methodsFor: 'accessing'!
className

	^self globalName
! !

!MaStorageForClass methodsFor: 'accessing'!
classObject

	^self globalObject
! !

!MaStorageForClass methodsFor: 'accessing'!
id

	^id
! !

!MaStorageForClass methodsFor: 'building'!
className: aSymbol

	self globalName: aSymbol
! !

!MaStorageForClass methodsFor: 'building'!
id: anInteger

	id _ anInteger
! !

!MaStorageForClass methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer

	super maPopulateUsing: aMaObjectSerializer.
	aMaObjectSerializer classIdManager
		idOfClass: self classObject
		is: self id
! !

!MaStorageForClass methodsFor: 'converting' stamp: 'cmm 3/27/2002 23:31'!
asSimpleStorage

	^self
! !


!MaUpgradeableObject methodsFor: 'actions'!
basicNew
	"The application believes it is dealing with a class.  Since I represent
	the class as well as the instance I'm upgrading to, I simply set my
	indexedSize and answer myself."

	self indexedSize: nil.
	^self
! !

!MaUpgradeableObject methodsFor: 'actions'!
basicNew: anInteger
	"The application believes it is dealing with a class.  Since I represent
	the class as well as the instance I'm upgrading to, I simply set my
	indexedSize and answer myself."

	self indexedSize: (Array new: anInteger).
	^self
! !

!MaUpgradeableObject methodsFor: 'accessing'!
classId

	^self definition id
! !

!MaUpgradeableObject methodsFor: 'accessing'!
indexedSize

	^self indexedObjects size
! !

!MaUpgradeableObject methodsFor: 'accessing'!
maAllInstVarNames

	^self definition maAllInstVarNames
! !

!MaUpgradeableObject methodsFor: 'accessing'!
maInstVarAt: anInteger

	^anInteger > self namedObjects size
		ifTrue:
			[ self indexedObjects at: anInteger - self namedObjects size ]
		ifFalse:
			[ self namedObjects at: anInteger ]
! !

!MaUpgradeableObject methodsFor: 'accessing'!
maInstVarNamed: aString

	^self namedObjects at: (self indexOfInstVarNamed: aString)
! !

!MaUpgradeableObject methodsFor: 'accessing'!
namedSize

	^self namedObjects size
! !

!MaUpgradeableObject methodsFor: 'accessing'!
objectInstSize

	^self indexedSize + self namedSize
! !

!MaUpgradeableObject methodsFor: 'accessing'!
version

	^self definition version
! !

!MaUpgradeableObject methodsFor: 'private accessing'!
definition

	^definition! !

!MaUpgradeableObject methodsFor: 'private accessing'!
indexOfInstVarNamed: aString

	^self definition maAllInstVarNames indexOf: aString
! !

!MaUpgradeableObject methodsFor: 'private accessing'!
indexedObjects

	^indexedObjects! !

!MaUpgradeableObject methodsFor: 'private accessing'!
namedObjects

	^namedObjects! !

!MaUpgradeableObject methodsFor: 'private building'!
definition: aMaStorageForClass

	definition _ aMaStorageForClass.
	self namedObjects: (Array new: aMaStorageForClass namedInstSize)
! !

!MaUpgradeableObject methodsFor: 'private building'!
indexedObjects: anArray

	indexedObjects _ anArray
! !

!MaUpgradeableObject methodsFor: 'private building'!
indexedSize: anInteger

	self indexedObjects: (Array new: anInteger)
! !

!MaUpgradeableObject methodsFor: 'private building'!
namedObjects: anArray

	namedObjects _ anArray
! !

!MaUpgradeableObject methodsFor: 'building'!
maInstVarAt: anInteger put: anObject

	anInteger > self namedObjects size
		ifTrue:
			[ self indexedObjects
				at: anInteger - self namedObjects size
				put: anObject ]
		ifFalse:
			[ self namedObjects
				at: anInteger
				put: anObject ]
! !

!MaUpgradeableObject methodsFor: 'building'!
maInstVarNamed: aString put: anObject

	self namedObjects
		at: (self indexOfInstVarNamed: aString)
		put: anObject
! !

!MaUpgradeableObject methodsFor: 'building'!
maMaterializeFrom: aMaNormalObjectBuffer

	self indexedSize: aMaNormalObjectBuffer physicalInstSize - self definition namedInstSize.
	1
		to: aMaNormalObjectBuffer physicalInstSize
		do:
			[ :index |
			self
				maInstVarAt: index
				put: (aMaNormalObjectBuffer maInstVarAt: index) ]
! !

!MaUpgradeableObject methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer
	"Replace the receivers named and indexed objects, which are currently
	oids, with the real objects.  If this isn't the current definition, upgrade it
	until it is."

	1
		to: self maInstSize
		do:
			[ :index | | oid |
			self
				maInstVarAt: index
				put: (
					aMaObjectSerializer
						objectWithOid: (oid _ self maInstVarAt: index)
						ifAbsent: [ aMaObjectSerializer proxyFor: oid ]) ]
! !

!MaUpgradeableObject methodsFor: 'testing'!
maIsUpgradeableObject

	^true
! !

!MaUpgradeableObject methodsFor: 'private actions' stamp: 'cmm 5/15/2002 20:56'!
upgradeUsing: aMaObjectSerializer
	"A really wild method, this performs an 'upgrade' on the receiver until it
	conforms to the current class version in the image."

	| classIdManager upgrade |
	classIdManager _ aMaObjectSerializer classIdManager.
	upgrade _ self.
	[ upgrade class == self class ] whileTrue:
		[ | nextUpgradeClass nextUpgrade |
		"upgradeClassFor: returns a class or aMaUpgradeableObject"
		nextUpgradeClass _ classIdManager upgradeClassFor: upgrade.
self maMarked: 'dev'.  "after VI4, we can use user-stored upgradeBlocks..
nextUpgrade _ upgrade definition upgradeBlock"
		nextUpgrade _ MaUpgradeableObject defaultUpgradeBlock
				value: upgrade
				value: nextUpgradeClass.
		upgrade _ nextUpgrade ].
	self becomeForward: upgrade.
	aMaObjectSerializer oidManager rehashOids
! !


!Number methodsFor: 'testing'!
maIsImmutableInBuffer

	^true
! !

!Number methodsFor: 'accessing'!
maAsStorageObject

	^self printString
! !

!Number methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer
	"Nothing to do for this class.."
! !

!Number methodsFor: 'actions'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeByteObjectBuffer
! !


!Float methodsFor: 'printing' stamp: 'cmm 7/11/2002 00:05'!
maStreamInto: aMaSerializedObjectBuffer for: aMaObjectSerializer

	"Nothing to do for Floats."
! !

!Float methodsFor: 'serialization' stamp: 'cmm 7/10/2002 22:54'!
maAsStorageObject

	^self! !

!Float methodsFor: 'serialization' stamp: 'cmm 7/10/2002 22:57'!
maCanGrow

	^false! !

!Float methodsFor: 'serialization' stamp: 'cmm 7/11/2002 00:00'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeFloatObjectBuffer! !


!Fraction methodsFor: 'testing'!
maIsImmutableInBuffer

	^false
! !

!Fraction methodsFor: 'creation'!
maAsStorageObject

	^self
! !

!Fraction methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer
	"Duplicated implementation from Object, because all other kinds
	of Number will not need to do anything."

	1
		to: self maInstSize
		do:
			[ :instVarIndex | | oid |
			self
				instVarAt: instVarIndex
				put: (
					aMaObjectSerializer
						objectWithOid: (oid _ self instVarAt: instVarIndex)
						ifAbsent: [ aMaObjectSerializer proxyFor: oid ]) ]
! !

!Fraction methodsFor: 'actions'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeNormalObjectBuffer
! !


!Integer methodsFor: 'accessing'!
maOid

	^MaOidCalculator oidForInteger: self
! !

!Integer methodsFor: 'actions'!
maStreamInto: aMaSerializedObjectBuffer for: aMaObjectSerializer

	"Do nothing.  Nothing can be streamed into an Integer."
! !


!LargePositiveInteger methodsFor: 'testing'!
maRequiresOwnBuffer

	^(MaOidCalculator isOptimizedInteger: self) not
! !

!LargePositiveInteger methodsFor: 'accessing'!
maAsStorageObject

	^self printString
! !


!Object class methodsFor: 'creation'!
maMaterializeFrom: aMaNormalObjectBuffer
	"Create a skeleton instance of the receiver, populating its
	instVars with oid integers in aMaNormalObjectBuffer."

	| skeleton indexedSize |

	indexedSize _ aMaNormalObjectBuffer physicalInstSize - self instSize.
	skeleton _ indexedSize = 0 ifTrue: [ self basicNew ] ifFalse: [ self basicNew: indexedSize ].
	1
		to: skeleton maInstSize
		do:
			[ :index |
			skeleton
				instVarAt: index
				put: (aMaNormalObjectBuffer maInstVarAt: index) ].
	^skeleton
! !


!Class class methodsFor: 'accessing'!
maMaterializeFrom: aMaClassObjectBuffer

	^Smalltalk
		at: aMaClassObjectBuffer asString asSymbol
		ifAbsent:
			[ MaStorageForClass
				className: aMaClassObjectBuffer asString asSymbol
				id: aMaClassObjectBuffer representedClassId ]
! !

!Class class methodsFor: 'accessing'!
maOid

	^MaOidCalculator oidForMetaclass
! !

!Class class methodsFor: 'testing'!
maRequiresOwnBuffer

	^false
! !


!Collection class methodsFor: 'creation'!
maMaterializeFrom: aMaNormalObjectBuffer

	| skeleton |

	skeleton _ self new: aMaNormalObjectBuffer physicalInstSize.
	1
		to: aMaNormalObjectBuffer logicalInstSize
		do: [ :index | skeleton add: (aMaNormalObjectBuffer maInstVarAt: index) ].
	^skeleton
! !


!ArrayedCollection class methodsFor: 'creation'!
maMaterializeFrom: aMaNormalObjectBuffer

	| skeleton size |

	skeleton _ self new: (size _ aMaNormalObjectBuffer logicalInstSize).
	1
		to: size
		do:
			[ :index |
			skeleton
				at: index
				put: (aMaNormalObjectBuffer maInstVarAt: index) ].
	^skeleton
! !


!ByteArray class methodsFor: 'creation'!
maMaterializeFrom: aMaByteObjectBuffer

	^aMaByteObjectBuffer asByteArray
! !


!Float class methodsFor: 'creation' stamp: 'cmm 7/11/2002 00:11'!
maMaterializeFrom: aMaByteObjectBuffer

	"Nothing to do for Floats since they are stored in a special buffer (see MaFloatBuffer).  They are materialized in skeletonObjectUsing:."
! !


!LargePositiveInteger class methodsFor: 'creation'!
maMaterializeFrom: aMaByteObjectBuffer

	^aMaByteObjectBuffer asString asNumber
! !


!MaAbstractObjectBuffer class methodsFor: 'accessing'!
addressSize
	"The size of addresses, in bytes.  Addresses consist of 2 bytes for the
	object space id, and 6 bytes for the file pointer id."

	^8
! !

!MaAbstractObjectBuffer class methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:04'!
bufferClasses

	^BufferClasses! !

!MaAbstractObjectBuffer class methodsFor: 'accessing'!
bufferPositionOfBufferType

	^12
! !

!MaAbstractObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/10/2002 20:27'!
byteArray: aByteArray startPos: anInteger

	^self new
		startPos: anInteger;
		byteArray: aByteArray
! !

!MaAbstractObjectBuffer class methodsFor: 'creation' stamp: 'cmm 7/10/2002 20:28'!
createFromByteArray: aByteArray startPos: anInteger

	^(self
		bufferClassFor: aByteArray
		startPos: anInteger)
			byteArray: aByteArray
			startPos: anInteger
! !

!MaAbstractObjectBuffer class methodsFor: 'initializing' stamp: 'cmm 7/15/2002 23:03'!
initialize
	"Called from preamble of MaObjectSerialization."

	BufferClasses _ Array
		with: MaByteObjectBuffer
		with: MaNormalObjectBuffer
		with: MaClassObjectBuffer
		with: MaFloatBuffer! !

!MaAbstractObjectBuffer class methodsFor: 'required overrides'!
headerSize

	self subclassResponsibility
! !

!MaAbstractObjectBuffer class methodsFor: 'private accessing' stamp: 'cmm 7/10/2002 00:34'!
bufferClassFor: aByteArray startPos: anInteger

	^(aByteArray
		uint: 16
		at: anInteger + self bufferPositionOfPhysicalSize) = 16
			ifTrue: [ MaFloatBuffer ]
			ifFalse:
				[ self bufferClasses at: 
				(aByteArray 
					uint: 8
					at: anInteger + self bufferPositionOfBufferType) ]! !

!MaAbstractObjectBuffer class methodsFor: 'private accessing'!
bufferPositionOfPhysicalSize
	"Zero-based logical position within this buffer's byteArray that contains the
	physical size of this buffer."

	^8
! !


!MaAbstractOidManager class methodsFor: 'creation'!
serializer: aMaObjectSerializer

	^self new serializer: aMaObjectSerializer
! !


!MaDefaultClassIdManager class methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:12'!
minimumClasses

	^MinimumClasses! !

!MaDefaultClassIdManager class methodsFor: 'accessing' stamp: 'cmm 7/16/2002 20:24'!
minimumClasses: anArray

	MinimumClasses _ anArray! !

!MaDefaultClassIdManager class methodsFor: 'initializing' stamp: 'cmm 7/15/2002 23:33'!
initialize
	"Called from postscript."

	self minimumClasses: { MaStorageForClass. String. ByteArray. Set. Symbol. Array }! !


!MaFloatBuffer class methodsFor: 'required overrides' stamp: 'cmm 7/12/2002 11:53'!
headerSize
	"The header for a FloatBuffer is the oid (8-bytes) + the physicalSize (4-bytes), which always has a value of 16."

	^12! !

!MaFloatBuffer class methodsFor: 'accessing' stamp: 'cmm 7/12/2002 13:31'!
physicalSize

	^16! !


!MaObjectBuffer class methodsFor: 'creation'!
headerSize

	^'This kind of buffer should not need to know its headerSize..'
! !


!MaByteObjectBuffer class methodsFor: 'creation'!
headerSize
	"The number of bytes in each object record before the user bytes begin."

	^24
! !


!MaNormalObjectBuffer class methodsFor: 'accessing'!
headerSize
	"The number of bytes in each object record before the addresses of its
	instance variables begin."

	^24
! !


!MaObjectSerializer class methodsFor: 'creation'!
new

	^self new: 10000
! !

!MaObjectSerializer class methodsFor: 'creation'!
new: anInteger

	^super new optimumByteArraySize: anInteger
! !

!MaObjectSerializer class methodsFor: 'debugging' stamp: 'cmm 5/29/2002 01:16'!
testMaterialize: anObject

	| s1 |

	s1 _ self new serializeGraph: anObject; yourself.
	^self new
		classDefinitionsByteArray: s1 classDefinitionsByteArray;
		materializeGraph: s1 byteArray copy! !


!MaOidCalculator class methodsFor: 'accessing' stamp: 'cmm 7/16/2002 00:25'!
baseLoid
	"Add 1000 for possible future need of reserved loids.  Hey, no added
	complexity here, and there's no shortage of loids.  Even if you can
	reserve one every millisecond, our Sun may still nova before you run out.."

	self maMarked: 'performance'.  "constant value, calculated over and over.."
	^16r0001000000000000 + 1000
! !

!MaOidCalculator class methodsFor: 'accessing'!
newOidMinimum

	^self startOfNonIntegerSpecialObjectsObjectSpace + self numberOfNonIntegerSpecialObjects
! !

!MaOidCalculator class methodsFor: 'accessing' stamp: 'cmm 7/16/2002 19:43'!
objectWithOid: anInteger ifNone: aBlock

	anInteger < self numberOfOptimizedIntegers ifTrue: [ ^self integerFromOid: anInteger ].
	anInteger = self oidForNil ifTrue: [ ^nil ].
	anInteger = self oidForFalse ifTrue: [ ^false ].
	anInteger = self oidForTrue ifTrue: [ ^true ].
	anInteger = self oidForMetaclass ifTrue: [ ^Class ].
	(anInteger
		between: self firstCharacterOid
		and: self lastCharacterOid)
			ifTrue:
				[ ^Character value: anInteger - self startOfNonIntegerSpecialObjectsObjectSpace ].
	^aBlock value
 ! !

!MaOidCalculator class methodsFor: 'private accessing'!
firstCharacterOid

	^self startOfNonIntegerSpecialObjectsObjectSpace
! !

!MaOidCalculator class methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 19:42'!
lastCharacterOid

	"^self firstCharacterOid + 65535"   "DBCS"
	^18446462598732906495! !

!MaOidCalculator class methodsFor: 'private accessing'!
numberOfNonIntegerSpecialObjects
	"Non-integer special objects are Characters 0 - 65535, nil, true, false,
	MaStorageForClass plus some extra room for future possible additions.
	See class comment for a full map."

	^66000
! !

!MaOidCalculator class methodsFor: 'private accessing'!
startOfNonIntegerSpecialObjectsObjectSpace
	"'Special-objects' are the Character set, nil, true, false, MaStorageForClass,
	String, Symbol, Array and Set.  Additionally, all new, non-persistent objects
	are stored temporarily in this objectSpace, giving them an oid greater than this."

	^16rFFFF000000000000
! !

!MaOidCalculator class methodsFor: 'accessing - integers'!
integerFromOid: oidInteger

	^oidInteger + self smallestOptimizedInteger
! !

!MaOidCalculator class methodsFor: 'accessing - integers' stamp: 'cmm 2/14/2002 00:51'!
oidForCharacter: aCharacter

	^self startOfNonIntegerSpecialObjectsObjectSpace + aCharacter asciiValue
! !

!MaOidCalculator class methodsFor: 'accessing - integers' stamp: 'cmm 7/16/2002 19:38'!
oidForFalse

	"^self startOfNonIntegerSpecialObjectsObjectSpace + 65538"
	^18446462598732906498! !

!MaOidCalculator class methodsFor: 'accessing - integers'!
oidForInteger: anInteger

	^anInteger - self smallestOptimizedInteger
! !

!MaOidCalculator class methodsFor: 'accessing - integers' stamp: 'cmm 7/16/2002 19:39'!
oidForMetaclass

	"^self startOfNonIntegerSpecialObjectsObjectSpace + 65539"
	^ 18446462598732906499! !

!MaOidCalculator class methodsFor: 'accessing - integers' stamp: 'cmm 7/16/2002 19:38'!
oidForNil

	"^self startOfNonIntegerSpecialObjectsObjectSpace + 65536"
	^ 18446462598732906496  "<- code above evaluates to this constant."
! !

!MaOidCalculator class methodsFor: 'accessing - integers' stamp: 'cmm 7/16/2002 19:39'!
oidForTrue

	"^self startOfNonIntegerSpecialObjectsObjectSpace + 65537"
	 ^18446462598732906497! !

!MaOidCalculator class methodsFor: 'private testing'!
isOidForOptimizedInteger: oidInteger

	^oidInteger
		between: 0
		and: self numberOfOptimizedIntegers - 1
! !

!MaOidCalculator class methodsFor: 'private testing'!
isOidForSpecialObject: oidInteger

	^oidInteger
		between: self startOfNonIntegerSpecialObjectsObjectSpace
		and: self newOidMinimum - 1
! !

!MaOidCalculator class methodsFor: 'testing'!
isOidForOptimizedObject: oidInteger
	"Answer whether oidInteger is an oid for anObject which will never require its
	own buffer.  These include optimized Integers, nil, true, false, and all Characters as
	well as the four special class objects (Array, Set, String, Symbol and
	MaStorageForClass."

	^(self isOidForOptimizedInteger: oidInteger) or: [ self isOidForSpecialObject: oidInteger ]
! !

!MaOidCalculator class methodsFor: 'testing'!
isOptimizedInteger: anInteger

	^anInteger
		between: self smallestOptimizedInteger
		and: self largestOptimizedInteger
! !

!MaOidCalculator class methodsFor: 'private accessing - integers' stamp: 'cmm 7/16/2002 00:26'!
largestOptimizedInteger

self maMarked: 'performance'.  "constant value, calculated over and over.."

	^(self numberOfOptimizedIntegers / 2) - 1
! !

!MaOidCalculator class methodsFor: 'private accessing - integers'!
numberOfOptimizedIntegers

	^16r0001000000000000
! !

!MaOidCalculator class methodsFor: 'private accessing - integers' stamp: 'cmm 7/16/2002 19:37'!
smallestOptimizedInteger

	"^0 - (self numberOfOptimizedIntegers / 2)"
	^ -140737488355328  "code above, evaluates to this constant.  performance enhancement."! !


!MaSerializedGraphBuffer class methodsFor: 'private accessing'!
headerSize

	^4
! !

!MaSerializedGraphBuffer class methodsFor: 'creation'!
new: anInteger

	^self new resetByteArray: (ByteArray new: anInteger)
! !


!MaStorageForGlobal class methodsFor: 'creation'!
globalName: aSymbol

	^self new globalName: aSymbol
! !


!MaStorageForClass class methodsFor: 'creation'!
class: aClass id: anInteger

	^self
		className: aClass name
		id: anInteger
! !

!MaStorageForClass class methodsFor: 'creation'!
className: aSymbol id: anInteger

	^self new
		className: aSymbol;
		id: anInteger
! !


!MaUpgradeableObject class methodsFor: 'accessing' stamp: 'cmm 3/10/2002 17:04'!
defaultUpgradeBlock

	^[ :oldObject :newClass | | upgrade |
		upgrade _
			oldObject indexedSize > 0
				ifTrue:
					[ newClass basicNew: oldObject indexedSize ]
				ifFalse:
					[ newClass basicNew ].
		(oldObject definition maAllInstVarNames intersection: newClass maAllInstVarNames) do:
			[ :each |
			upgrade
				maInstVarNamed: each
				put: (oldObject maInstVarNamed: each) ].
		1
			to: oldObject indexedSize
			do:
				[ :index |
				upgrade
					maInstVarAt: upgrade namedInstSize + index
					put: (oldObject maInstVarAt: oldObject namedInstSize + index) ].
		upgrade ]
! !

!MaUpgradeableObject class methodsFor: 'creation'!
definition: aMaStorageForClass

	^self new definition: aMaStorageForClass
! !


!OrderedCollection methodsFor: 'accessing' stamp: 'cmm 1/24/2002 15:04'!
maDefaultGrowthSize

	^array size
! !

!OrderedCollection methodsFor: 'building' stamp: 'cmm 5/1/2002 22:53'!
maPopulateUsing: aMaObjectSerializer

	1
		to: self size
		do:
			[ :index |
			self
				at: index
				put: (
					aMaObjectSerializer
						objectWithOid: (self at: index)
						ifAbsent:
							[ MaObjectSerializationSoftwareError signal:
								'In Collection>>maPopulateUsing:, DefaultReadStrategy should have prevented need for proxy.  We don''t support automatic rehashing.' ]) ]
! !


!ProcessorScheduler methodsFor: 'actions' stamp: 'cmm 2/20/2002 01:15'!
maPopulateUsing: aMaObjectSerializer
	"Nothing to do for this class.."
! !

!ProcessorScheduler methodsFor: 'actions' stamp: 'cmm 2/20/2002 01:15'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeByteObjectBuffer
! !

!ProcessorScheduler methodsFor: 'testing' stamp: 'cmm 2/19/2002 22:47'!
maIsImmutableInBuffer

	^true
! !

!ProcessorScheduler methodsFor: 'converting' stamp: 'cmm 2/20/2002 01:15'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^self maEmptyString
! !


!ProcessorScheduler class methodsFor: 'object serialization' stamp: 'cmm 2/20/2002 01:14'!
maMaterializeFrom: aMaByteObjectBuffer

	^Processor
! !


!Set methodsFor: 'accessing' stamp: 'cmm 1/24/2002 15:08'!
maDefaultGrowthSize

	^array size * 3 // 4
! !


!Dictionary methodsFor: 'private actions' stamp: 'cmm 1/24/2002 15:45'!
maPopulateUsing: aMaObjectSerializer

	| transformer oidKeys oidValues |

	self isEmpty ifTrue: [ ^self ].
	transformer _
		[ :object |
			(aMaObjectSerializer oidManager
				objectWithOid: object
				ifAbsent: [ aMaObjectSerializer proxyFor: object ]) ].
	oidKeys _ OrderedCollection new: self size.
	oidValues _ OrderedCollection new: self size.
	self
		keysAndValuesRemove:
			[ :eachKey :eachValue |
			oidKeys add: eachKey.
			oidValues add: eachValue.
			true ].
	oidKeys
		with: oidValues
		do:
			[ :eachKey :eachValue |
			self
				at: (transformer value: eachKey)
				put: (transformer value: eachValue) ]
! !

!Dictionary methodsFor: 'private actions'!
maStreamInto: aMaNormalObjectBuffer for: aMaObjectSerializer
	"Put the receivers instance variables into aMaNormalObjectBuffer as they fit."

	| index |

	index _ 1.
	self keysAndValuesDo:
		[ :eachKey :eachValue |
		[ :obj |
			aMaNormalObjectBuffer
				maInstVarAt: index
				put: (aMaObjectSerializer oidFor: obj).
			index _ index + 1 ]
				value: eachKey;
				value: eachValue ]
! !

!Dictionary methodsFor: 'private accessing'!
maBufferInstSize

	^self size * 2
! !

!Dictionary methodsFor: 'private accessing' stamp: 'cmm 1/24/2002 15:19'!
maDefaultGrowthSize

	^super maDefaultGrowthSize * 2  "key value pairs"
! !


!Dictionary class methodsFor: 'creation'!
maMaterializeFrom: aMaNormalObjectBuffer

	| skeleton |

	skeleton _ self new: aMaNormalObjectBuffer physicalInstSize / 2. "key + value"
	1
		to: aMaNormalObjectBuffer logicalInstSize
		by: 2
		do:
			[ :index |
			skeleton
				at: (aMaNormalObjectBuffer maInstVarAt: index)
				put: (aMaNormalObjectBuffer maInstVarAt: index + 1) ].
	^skeleton
! !


!SmallInteger methodsFor: 'testing'!
maRequiresOwnBuffer

	^false
! !


!SmallInteger class methodsFor: 'creation'!
maMaterializeFrom: aMaByteObjectBuffer

	^MaOidCalculator
		objectWithOid: aMaByteObjectBuffer oid
		ifNone: [ self error: aMaByteObjectBuffer , ' is not a buffer for a SmallInteger.' ]
! !


!SortedCollection methodsFor: 'actions'!
maPopulateUsing: aMaObjectSerializer

	| tempColl |

	self isEmpty ifTrue: [ ^self ]. "performance, avoid the copy if possible.."
	tempColl _ self asArray.
	self removeAll: tempColl.
	tempColl do:
		[ :each |
		self add: (
			aMaObjectSerializer
				objectWithOid: each
				ifAbsent: [ aMaObjectSerializer proxyFor: each ]) ]
! !


!String methodsFor: 'accessing'!
maInstVarStorageSize

	^self size
! !

!String methodsFor: 'accessing'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeByteObjectBuffer
! !

!String methodsFor: 'testing'!
maIsImmutableInBuffer
	^true! !

!String methodsFor: 'building'!
maPopulateUsing: aMaObjectSerializer
	"Nothing to do for this class.."
! !

!String methodsFor: 'actions'!
maStreamInto: aMaByteObjectBuffer for: aMaObjectSerializer

	aMaByteObjectBuffer storeDirectly: self
! !


!String class methodsFor: 'creation'!
maMaterializeFrom: aMaByteObjectBuffer

	^aMaByteObjectBuffer asString
! !


!Symbol class methodsFor: 'creation'!
maMaterializeFrom: aMaByteObjectBuffer

	^(super maMaterializeFrom: aMaByteObjectBuffer) asSymbol
! !


!SystemDictionary methodsFor: 'actions' stamp: 'cmm 2/20/2002 01:05'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeByteObjectBuffer
! !

!SystemDictionary methodsFor: 'converting' stamp: 'cmm 2/20/2002 01:03'!
maAsStorageObject
	"We don't even need to store the name of the global.  It's class
	gives it away."

	^self maEmptyString
! !

!SystemDictionary methodsFor: 'testing' stamp: 'cmm 2/19/2002 22:57'!
maIsImmutableInBuffer

	^true
! !

!SystemDictionary methodsFor: 'building' stamp: 'cmm 2/20/2002 01:04'!
maPopulateUsing: aMaObjectSerializer
	"Nothing to do for this class.."
! !


!SystemDictionary class methodsFor: 'object serialization' stamp: 'cmm 2/20/2002 01:09'!
maMaterializeFrom: aMaByteObjectBuffer

	^Smalltalk
! !


!TranscriptStream methodsFor: 'testing' stamp: 'cmm 2/19/2002 22:47'!
maIsImmutableInBuffer

	^true
! !

!TranscriptStream methodsFor: 'actions' stamp: 'cmm 2/20/2002 01:11'!
maPopulateUsing: aMaObjectSerializer
	"Nothing to do for this class.."
! !

!TranscriptStream methodsFor: 'actions' stamp: 'cmm 2/20/2002 01:13'!
maSelectPreMadeObjectBufferFrom: aMaObjectSerializer

	^aMaObjectSerializer preMadeByteObjectBuffer
! !

!TranscriptStream methodsFor: 'converting' stamp: 'cmm 2/20/2002 01:10'!
maAsStorageObject
	"We don't even need to store the name of this global.  It's class
	gives it away."

	^self maEmptyString
! !


!TranscriptStream class methodsFor: 'object serialization' stamp: 'cmm 2/20/2002 01:10'!
maMaterializeFrom: aByteObjectBuffer

	^Transcript
! !


!True methodsFor: 'accessing'!
maOid

	^MaOidCalculator oidForTrue
! !


!UndefinedObject methodsFor: 'testing'!
maIsImmutableInBuffer
	^true! !

!UndefinedObject methodsFor: 'testing'!
maRequiresOwnBuffer

	^false
! !

!UndefinedObject methodsFor: 'creation'!
maMaterializeFrom: aMaByteObjectBuffer

	^self fromString: aMaByteObjectBuffer asString
! !

!UndefinedObject methodsFor: 'accessing'!
maOid
	^MaOidCalculator oidForNil! !


!MaFloatBuffer class reorganize!
('required overrides' headerSize)
('accessing' physicalSize)
!

MaDefaultClassIdManager initialize!
MaAbstractObjectBuffer initialize!

!MaAbstractObjectBuffer class reorganize!
('accessing' addressSize bufferClasses bufferPositionOfBufferType)
('creation' byteArray:startPos: createFromByteArray:startPos:)
('initializing' initialize)
('required overrides' headerSize)
('private accessing' bufferClassFor:startPos: bufferPositionOfPhysicalSize)
!


!MaFloatBuffer reorganize!
('accessing' bufferPositionOfFloat float float: physicalDataSizeNeededFor: populateHeaderFor:storageObject:using: skeletonObjectUsing:)
('private' bufferPositionOfBytesToStore)
('printing' appendGraphUsing:currentDepth:minDepth:with:forRepository: printOn:)
!

"Postscript:
"
MaAbstractObjectBuffer initialize.
MaDefaultClassIdManager initialize.
!

