'From Squeak 3.2 of 11 July 2002 [latest update: #4917] on 2 August 2002 at 12:43:30 am'!
"Change Set:		MagmaServer
Date:			28 July 2002
Author:			Chris Muller

This is the change set necessary to host a Magma repository."!

MaObject subclass: #MaHashIndexRecord
	instanceVariableNames: 'recordNumber lowKey highKey keySize byteArray numberOfEntries entrySize canHoldDuplicateKeys '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!

!MaHashIndexRecord commentStamp: '<historical>' prior: 0!
keySize is in bits.
entrySize is in bytes.
!

MaObject subclass: #MaHashIndexRecordFactory
	instanceVariableNames: 'index recordNumbersPath entryIndexPath byteArrayIndexPath recordPath preMadeNewRecord '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!
MaObject subclass: #MaLargeCollectionManager
	instanceVariableNames: 'collection memberIndex indexes indexesByAttribute repository oidOfIndexesCollection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!
MaObject subclass: #MaLargeCollectionOfIntegers
	instanceVariableNames: 'file byteSize byteArray '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!
MaObject subclass: #MaMagnitudeIndex
	instanceVariableNames: 'file keySize nextRecordNumber '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!

!MaMagnitudeIndex commentStamp: '<historical>' prior: 0!
keySize in bits.!

MaMagnitudeIndex subclass: #MaHashIndex
	instanceVariableNames: 'hashRecordSize record preMadeAnswerArrays recordFactory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!
MaObject subclass: #MaObjectFiler
	instanceVariableNames: 'filename file memory preMadeObjectBuffer filePositionIndex usedByteArrays '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!
MaObject subclass: #MaObjectRepository
	instanceVariableNames: 'transactionLog filer repositoryController largeCollectionManagers nextLoid filename '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!

!MaObjectRepository commentStamp: '<historical>' prior: 0!
Maps the name of each ObjectSpace to a url, and to a two-byte key
(used as the first part of the 64-bit oids).
!

MaObject subclass: #MaTransactionLog
	instanceVariableNames: 'entries '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!

!MaTransactionLog commentStamp: '<historical>' prior: 0!
This class resides on the server.
!

MaObject subclass: #MaTransactionLogEntry
	instanceVariableNames: 'result challengingEntries '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!
MaTransactionLogEntry subclass: #MaCommitLogEntry
	instanceVariableNames: 'committed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server private'!
MaObject subclass: #MagmaRepositoryController
	instanceVariableNames: 'repository definition session serverSerializer isAcceptingConnections isStopped '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server'!
MaObject subclass: #MagmaRepositoryDefinition
	instanceVariableNames: 'memory classesSet classDefinitions maximumNumberOfChallengers allLargeCollections '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma-Server'!

!Exception methodsFor: 'exceptionDescription' stamp: 'cmm 7/8/2002 14:25'!
maAsErrorMessage

	^self class new messageText: self messageText! !


!FileStream methodsFor: 'accessing' stamp: 'cmm 7/15/2002 22:58'!
maRead: someNumber bytesFromPosition: bufferPosition of: aByteArray atFilePosition: filePosition

	^self
		position: filePosition;
		next: someNumber
		into: aByteArray
		startingAt: bufferPosition
! !

!FileStream methodsFor: 'accessing' stamp: 'cmm 7/15/2002 22:58'!
maWrite: numberOfBytes bytesFromPosition: bufferPosition of: byteArray atFilePosition: filePosition

	self position: filePosition.
	self
		next: numberOfBytes
		putAll: byteArray
		startingAt: bufferPosition.
	self maMarked: 'performance'.  "is flushing too slow?"
	"self flush"
! !


!MaAbstractObjectBuffer methodsFor: 'accessing'!
loid

	^self oid
! !

!MaAbstractObjectBuffer methodsFor: 'accessing' stamp: 'cmm 7/13/2002 16:23'!
numberOfBytesToStore
	"Answer the number of bytes that should be stored for this buffer.  This is used by Magma, which doesn't need to store the oid since that is kept in the oid table."

	^self physicalSize - MaAbstractObjectBuffer addressSize
! !

!MaAbstractObjectBuffer methodsFor: 'building'!
appendGraphUsing: aMaReadStrategy forRepository: aMaObjectRepository

	self
		appendGraphUsing: aMaReadStrategy
		currentDepth: 1
		minDepth: aMaReadStrategy minimumDepth
		with: Set new
		forRepository: aMaObjectRepository
! !

!MaAbstractObjectBuffer methodsFor: 'private accessing'!
bufferPositionOfBytesToStore
	"Default 1-based position of the byte within each byteArray that we start storing
	to disk at."

	^1
! !

!MaAbstractObjectBuffer methodsFor: 'actions'!
appendGraphNode: loid using: aMaReadStrategy currentDepth: anInteger minDepth: minDepth with: alreadyAppendedSet forRepository: aMaObjectRepository

	| buffer |

	(alreadyAppendedSet includes: loid) ifTrue: [ ^self ].
	alreadyAppendedSet add: loid.
	buffer _ aMaObjectRepository appendObjectWithLoid: loid.
	buffer
		appendGraphUsing: aMaReadStrategy
		currentDepth: anInteger + 1
		minDepth: minDepth
		with: alreadyAppendedSet
		forRepository: aMaObjectRepository
! !

!MaAbstractObjectBuffer methodsFor: 'converting' stamp: 'cmm 7/10/2002 20:02'!
asSentientBuffer
	"Answer the newwwwwww meeee!!  That's right!!  I've been injected
	with the ByteArray-of-truth and now know what kind of buffer
	I always wondered I was going to grow up to be."

	^self class
		createFromByteArray: byteArray
		startPos: startPos
! !


!MaFloatBuffer methodsFor: 'private' stamp: 'cmm 7/13/2002 16:57'!
bufferPositionOfBytesToStore

	^9! !

!MaFloatBuffer methodsFor: 'printing' stamp: 'cmm 7/10/2002 20:52'!
appendGraphUsing: aMaReadStrategy currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet forRepository: aMaObjectRepository

	"nothing to do for a float."! !


!MaHashIndexRecord methodsFor: 'accessing'!
bufferSize

	^byteArray size
! !

!MaHashIndexRecord methodsFor: 'accessing'!
byteArray

	^byteArray! !

!MaHashIndexRecord methodsFor: 'accessing'!
byteArrayIndexContainingGlobalIndex: anInteger base: baseInteger

	| count |

	count _ baseInteger.
	self
		byteArrayIndexesFrom: 0
		do:
			[ :each |
			count _ count + (self numberOfChildrenAtByteArrayIndex: each).
			(count > anInteger and: [ self hasEntryAtByteArrayIndex: each ]) ifTrue: [ ^each ] ].
	^nil
! !

!MaHashIndexRecord methodsFor: 'accessing'!
entryIndexFor: keyInteger
	"see method comment."

	^((keyInteger - lowKey) * numberOfEntries) // (highKey + 1 - lowKey)
! !

!MaHashIndexRecord methodsFor: 'accessing'!
entryIndexForBax: anInteger
	"Bax means 'byteArrayIndex'."

	^(anInteger - self headerSize) / entrySize
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2002 20:26'!
highKey

	^byteArray
		uint: keySize
		at: keySize / 8
! !

!MaHashIndexRecord methodsFor: 'accessing'!
highestByteArrayIndexFor: keyInteger
	"This will vary from the lowestByteArrayIndexFor: keyInteger only when 
	the receiver canHoldDuplicateKeys."

	^self byteArrayIndexFor: (self highestEntryIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'accessing'!
highestKeyAtIndex: anInteger

	^canHoldDuplicateKeys
		ifTrue:
			[ self lowestKeyAtIndex: (
				numberOfEntries \\ (anInteger + 1) = 0
					ifTrue:
						[ anInteger ]
					ifFalse:
						[ anInteger + 1 ]) ]
		ifFalse:
			[ (self lowestKeyAtIndex: anInteger + 1) - 1 ]
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2002 20:26'!
keyAtByteArrayIndex: anInteger

	^byteArray
		uint: keySize
		at: anInteger + self keyEntryOffset
! !

!MaHashIndexRecord methodsFor: 'accessing'!
keyAtEntryIndex: anInteger

	^self keyAtByteArrayIndex: (self byteArrayIndexFor: anInteger)
! !

!MaHashIndexRecord methodsFor: 'accessing'!
keyAtHighestSlotFor: keyInteger

	^self keyAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2002 20:27'!
lowKey

	^byteArray
		uint: keySize
		at: 0
! !

!MaHashIndexRecord methodsFor: 'accessing'!
numberOfChildren

	| total |

	total _ 0.
	self
		byteArrayIndexesFrom: 0
		do: [ :index | total _ total + (self numberOfChildrenAtByteArrayIndex: index) ].
	^total
! !

!MaHashIndexRecord methodsFor: 'accessing'!
numberOfChildrenBefore: keyInteger

	| total lastByteArrayIndex entryIndex |

	total _ 0.
	entryIndex _ self entryIndexFor: keyInteger.
	lastByteArrayIndex _ self byteArrayIndexFor: entryIndex.
	self
		byteArrayIndexesFrom: 0
		to: entryIndex
		do:
			[ :index |
			(canHoldDuplicateKeys not and: [ index = lastByteArrayIndex ])
				ifTrue:
					[ ((self keyAtByteArrayIndex: index) < keyInteger
						and: [ self hasEntryAtByteArrayIndex: index ])
							ifTrue:
								[ total _ total + 1 ] ]
				ifFalse:
					[ total _ total + (self numberOfChildrenAtByteArrayIndex: index) ] ].
	^total
! !

!MaHashIndexRecord methodsFor: 'accessing'!
numberOfChildrenBeforeByteArrayIndex: anInteger

	| total |

	total _ 0.
	self
		byteArrayIndexesFrom: 0
		do:
			[ :each |
			each = anInteger ifTrue: [ ^total ].
			total _ total + (self numberOfChildrenAtByteArrayIndex: each) ]
	"We should never get here.."
! !

!MaHashIndexRecord methodsFor: 'accessing'!
primHighKey

	^highKey
! !

!MaHashIndexRecord methodsFor: 'accessing'!
primLowKey

	^lowKey
! !

!MaHashIndexRecord methodsFor: 'accessing'!
recordNumber

	^recordNumber! !

!MaHashIndexRecord methodsFor: 'accessing' stamp: 'cmm 1/27/2002 20:24'!
recordNumberAtByteArrayIndex: anInteger

	^byteArray 
		uint: 32
		at: anInteger + self recordNumberEntryOffset
! !

!MaHashIndexRecord methodsFor: 'accessing'!
recordNumberCloserTo: keyInteger

	^self recordNumberAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'private printing'!
allNumberOfChildren
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self numberOfChildrenAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'private printing'!
keys
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self keyAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'private printing'!
oids
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self oidAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'private printing'!
recordNumbers
	"This is intended to be used only for printing!!"

	^(self headerSize
		to: byteArray size - 1
		by: entrySize)
			collect: [ :index | self recordNumberAtByteArrayIndex: index ]
! !

!MaHashIndexRecord methodsFor: 'building'!
atKey: keyInteger put: oidInteger
	"The receiver has been verified for some available slot for keyInteger."

	self
		eligibleByteArrayIndexesFor: keyInteger
		do:
			[ :index |
			(self hasSlotAvailableAtByteArrayIndex: index)
				ifTrue:
					[ self
						keyAtByteArrayIndex: index
							put: keyInteger;
						oidAtByteArrayIndex: index
							put: oidInteger.
					^index ] ]
! !

!MaHashIndexRecord methodsFor: 'building'!
beFrom: lowKeyInteger to: highKeyInteger

	lowKey _ lowKeyInteger.
	highKey _ highKeyInteger.
	self
		setCanHoldDuplicateKeys;
		lowKey: lowKeyInteger;
		highKey: highKeyInteger
! !

!MaHashIndexRecord methodsFor: 'building'!
beZoomedInToward: keyInteger from: aMaHashIndexRecord
	"Set the receivers low and highIndex to the correct range that can
	accomodate the index where keyInteger belongs in aMaHashIndexRecord."

	| index |

	index _ aMaHashIndexRecord entryIndexFor: keyInteger.
	self
		beFrom: (aMaHashIndexRecord lowestKeyAtIndex: index)
		to: (aMaHashIndexRecord highestKeyAtIndex: index)
! !

!MaHashIndexRecord methodsFor: 'building'!
clearHighestSlotFor: keyInteger

	self removeEntryAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'building'!
decrementNumberOfChildrenAtByteArrayIndex: anInteger

	| currentNumberOfChildren |

	currentNumberOfChildren _ self numberOfChildrenAtByteArrayIndex: anInteger.
	self
		numberOfChildrenAtByteArrayIndex: anInteger
		put: currentNumberOfChildren - 1
! !

!MaHashIndexRecord methodsFor: 'building'!
decrementNumberOfChildrenAtKey: keyInteger

	self decrementNumberOfChildrenAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2002 23:02'!
highKey: anInteger

	^byteArray
		uint: keySize
		at: (keySize / 8)
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'building'!
incrementNumberOfChildrenAtByteArrayIndex: anInteger

	| currentNumberOfChildren |

	currentNumberOfChildren _ self numberOfChildrenAtByteArrayIndex: anInteger.
	self
		numberOfChildrenAtByteArrayIndex: anInteger
		put: currentNumberOfChildren + 1
! !

!MaHashIndexRecord methodsFor: 'building'!
keySize: numberOfBitsInteger numberOfEntries: numberOfEntriesInteger

	keySize _ numberOfBitsInteger.
	numberOfEntries _ numberOfEntriesInteger.
	"Each entry consists of:  oid (at: 0), record number (at: 8), key (at: 12), number of child entries (at: 20)."
	entrySize _ MaAbstractObjectBuffer addressSize + self sizeOfRecordNumber + ((keySize / 8) * 2).
	byteArray _ ByteArray new: self headerSize + (entrySize * numberOfEntriesInteger).
	self clearAllEntries
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2002 23:03'!
lowKey: anInteger

	^byteArray
		uint: keySize
		at: 0
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'building'!
populateFrom: aMaHashIndexRecord

	byteArray
		replaceFrom: 1
		to: byteArray size
		with: aMaHashIndexRecord byteArray.
	recordNumber _ aMaHashIndexRecord recordNumber.
	lowKey _ aMaHashIndexRecord primLowKey.
	highKey _ aMaHashIndexRecord primHighKey.
	self setCanHoldDuplicateKeys
! !

!MaHashIndexRecord methodsFor: 'building' stamp: 'cmm 1/27/2002 22:45'!
readFrom: file atPosition: anInteger

	file
		maRead: self bufferSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: anInteger.
	lowKey _ self lowKey.
	highKey _ self highKey.
	self setCanHoldDuplicateKeys
! !

!MaHashIndexRecord methodsFor: 'building'!
recordNumber: anInteger

	recordNumber _ anInteger
! !

!MaHashIndexRecord methodsFor: 'building'!
recordNumberAtSlotForKey: keyInteger put: recordNumberInteger

	self
		recordNumberAtByteArrayIndex: (self highestByteArrayIndexFor: keyInteger)
		put: recordNumberInteger
! !

!MaHashIndexRecord methodsFor: 'building'!
removeKey: anInteger
	"Remove the first instance of anInteger."

	self
		eligibleByteArrayIndexesFor: anInteger
		do:
			[ :each |
			(self keyAtByteArrayIndex: each) = anInteger
				ifTrue:
					[ ^self removeEntryAtByteArrayIndex: each ] ].
	^nil
! !

!MaHashIndexRecord methodsFor: 'building'!
removeKey: keyInteger withOid: oidInteger

	self
		eligibleByteArrayIndexesFor: keyInteger
		do:
			[ :each |
			((self keyAtByteArrayIndex: each) = keyInteger
				and: [ (self oidAtByteArrayIndex: each) = oidInteger ])
					ifTrue:
						[ ^self removeEntryAtByteArrayIndex: each ] ].
	^nil
! !

!MaHashIndexRecord methodsFor: 'debugging'!
baxMap

	| map |

	map _ OrderedCollection new.
	self
		byteArrayIndexesFrom: 0
		do: [ :each | map add: (self entryIndexForBax: each) -> each ].
	^map asArray
! !

!MaHashIndexRecord methodsFor: 'debugging'!
independentCopy

	^self copyWithAttributes: #('byteArray')
! !

!MaHashIndexRecord methodsFor: 'debugging'!
possibleKeys

	| answer |

	answer _ WriteStream on: (String new: numberOfEntries * 2).
	0
		to: numberOfEntries - 1
		do:
			[ :index | | low high |
			low _ self lowestKeyAtIndex: index.
			high _ self highestKeyAtIndex: index.
			answer nextPutAll: ' | '.
			low = high
				ifTrue:
					[ answer maPrint: low ]
				ifFalse:
					[ answer
						maPrint: low;
						maPrint: '..';
						maPrint: high ] ].
	^answer contents
! !

!MaHashIndexRecord methodsFor: 'actions'!
byteArrayIndexesFrom: startingEntryIndex do: oneArgBlock

	self
		byteArrayIndexesFrom: startingEntryIndex
		to: numberOfEntries - 1
		do: oneArgBlock
! !

!MaHashIndexRecord methodsFor: 'actions'!
byteArrayIndexesFrom: startingEntryIndex to: endingEntryIndex do: oneArgBlock

	(self byteArrayIndexFor: startingEntryIndex)
		to: (self byteArrayIndexFor: endingEntryIndex)
		by: entrySize
		do: oneArgBlock
! !

!MaHashIndexRecord methodsFor: 'actions'!
eligibleByteArrayIndexesFor: keyInteger do: oneArgBlock

	(self lowestByteArrayIndexFor: keyInteger)
		to: (self highestByteArrayIndexFor: keyInteger)
		by: entrySize
		do: [ :index | oneArgBlock value: index ]
! !

!MaHashIndexRecord methodsFor: 'actions' stamp: 'cmm 1/27/2002 22:46'!
writeTo: file atPosition: anInteger

	file
		maWrite: self bufferSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: anInteger
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
byteArrayIndexFor: entryIndex

	^entryIndex * entrySize + self headerSize
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
headerSize
	"Low and high keys.
	^(keySize / 8) * 2  simplified to / 4 for max performance."

	^keySize / 4
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
highestEntryIndexFor: keyInteger

	^canHoldDuplicateKeys
		ifTrue:
			[ | candidateIndex |
			"Depending on how the record divides up, the entryIndex
			of the next higher key may be the highest index for keyInteger.
			Sometimes, it divides evenly and the next higher index won't
			accomodate keyInteger."
			candidateIndex _ self entryIndexFor: keyInteger + 1.
			(self lowestKeyAtIndex: candidateIndex) = keyInteger
				ifTrue:
					[ candidateIndex ]
				ifFalse:
					[ candidateIndex - 1 ] ]
		ifFalse:
			[ self entryIndexFor: keyInteger ]
! !

!MaHashIndexRecord methodsFor: 'private accessing' stamp: 'cmm 7/15/2002 23:35'!
keyEntryOffset

	^self recordNumberEntryOffset + self sizeOfRecordNumber
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
lowestByteArrayIndexFor: keyInteger

	^self byteArrayIndexFor: (self entryIndexFor: keyInteger)
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
lowestKeyAtIndex: entryIndex
	"Answer the lowest-possible key that can be stored at entryIndex."

	| answer |

	answer _ lowKey + ((entryIndex * (highKey + 1 - lowKey)) // numberOfEntries).
	^(canHoldDuplicateKeys or: [ (self entryIndexFor: answer) = entryIndex ])
		ifTrue:
			[ answer ]
		ifFalse:
			[ answer + 1 ]
! !

!MaHashIndexRecord methodsFor: 'private accessing' stamp: 'cmm 1/27/2002 20:27'!
numberOfChildrenAtByteArrayIndex: anInteger

	^byteArray
		uint: keySize
		at: anInteger + self numberOfChildrenEntryOffset
! !

!MaHashIndexRecord methodsFor: 'private accessing' stamp: 'cmm 7/15/2002 23:37'!
numberOfChildrenEntryOffset

	self maMarked: 'performance'. "This is a constant, unchanging value that is calculated over and over.."
	^self keyEntryOffset + (keySize / 8)
! !

!MaHashIndexRecord methodsFor: 'private accessing' stamp: 'cmm 1/27/2002 20:27'!
oidAtByteArrayIndex: anInteger

	^byteArray 
		uint: 64
		at: anInteger + self oidEntryOffset
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
oidEntryOffset

	^0
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
recordNumberEntryOffset

	^MaAbstractObjectBuffer addressSize
! !

!MaHashIndexRecord methodsFor: 'private accessing'!
sizeOfRecordNumber

	^self class sizeOfRecordNumber
! !

!MaHashIndexRecord methodsFor: 'testing'!
canAdd: keyInteger

	self
		eligibleByteArrayIndexesFor: keyInteger
		do: [ :index | (self hasSlotAvailableAtByteArrayIndex: index) ifTrue: [ ^true ] ].
	^false
! !

!MaHashIndexRecord methodsFor: 'testing'!
hasChildAtByteArrayIndex: byteArrayIndex

	^(self recordNumberAtByteArrayIndex: byteArrayIndex) > 0
! !

!MaHashIndexRecord methodsFor: 'testing'!
hasEntryAtByteArrayIndex: anInteger

	^(self hasSlotAvailableAtByteArrayIndex: anInteger) not
! !

!MaHashIndexRecord methodsFor: 'testing'!
hasEntryForKey: keyInteger
	"Answer whether keyInteger resides in an entry of the receiver."

	self
		eligibleByteArrayIndexesFor: keyInteger
		do:
			[ :index |
			((self hasEntryAtByteArrayIndex: index)
				and: [ (self keyAtByteArrayIndex: index) = keyInteger ])
					ifTrue:
						[ ^true ] ].
	^false
! !

!MaHashIndexRecord methodsFor: 'testing'!
hasSlotAvailableAtByteArrayIndex: anInteger

	^(self oidAtByteArrayIndex: anInteger) = MaOidCalculator specialValueForUnusedHashIndexEntry
! !

!MaHashIndexRecord methodsFor: 'private testing'!
canHoldDuplicateKeys

	^canHoldDuplicateKeys! !

!MaHashIndexRecord methodsFor: 'private testing'!
setCanHoldDuplicateKeys

	canHoldDuplicateKeys _ (highKey - lowKey + 1) < numberOfEntries
! !

!MaHashIndexRecord methodsFor: 'private building'!
clearAllEntries

	self
		byteArrayIndexesFrom: 0
		do: [ :each | self removeEntryAtByteArrayIndex: each ]
! !

!MaHashIndexRecord methodsFor: 'private building' stamp: 'cmm 1/27/2002 23:02'!
keyAtByteArrayIndex: index put: anInteger

	^byteArray
		uint: keySize
		at: index + self keyEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'private building' stamp: 'cmm 1/27/2002 23:03'!
numberOfChildrenAtByteArrayIndex: index put: anInteger

	^byteArray
		uint: keySize
		at: index + self numberOfChildrenEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'private building' stamp: 'cmm 1/27/2002 23:03'!
oidAtByteArrayIndex: index put: anInteger

	^byteArray
		uint: 64
		at: index + self oidEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'private building' stamp: 'cmm 1/27/2002 20:25'!
recordNumberAtByteArrayIndex: index put: anInteger

	^byteArray
		uint: 32
		at: index + self recordNumberEntryOffset
		put: anInteger
! !

!MaHashIndexRecord methodsFor: 'private building'!
removeEntryAtByteArrayIndex: anInteger

	| answer |

	answer _ self oidAtByteArrayIndex: anInteger.
	self
		oidAtByteArrayIndex: anInteger
		put: MaOidCalculator specialValueForUnusedHashIndexEntry.
	^answer
! !

!MaHashIndexRecord methodsFor: 'private debugging' stamp: 'cmm 1/30/2002 17:37'!
isValid
	"Verify that the ranges calculated by the zooming for each index
	are the same keys that were put in those indexes.   Also verify that
	they are the exact boundaries of those ranges (i.e., the next higher
	key makes it go to the next index)."

| ranges |
ranges _ (1 to: 100) collect:
	[ :index |
	(self lowestKeyAtIndex: index) -> (self highestKeyAtIndex: index) ].
^(1 to: 100) maConform:
	[ :index |
	| eachLowestKey eachHighestKey |
	eachLowestKey _ (ranges at: index) key.
	eachHighestKey _ (ranges at: index) value.
	eachLowestKey = eachHighestKey
		ifTrue:
			[ (self entryIndexFor: eachLowestKey) = index ]
		ifFalse:
			[ (self entryIndexFor: eachLowestKey - 1) = (index - 1) &
				( (self entryIndexFor: eachLowestKey) = index ) &
				( (self entryIndexFor: eachHighestKey) = index ) &
				( (self entryIndexFor: eachHighestKey + 1) = (index + 1) ) ] ]

! !

!MaHashIndexRecord methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:24'!
maPrintAbbreviatedOn: aStream

	self
		maPrintAttributes: #(
			recordNumber lowKey highKey canHoldDuplicateKeys possibleKeys keys recordNumbers oids
			allNumberOfChildren)
		on: aStream
! !


!MaHashIndexRecord class methodsFor: 'debugging'!
collectionZoomedToward: keyInteger

	| r previousRecord answer |

	answer _ OrderedCollection new.
	r _
		MaHashIndexRecord
			keySize: 64
			numberOfEntries: 100.
	r
		beFrom: 0
		to: (2 raisedTo: 64) - 1.
	answer add: r.
	previousRecord _ r.
	12 timesRepeat:
		[ answer add: (
			(MaHashIndexRecord
				keySize: 64
				numberOfEntries: 100)
					beZoomedInToward: keyInteger
					from: previousRecord).
		previousRecord _ answer last ].
	^answer
! !

!MaHashIndexRecord class methodsFor: 'creation'!
keySize: numberOfBits numberOfEntries: entrySizeInteger

	^self new
		keySize: numberOfBits
		numberOfEntries: entrySizeInteger
! !

!MaHashIndexRecord class methodsFor: 'private accessing'!
sizeOfRecordNumber

	^4
! !


!MaHashIndexRecordFactory methodsFor: 'private initializing'!
createPreMadeNewRecord

	preMadeNewRecord :=
		MaHashIndexRecord
			keySize: index keySize
			numberOfEntries: index hashRecordSize
! !

!MaHashIndexRecordFactory methodsFor: 'private initializing'!
initialize

	super initialize.
	recordNumbersPath := OrderedCollection new: self maxDepth.
	entryIndexPath := OrderedCollection new: self maxDepth.
	byteArrayIndexPath := OrderedCollection new: self maxDepth.
	recordPath := Array new: self maxDepth
! !

!MaHashIndexRecordFactory methodsFor: 'private initializing'!
initializeRecordPathRecords

	1
		to: self maxDepth
		do:
			[ :x |
			recordPath
				at: x
				put: (
					MaHashIndexRecord
						keySize: index keySize
						numberOfEntries: index hashRecordSize) ]
! !

!MaHashIndexRecordFactory methodsFor: 'accessing'!
entryIndexAtLevel: anInteger

	^entryIndexPath at: anInteger
! !

!MaHashIndexRecordFactory methodsFor: 'accessing'!
preMadeNewRecord

	^preMadeNewRecord! !

!MaHashIndexRecordFactory methodsFor: 'accessing'!
recordForLevel: levelInteger

	^levelInteger > recordPath size
		ifTrue:
			[ recordPath first independentCopy ]
		ifFalse:
			[ recordPath at: levelInteger ]
! !

!MaHashIndexRecordFactory methodsFor: 'accessing'!
recordNumberAtLevel: anInteger

	^recordNumbersPath at: anInteger
! !

!MaHashIndexRecordFactory methodsFor: 'private building'!
index: aMaHashIndex

	index := aMaHashIndex.
	self
		createPreMadeNewRecord;
		initializeRecordPathRecords
! !

!MaHashIndexRecordFactory methodsFor: 'private accessing'!
maxDepth

	^50
! !

!MaHashIndexRecordFactory methodsFor: 'building'!
put: aMaHashIndexRecord atLevel: levelInteger byteArrayIndex: indexInteger

	levelInteger > recordNumbersPath size
		ifTrue:
			[ recordNumbersPath add: aMaHashIndexRecord recordNumber.
			byteArrayIndexPath add: indexInteger.
			entryIndexPath add: (aMaHashIndexRecord entryIndexForBax: indexInteger) ]
		ifFalse:
			[ recordNumbersPath
				at: levelInteger
				put: aMaHashIndexRecord recordNumber.
			byteArrayIndexPath
				at: levelInteger
				put: indexInteger.
			entryIndexPath
				at: levelInteger
				put: (aMaHashIndexRecord entryIndexForBax: indexInteger) ].
	levelInteger > recordPath size
		ifFalse:
			[ (recordPath at: levelInteger) populateFrom: aMaHashIndexRecord ]
! !


!MaHashIndexRecordFactory class methodsFor: 'creation'!
index: aMaHashIndex

	^self new index: aMaHashIndex
! !


!MaIntervalCollection methodsFor: 'accessing'!
intervals
	"This needed only for the MaPersistentObjectsApp.  Normally, we should never
	need this, but to efficiently update the memory on disk, it is best to have direct
	access to this."

	^intervals
! !


!MaLargeCollectionManager methodsFor: 'actions'!
close

	memberIndex close.
	indexes do: [ :each | each close ]
! !

!MaLargeCollectionManager methodsFor: 'actions'!
open

	memberIndex := self openIndex: (repository collectionFilenameFor: self collectionLoid).
	indexes :=
		collection indexes collect: [ :each | self openIndex: (self fullFileNameStringFor: each) ].
	^self
! !

!MaLargeCollectionManager methodsFor: 'actions'!
process: aMaCollectionChanges recordResultsIn: aMaCommitResult

	self
		processAddedIndexesIn: aMaCollectionChanges;
		processRemovedIndexesIn: aMaCollectionChanges;
		processAddsIn: aMaCollectionChanges
			using: aMaCommitResult;
		processRemovesIn: aMaCollectionChanges;
		processChangedIndexValuesIn: aMaCollectionChanges;
		processAddNewIndexValuesIn: aMaCollectionChanges
! !

!MaLargeCollectionManager methodsFor: 'private building'!
collection: aMagmaCollection

	collection := aMagmaCollection
! !

!MaLargeCollectionManager methodsFor: 'private building'!
oidOfIndexesCollection: anInteger

	oidOfIndexesCollection := anInteger
! !

!MaLargeCollectionManager methodsFor: 'private building'!
openIndex: aString

	^MaHashIndex open: aString
! !

!MaLargeCollectionManager methodsFor: 'private building'!
repository: aMaObjectRepository

	repository := aMaObjectRepository
! !

!MaLargeCollectionManager methodsFor: 'private accessing' stamp: 'cmm 3/30/2002 21:22'!
collectionLoid

	^repository session oidFor: collection
! !

!MaLargeCollectionManager methodsFor: 'private accessing'!
filenameComponentFor: aMaIndexDefinition

	^self collectionLoid printString , aMaIndexDefinition uniqueFileIdentifier
! !

!MaLargeCollectionManager methodsFor: 'private accessing'!
fullFileNameStringFor: aMaIndexDefinition

	^(MaFilename new
		path: repository filename path;
		baseComponent: (self filenameComponentFor: aMaIndexDefinition);
		extension: MaHashIndex suggestedFileExtension)
			asString
! !

!MaLargeCollectionManager methodsFor: 'private accessing' stamp: 'cmm 7/3/2002 00:04'!
indexForAttribute: aSymbol

	^self
		indexForAttribute: aSymbol
		ifNone:
			[ MaHardwareError signal:
				'The index for ' , aSymbol ,
					' was not found.  (MaLargeCollectionManager>>#indexForAttribute:).' ]
! !

!MaLargeCollectionManager methodsFor: 'private accessing'!
indexForAttribute: aSymbol ifNone: aBlock

	aSymbol isNil ifTrue: [ ^self memberIndex ].
	^indexesByAttribute
		at: aSymbol
		ifAbsent: aBlock
! !

!MaLargeCollectionManager methodsFor: 'private actions' stamp: 'cmm 3/4/2002 22:52'!
createNewIndex: aMaIndexDefinition

	(MaHashIndex
		create: (self fullFileNameStringFor: aMaIndexDefinition)
		keySize: aMaIndexDefinition keySize
		hashRecordSize: aMaIndexDefinition recordSize) close
! !

!MaLargeCollectionManager methodsFor: 'private actions'!
processAddNewIndexValuesIn: aMaCollectionChanges
	"Serialize the new values for an index that is being built."

	aMaCollectionChanges newIndexValues keysAndValuesDo:
		[ :eachAttribute :eachValues | | index |
		index := (self indexForAttribute: eachAttribute).
		eachValues do:
			[ :eachAssociation |
			index
				add: eachAssociation value
				at: eachAssociation key ] ]
! !

!MaLargeCollectionManager methodsFor: 'private actions'!
processAddedIndexesIn: aMaCollectionChanges

	aMaCollectionChanges addedIndexesDo:
		[ :eachIndex | | hashIndex |
		self createNewIndex: eachIndex.
		indexes add: (hashIndex := self openIndex: (self fullFileNameStringFor: eachIndex)).
		indexesByAttribute
			at: eachIndex attribute
			put: hashIndex ]
! !

!MaLargeCollectionManager methodsFor: 'private actions'!
processAddsIn: aMaCollectionChanges using: aMaCommitResult

	aMaCollectionChanges additionsDo:
		[ :eachOid :eachHashIndexValues | | addedObjectLoid |
		addedObjectLoid :=
			(MaOidCalculator isOidForNewObject: eachOid)
				ifTrue:
					[ aMaCommitResult permanentLoids at: eachOid ]
				ifFalse:
					[ eachOid ].
		memberIndex
			add: addedObjectLoid
			at: addedObjectLoid.
		eachHashIndexValues
			with: indexes
			do:
				[ :eachHashValue :eachIndex |
				eachIndex
					add: addedObjectLoid
					at: eachHashValue ] ]
! !

!MaLargeCollectionManager methodsFor: 'private actions'!
processChangedIndexValuesIn: aMaCollectionChanges

	aMaCollectionChanges changedKeySpecificationsDo:
		[ :each | | index |
		index := self indexForAttribute: each attribute.
		(index
			remove: each oid
			at: each oldHashValue)
				ifTrue:
					[ index
						add: each oid
						at: each newHashValue ] ]
! !

!MaLargeCollectionManager methodsFor: 'private actions'!
processRemovedIndexesIn: aMaCollectionChanges

	aMaCollectionChanges
		removedIndexesDo: [ :each | self removeIndex: (self indexForAttribute: each) ]
! !

!MaLargeCollectionManager methodsFor: 'private actions'!
processRemovesIn: aMaLargeCollectionChanges

	aMaLargeCollectionChanges removedDo:
		[ :eachLoid :eachHashIndexValues |
		memberIndex removeKey: eachLoid.
		eachHashIndexValues
			with: indexes
			do:
				[ :eachHashValue :eachIndex |
				eachIndex
					remove: eachLoid
					at: eachHashValue ] ]
! !

!MaLargeCollectionManager methodsFor: 'private actions'!
removeIndex: aMaHashIndex

	aMaHashIndex
		close;
		delete
! !

!MaLargeCollectionManager methodsFor: 'private initializing' stamp: 'cmm 4/21/2002 23:09'!
initialize

	super initialize.
	"we need them mapped to the correct attribute."
	indexesByAttribute := Dictionary new.
	"and we must know the correct order, as well"
	indexes := OrderedCollection new
! !

!MaLargeCollectionManager methodsFor: 'accessing'!
memberIndex

	^memberIndex
! !

!MaLargeCollectionManager methodsFor: 'accessing'!
oidOfIndexesCollection

	^oidOfIndexesCollection
! !

!MaLargeCollectionManager methodsFor: 'accessing'!
size

	^memberIndex size
! !


!MaLargeCollectionManager class methodsFor: 'creation'!
collection: aMagmaCollection repository: aMaObjectRepository oidOfIndexesCollection: anInteger

	^self new
		collection: aMagmaCollection;
		repository: aMaObjectRepository;
		oidOfIndexesCollection: anInteger
! !


!MaLargeCollectionOfIntegers methodsFor: 'building'!
add: anInteger

	^self
		at: self size + 1
		put: anInteger
! !

!MaLargeCollectionOfIntegers methodsFor: 'building'!
at: logicalIndex put: anInteger

	self loadByteArrayWith: anInteger.
	file
		maWrite: byteSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: (self filePositionFor: logicalIndex).
	^anInteger
! !

!MaLargeCollectionOfIntegers methodsFor: 'accessing' stamp: 'cmm 5/1/2002 23:09'!
at: logicalIndex

	(logicalIndex
		between: 1
		and: self size)
			ifFalse:
				[ MagmaSoftwareError signal: 'Index out of range.' ].
	file
		maRead: byteSize
		bytesFromPosition: 1
		of: byteArray
		atFilePosition: (self filePositionFor: logicalIndex).
	^self valueInByteArray
! !

!MaLargeCollectionOfIntegers methodsFor: 'accessing'!
size

	^(file size - self headerSize) / byteSize! !

!MaLargeCollectionOfIntegers methodsFor: 'private building'!
byteSize: anInteger

	byteSize _ anInteger.
	self initializePremadeByteArray
! !

!MaLargeCollectionOfIntegers methodsFor: 'private building' stamp: 'cmm 1/27/2002 22:51'!
open: fileNameString

	file _
		(FileStream concreteStream new
			open: fileNameString
			forWrite: true) binary.
	self loadHeader
! !

!MaLargeCollectionOfIntegers methodsFor: 'actions' stamp: 'cmm 1/27/2002 22:50'!
close

	file ifNotNil: [ file close ]
! !

!MaLargeCollectionOfIntegers methodsFor: 'private actions' stamp: 'cmm 1/27/2002 22:51'!
create: fileNameString

	file _
		(FileStream concreteStream new
			open: fileNameString
			forWrite: true) binary.
	self writeHeader
! !

!MaLargeCollectionOfIntegers methodsFor: 'private actions'!
filePositionFor: logicalIndex

	^((logicalIndex - 1) * byteSize) + self headerSize
! !

!MaLargeCollectionOfIntegers methodsFor: 'private actions' stamp: 'cmm 1/27/2002 20:22'!
loadByteArrayWith: anInteger

	^byteArray
		uint: byteSize * 8
		at: 0
		put: anInteger
! !

!MaLargeCollectionOfIntegers methodsFor: 'private actions' stamp: 'cmm 1/27/2002 20:21'!
valueInByteArray

	^byteArray
		uint: byteSize * 8
		at: 0
! !

!MaLargeCollectionOfIntegers methodsFor: 'private accessing'!
headerSize
	"Header consists of:
		number of bits per Integer in the receiver."
	^1
! !

!MaLargeCollectionOfIntegers methodsFor: 'private initializing' stamp: 'cmm 3/21/2002 23:24'!
finalize

	self close.
	super finalize
! !

!MaLargeCollectionOfIntegers methodsFor: 'private initializing' stamp: 'cmm 1/27/2002 20:20'!
initializeFromHeader: aByteArray

	self byteSize: (
		aByteArray 
			uint: 8
			at: 0)
! !

!MaLargeCollectionOfIntegers methodsFor: 'private initializing'!
initializePremadeByteArray

	byteArray _ ByteArray new: byteSize
! !

!MaLargeCollectionOfIntegers methodsFor: 'private initializing'!
loadHeader

	| headerBytes |

	headerBytes _ ByteArray new: self headerSize.
	file
		maRead: self headerSize
		bytesFromPosition: 1
		of: headerBytes
		atFilePosition: 0.
	self initializeFromHeader: headerBytes
! !

!MaLargeCollectionOfIntegers methodsFor: 'private initializing' stamp: 'cmm 1/27/2002 20:23'!
newHeaderBytes
	"Answer a new ByteArray containing the header for the receiver.
	This is only used when creating the an instance of this class with
	the create: constructor."

	^(ByteArray new: self headerSize)
		uint: 8
		at: 0
		put: byteSize;
		yourself
! !

!MaLargeCollectionOfIntegers methodsFor: 'private initializing'!
writeHeader

	| headerBytes |

	headerBytes _ self newHeaderBytes.
	file
		maWrite: self headerSize
		bytesFromPosition: 1
		of: headerBytes
		atFilePosition: 0
! !

!MaLargeCollectionOfIntegers methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	1
		to: (self size min: 100)
		do:
			[ :each |
			aStream
				space;
				maPrint: (self at: each) ].
	self size > 100 ifTrue: [ aStream nextPutAll: ' ...' ]
! !


!MaLargeCollectionOfIntegers class methodsFor: 'creation'!
create: aString

	^self
		create: aString
		bitSize: 64
! !

!MaLargeCollectionOfIntegers class methodsFor: 'creation'!
create: aString bitSize: anInteger

	^self new
		byteSize: anInteger / 8;
		create: aString
! !

!MaLargeCollectionOfIntegers class methodsFor: 'creation'!
open: aString

	^self new open: aString
! !


!MaMagnitudeIndex methodsFor: 'building'!
add: oidInteger at: keyInteger

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'actions' stamp: 'cmm 1/27/2002 22:52'!
close

	file ifNotNil: [ file close ]
! !

!MaMagnitudeIndex methodsFor: 'private actions' stamp: 'cmm 5/1/2002 23:16'!
create: fileNameString

	(FileStream concreteStream isAFileNamed: fileNameString)
		ifTrue:
			[ MagmaUserError signal: fileNameString, ' already exists.' ].
	file _
		(FileStream concreteStream new
			open: fileNameString
			forWrite: true) binary.
	self writeHeader.
	nextRecordNumber _ 0
! !

!MaMagnitudeIndex methodsFor: 'private actions' stamp: 'cmm 7/3/2002 00:04'!
open: fileNameString

	(FileStream concreteStream isAFileNamed: fileNameString)
		ifFalse:
			[ MaHardwareError signal: 'Could not locate index file ', fileNameString ].
	file _
		(FileStream concreteStream new
			open: fileNameString
			forWrite: true) binary.
	self
		readHeader;
		initializeRecords.
	nextRecordNumber _ (file size - self headerSize - 1) / self recordSize.
	nextRecordNumber maIsFraction
		ifTrue:
			[ self maSignalSystemError: 'Invalid index size.  Requires maintenance tool.' ]
! !

!MaMagnitudeIndex methodsFor: 'private accessing'!
headerSize

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'private accessing'!
recordSize

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'accessing'!
highestPossibleKey

	^(2 raisedTo: keySize) - 1
! !

!MaMagnitudeIndex methodsFor: 'accessing'!
keySize

	^keySize! !

!MaMagnitudeIndex methodsFor: 'accessing'!
lowestPossibleKey

	^0
! !

!MaMagnitudeIndex methodsFor: 'private initializing' stamp: 'cmm 1/30/2002 00:49'!
finalize

	self close
! !

!MaMagnitudeIndex methodsFor: 'private building'!
keySize: numberOfBitsInteger

	keySize _ numberOfBitsInteger
! !

!MaMagnitudeIndex methodsFor: 'private building'!
writeHeader
	"Your keySize should be stored somewhere in the header."

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'private framework'!
readHeader
	"Answer a ByteArray containing the header bytes.  This includes the keySize as well
	as other implementation-specific variables."

	self subclassResponsibility
! !

!MaMagnitudeIndex methodsFor: 'framework'!
upTo: count oidsFromKey: keyInteger

	"optional subclassResponsibility"
! !

!MaMagnitudeIndex methodsFor: 'framework'!
upTo: count oidsWithKey: keyInteger

	self subclassResponsibility
! !


!MaHashIndex methodsFor: 'building'!
add: oidInteger at: keyInteger
	"Find the record which either has space for keyInteger or is as far
	zoomed-in as possible (with either space for keyInteger or not).
	If a record already contains another key greater than keyInteger,
	that entry must be 'pushed' down so we can maintain key order.
	Additionally, we must incremement the numberOfChildren for each
	record to the path of where we finally add."

	| currentKeyToWrite currentOidToWrite hasSpace atBottom |

	currentKeyToWrite _ keyInteger.
	currentOidToWrite _ oidInteger.
	self selectRoot.
	hasSpace _ false.
	atBottom _ false.
	[ hasSpace | atBottom ] whileFalse:
		[ | highestBax keyToMove oidToMove recordNumber |
		highestBax _ record highestByteArrayIndexFor: currentKeyToWrite.
		record incrementNumberOfChildrenAtByteArrayIndex: highestBax.
		((hasSpace _ record canAdd: currentKeyToWrite)
			or: [ (keyToMove _ record keyAtHighestSlotFor: currentKeyToWrite) > currentKeyToWrite ])
				ifTrue:
					[ hasSpace
						ifFalse:
							[ oidToMove _ record oidAtByteArrayIndex: highestBax.
							record clearHighestSlotFor: currentKeyToWrite ].
					record
						atKey: currentKeyToWrite
						put: currentOidToWrite.
					"See method comment."
					hasSpace
						ifFalse:
							[ (record canAdd: keyToMove)
								ifTrue:
									[ record
										atKey: keyToMove
										put: oidToMove.
									"bypass logic to select new record, below.."
									hasSpace _ true ] ] ].
		self writeRecord: record.
		oidToMove notNil
			ifTrue:
				[
				"we will need to push this key/oid pair down"
				currentKeyToWrite _ keyToMove.
				currentOidToWrite _ oidToMove ].
		recordNumber _ record recordNumberCloserTo: currentKeyToWrite.
		atBottom _ recordNumber = 0.
		atBottom ifFalse: [ self selectRecord: recordNumber ] ].
	(atBottom and: [ hasSpace not ])
		ifTrue:
			[ self selectNewRecordFor: currentKeyToWrite.
			record incrementNumberOfChildrenAtByteArrayIndex: (
				record
					atKey: currentKeyToWrite
					put: currentOidToWrite).
			self writeRecord ]
! !

!MaHashIndex methodsFor: 'building' stamp: 'cmm 3/6/2002 00:24'!
remove: oidInteger at: keyInteger
	"Answer a boolean indicating whether anything was removed."

	(self
		includesOid: oidInteger
		at: keyInteger)
			ifFalse:
				[ ^false ].
	self
		navigateToward: keyInteger
		until:
			[ :eachRecord |
			(eachRecord
				removeKey: keyInteger
				withOid: oidInteger)
					notNil ]
		do:
			[ :eachRecord | | highestBax |
			highestBax _ eachRecord highestByteArrayIndexFor: keyInteger.
			eachRecord decrementNumberOfChildrenAtByteArrayIndex: highestBax.
			self writeRecord ].
	record decrementNumberOfChildrenAtKey: keyInteger.
	self writeRecord.
	^true
! !

!MaHashIndex methodsFor: 'building' stamp: 'cmm 3/6/2002 00:50'!
removeKey: anInteger
	"Answer the oid of the object removed."

	| oidRemoved |

	(self includesKey: anInteger) ifFalse: [ ^nil ].
	self
		navigateToward: anInteger
		until: [ :eachRecord | eachRecord hasEntryForKey: anInteger ]
		do:
			[ :eachRecord | | highestBax |
			highestBax _ eachRecord highestByteArrayIndexFor: anInteger.
			eachRecord decrementNumberOfChildrenAtByteArrayIndex: highestBax.
			self writeRecord ].
	oidRemoved _ record removeKey: anInteger.
	record decrementNumberOfChildrenAtKey: anInteger.
	self writeRecord.
	^oidRemoved
! !

!MaHashIndex methodsFor: 'private accessing'!
answerArrayOfSize: anInteger

	^anInteger > preMadeAnswerArrays size
		ifTrue:
			[ Array new: anInteger ]
		ifFalse:
			[ preMadeAnswerArrays at: anInteger ]
! !

!MaHashIndex methodsFor: 'private accessing'!
filePositionFor: recordNumberInteger

	^self headerSize + (record bufferSize * recordNumberInteger) + 1
! !

!MaHashIndex methodsFor: 'private accessing'!
getNextRecordNumber

	^nextRecordNumber _ nextRecordNumber + 1
! !

!MaHashIndex methodsFor: 'private accessing'!
indexOfLowest: keyInteger exactKey: aBoolean
	"If aBoolean is true, answer 0 if we don't find an exact key.  If false
	answer the index of the first equal or higher key."

	| total index |

	total _ 0.
	self
		navigateToward: keyInteger
		until:
			[ :currentRecord | | foundRecord |
			foundRecord _ false.
			total _ total + (record numberOfChildrenBefore: keyInteger).
			currentRecord
				eligibleByteArrayIndexesFor: keyInteger
				do:
					[ :each |
					((currentRecord hasEntryAtByteArrayIndex: each)
						and: [ (currentRecord keyAtByteArrayIndex: each) >= keyInteger ])
							ifTrue:
								[ foundRecord _ true ] ].
			foundRecord ]
		do: [ :currentRecord | "nothing" ].
	"We now have the correct potential record selected and a correct total number
	of entries that occur before the entry that would contain keyInteger.  Now determine
	whether we should answer it or nil"
	index _ total + 1.
	^aBoolean
		ifTrue:
			[ (record hasEntryForKey: keyInteger) ifTrue: [ ^index ] ifFalse: [ 0 ] ]
		ifFalse:
			[ index > self size ifTrue: [ 0 ] ifFalse: [ index ] ]
! !

!MaHashIndex methodsFor: 'private accessing'!
recordSize

	^record bufferSize
! !

!MaHashIndex methodsFor: 'private actions'!
create: fileNameString

	super create: fileNameString.
	self writeNewRoot
! !

!MaHashIndex methodsFor: 'private actions'!
navigateToward: keyInteger until: untilBlock do: doBlock
	"Select records between the root and the one that can contain keyInteger
	and value one-argument doBlock on each of those records until the
	one-argument untilBlock values true or we cannot navigate any
	closer to keyInteger."

	| level bax |

	level _ 1.
	self selectRoot.
	[ | goalRecordReached |
		goalRecordReached _ untilBlock value: record.
		goalRecordReached not and:
			[ record hasChildAtByteArrayIndex: (bax _ record highestByteArrayIndexFor: keyInteger) ] ]
				whileTrue:
					[ recordFactory
						put: record
						atLevel: level
						byteArrayIndex: bax.
					doBlock value: record.
					self selectRecord: (record recordNumberCloserTo: keyInteger).
					level _ level + 1 ]
! !

!MaHashIndex methodsFor: 'private actions'!
readRecord: aMaHashIndexRecord at: recordIndex

	aMaHashIndexRecord
		readFrom: file
		atPosition: (self filePositionFor: recordIndex);

		recordNumber: recordIndex.
	^aMaHashIndexRecord
! !

!MaHashIndex methodsFor: 'private actions'!
selectFirstRecordWithKeyEqualOrGreaterThan: keyInteger
	"If keyInteger is
	larger than every key in the index, answer nil, otherwise answer the level of the
	record with the answer."

	| level searchedLevel |

	level _ 1.
	self
		navigateToward: keyInteger
		until:
			[ :currentRecord |
			currentRecord
				eligibleByteArrayIndexesFor: keyInteger
				do:
					[ :each |
					((currentRecord hasEntryAtByteArrayIndex: each)
						and: [ (currentRecord keyAtByteArrayIndex: each) >= keyInteger ])
							ifTrue:
								[ ^level ] ].
			false ]
		do: [ :currentRecord | level _ level + 1 ].
	"Though we have arrived at the record which would contain keyInteger,
	in case it does not have entries whose keys are >= keyInteger,
	look for the next higher key."
	self
		traverseSlotsFromRecord: record
		index: (record entryIndexFor: keyInteger)
		do: [ :currentRecord :byteArrayIndex :currentLevel | "nothing" ]
		until:
			[ :currentRecord :byteArrayIndex :currentLevel |
			searchedLevel _ currentLevel.
			currentRecord hasEntryAtByteArrayIndex: byteArrayIndex ]
		level: level.
	^searchedLevel
! !

!MaHashIndex methodsFor: 'private actions'!
selectPreMadeNewRecord

	record populateFrom: recordFactory preMadeNewRecord
! !

!MaHashIndex methodsFor: 'private actions'!
selectRecord: anInteger

	self
		readRecord: record
		at: anInteger
! !

!MaHashIndex methodsFor: 'private actions'!
selectRecordAt: globalIndex
	"Answer the level and the byteArrayIndex of the selected record, or nil if out of bounds.
	Since the caller of this method is going to call traverseSlotsFromRecord:index:do:until:level:,
	we must be sure to populate the receivers path."

	| level byteArrayIndex currentGlobalPosition outOfBounds |

	self selectRoot.
	level _ 1.
	currentGlobalPosition _ 1.
	outOfBounds _ false.
	[
		byteArrayIndex _
			record
				byteArrayIndexContainingGlobalIndex: globalIndex
				base: currentGlobalPosition.
		byteArrayIndex isNil
			ifTrue:
				[ outOfBounds _ true.
				false ]
			ifFalse:
				[ currentGlobalPosition _
					currentGlobalPosition +
						(record numberOfChildrenBeforeByteArrayIndex: byteArrayIndex).
				(currentGlobalPosition < globalIndex) and:
					[ "this should never be false if above is true" record
						hasChildAtByteArrayIndex: byteArrayIndex ] ] ]
							whileTrue:
								[ recordFactory
									put: record
									atLevel: level
									byteArrayIndex: byteArrayIndex.
								self selectRecord:
									(record recordNumberAtByteArrayIndex: byteArrayIndex).
								currentGlobalPosition _ currentGlobalPosition + 1.
								level _ level + 1 ].
	^outOfBounds
		ifTrue:
			[ nil ]
		ifFalse:
			[ Array
				with: byteArrayIndex
				with: level ]
! !

!MaHashIndex methodsFor: 'private actions'!
selectRoot

	self selectRecord: 0
! !

!MaHashIndex methodsFor: 'private actions'!
setUpNewRecordFor: keyInteger

	recordFactory preMadeNewRecord
		beZoomedInToward: keyInteger
			from: record;
		recordNumber: self getNextRecordNumber
! !

!MaHashIndex methodsFor: 'private actions'!
traverseSlotsFromParentRecord: aMaHashIndexRecord index: entryIndex do: threeArgBlock until: conditionBlock level: levelInteger
	"levelInteger is 1 for the root record."

	| conditionMet |

	conditionMet _ false.
	aMaHashIndexRecord
		byteArrayIndexesFrom: entryIndex
		do:
			[ :index | | nextToRead |
			conditionMet
				ifFalse:
					[ nextToRead _ aMaHashIndexRecord recordNumberAtByteArrayIndex: index.
					(conditionBlock
						value: aMaHashIndexRecord
						value: index
						value: levelInteger)
							ifTrue:
								[ conditionMet _ true ]
							ifFalse:
								[ threeArgBlock
									value: aMaHashIndexRecord
									value: index
									value: levelInteger ] ].
			conditionMet
				ifFalse:
					[ nextToRead > 0
						ifTrue:
							[ | currentRecord |
							currentRecord _ recordFactory recordForLevel: levelInteger + 1.
							self
								readRecord: currentRecord
								at: nextToRead.
							conditionMet _
								self
									traverseSlotsFromParentRecord: currentRecord
									index: 0
									do: threeArgBlock
									until: conditionBlock
									level: levelInteger + 1 ] ] ].
	^conditionMet
! !

!MaHashIndex methodsFor: 'private actions'!
traverseSlotsFromRecord: aMaHashIndexRecord index: entryIndex do: threeArgBlock until: conditionBlock level: levelInteger
	"levelInteger is 1 for the root record."

	| done |

	done _
		self
			traverseSlotsFromParentRecord: aMaHashIndexRecord
			index: entryIndex
			do: threeArgBlock
			until: conditionBlock
			level: levelInteger.
	(done not and: [ levelInteger > 1 ])
		ifTrue:
			[ | nextStart |
			nextStart _ recordFactory recordForLevel: levelInteger - 1.
			self
				readRecord: nextStart
				at: (recordFactory recordNumberAtLevel: levelInteger - 1).
			self
				traverseSlotsFromRecord: nextStart
				index: (recordFactory entryIndexAtLevel: levelInteger - 1) + 1
				do: threeArgBlock
				until: conditionBlock
				level: levelInteger - 1 ]
! !

!MaHashIndex methodsFor: 'private actions'!
writeRecord

	self writeRecord: record
! !

!MaHashIndex methodsFor: 'private actions'!
writeRecord: aMaHashIndexRecord

	aMaHashIndexRecord
		writeTo: file
		atPosition: (self filePositionFor: aMaHashIndexRecord recordNumber)
! !

!MaHashIndex methodsFor: 'private initializing'!
createRecord

	record _
		(MaHashIndexRecord
			keySize: keySize
			numberOfEntries: hashRecordSize)

				beFrom: 0
				to: (2 raisedTo: keySize) - 1;

				recordNumber: 0
! !

!MaHashIndex methodsFor: 'private initializing'!
initialize

	super initialize.
	self initializePreMadeAnswerArrays
! !

!MaHashIndex methodsFor: 'private initializing'!
initializePreMadeAnswerArrays

	preMadeAnswerArrays _ (1 to: 250) collect: [ :eachSize | Array new: eachSize ]
! !

!MaHashIndex methodsFor: 'private initializing'!
initializeRecordFactory

	recordFactory _ MaHashIndexRecordFactory index: self
! !

!MaHashIndex methodsFor: 'private initializing'!
initializeRecords

	self
		createRecord;
		initializeRecordFactory
! !

!MaHashIndex methodsFor: 'debugging'!
dumpEntries

	| entryNumber originalRecord |

	originalRecord _ record recordNumber.
	entryNumber _ 1.
	self
		entriesFrom: 0
		do:
			[ :eachRecord :index :level |
			Transcript
				cr;
				show: 'at: ' , entryNumber printString;
				maTab: level - 1;
				show: eachRecord recordNumber printString;
				show: ' (' , eachRecord lowKey printString;
				show: ' to: ' , eachRecord highKey printString;
				show: ')';
				show: ' x:' , (eachRecord entryIndexForBax: index) printString;
				show: ' k:' , (eachRecord keyAtByteArrayIndex: index) printString;
				show: ' o:' , (eachRecord oidAtByteArrayIndex: index) printString;
				show: ' r:' , (eachRecord recordNumberAtByteArrayIndex: index) printString;
				show: ' c:' , (eachRecord numberOfChildrenAtByteArrayIndex: index) printString.
			entryNumber _ entryNumber + 1 ]
		until: [ :eachRecord :index :level | false ].
	self selectRecord: originalRecord
! !

!MaHashIndex methodsFor: 'actions'!
entriesFrom: keyInteger do: threeArgBlock until: conditionBlock
	"The first two arguments of threeArgBlock and conditionBlock are the record and the
	internal index position needed to access the of each entry in those records via
	keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.
	The third argument is the levels from the root record, where the root is level 1.
	This is used to reference into the receivers preMadeRecords, a performance optimization."

	^self
		slotsFrom: keyInteger
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ threeArgBlock
						value: currentRecord
						value: byteArrayIndex
						value: level ] ]
		until: conditionBlock
! !

!MaHashIndex methodsFor: 'actions'!
entriesFromIndex: globalIndex do: threeArgBlock until: conditionBlock

	^self
		slotsFromIndex: globalIndex
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ threeArgBlock
						value: currentRecord
						value: byteArrayIndex
						value: level ] ]
		until: conditionBlock
! !

!MaHashIndex methodsFor: 'actions'!
slotsFrom: keyInteger do: threeArgBlock until: conditionBlock
	"The first two arguments of threeArgBlock and conditionBlock are the record and the
	internal index position needed to access the of each entry in those records via
	keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.
	The third argument is the levels from the root record, where the root is level 1.
	This is used to reference into the receivers preMadeRecords, a performance optimization."

	| level startingEntryIndex |

	(level _ self selectFirstRecordWithKeyEqualOrGreaterThan: keyInteger) isNil ifTrue: [ ^self ].
	"For inverted records, it is possible the entryIndex for keyInteger will be consumed by the
	next lower key.  Unfortunately, we have to check."
	startingEntryIndex _ record entryIndexFor: keyInteger.
	(record keyAtEntryIndex: startingEntryIndex) < keyInteger
		ifTrue:
			[ startingEntryIndex _ startingEntryIndex + 1 ].
	self
		traverseSlotsFromRecord: record
		index: startingEntryIndex
		do: threeArgBlock
		until: conditionBlock
		level: level
! !

!MaHashIndex methodsFor: 'actions'!
slotsFromIndex: globalIndex do: threeArgBlock until: conditionBlock
	"The first two arguments of threeArgBlock and conditionBlock are the record and the
	internal index position needed to access the of each entry in those records via
	keyAtByteArrayIndex:, oidAtByteArrayIndex:, and recordNumberAtByteArrayIndex:.
	The third argument is the levels from the root record, where the root is level 1.
	This is used to reference into the receivers preMadeRecords, a performance optimization."

	| byteArrayIndexAndLevelArray |

	(byteArrayIndexAndLevelArray _ self selectRecordAt: globalIndex) isNil ifTrue: [ ^self ].
	self
		traverseSlotsFromRecord: record
		index: (record entryIndexForBax: byteArrayIndexAndLevelArray first)
		do: threeArgBlock
		until: conditionBlock
		level: byteArrayIndexAndLevelArray last
! !

!MaHashIndex methodsFor: 'accessing'!
hashRecordSize

	^hashRecordSize! !

!MaHashIndex methodsFor: 'accessing'!
indexOf: keyInteger

	^self
		indexOfLowest: keyInteger
		exactKey: true
! !

!MaHashIndex methodsFor: 'accessing'!
indexOfHighest: keyInteger
	"If keyInteger is present, answer the index of its last occurrence.
	Otherwise, answer the index of the next lower key.  If keyInteger
	is lower than all keys in the receiver, answer 0."

	| lowestIndexOfNextHigherKey |

	keyInteger >= self highestPossibleKey ifTrue: [ ^self size ].
	^(lowestIndexOfNextHigherKey _
		self
			indexOfLowest: keyInteger + 1
			exactKey: false) = 0
				ifTrue:
					[ self size ]
				ifFalse:
					[ lowestIndexOfNextHigherKey - 1 max: 1 ]
! !

!MaHashIndex methodsFor: 'accessing'!
numberOfEntriesFrom: lowKey to: highKey
	"Inclusive of lowKey and highKey, if those keys exist.
	If lowKey does not exist, we count from the next higher key.
	If highKey doesn't exist, we count up to the next highestKey."

	| lowest |

	(lowest _
		self
			indexOfLowest: lowKey
			exactKey: false) = 0
				ifTrue:
					[ ^0 ].
	^(self indexOfHighest: highKey) - lowest + 1
! !

!MaHashIndex methodsFor: 'accessing'!
occurrencesOf: keyInteger

	^self
		numberOfEntriesFrom: keyInteger
		to: keyInteger
! !

!MaHashIndex methodsFor: 'accessing'!
size

	self selectRoot.
	^record numberOfChildren
! !

!MaHashIndex methodsFor: 'accessing'!
upTo: countInteger at: keyInteger

	^self
		upTo: countInteger
		oidsFrom: keyInteger
		to: keyInteger
! !

!MaHashIndex methodsFor: 'accessing'!
upTo: countInteger oidsFrom: lowKey to: highKey

	| result answerIndex |

	result _ self answerArrayOfSize: countInteger.
	answerIndex _ 1.
	self
		entriesFrom: lowKey
		do:
			[ :currentRecord :byteArrayIndex :level |
			(currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
				ifTrue:
					[ result
						at: answerIndex
						put: (currentRecord oidAtByteArrayIndex: byteArrayIndex).
					answerIndex _ answerIndex + 1 ] ]
		until:
			[ :currentRecord :byteArrayIndex :level |
			answerIndex > countInteger or:
				[ (currentRecord hasEntryAtByteArrayIndex: byteArrayIndex)
					and: [ (currentRecord keyAtByteArrayIndex: byteArrayIndex) > highKey ] ] ].
	"Need to check in case of a small index (say only 9 entries?)."
	^answerIndex < countInteger
		ifTrue:
			[ result
				copyFrom: 1
				to: answerIndex - 1 ]
		ifFalse:
			[ result ]
! !

!MaHashIndex methodsFor: 'accessing'!
upTo: countInteger oidsFromIndex: lowIndex

	| result answerIndex |

	result _ self answerArrayOfSize: countInteger.
	answerIndex _ 1.
	self
		entriesFromIndex: lowIndex
		do:
			[ :currentRecord :byteArrayIndex :level |
			result
				at: answerIndex
				put: (currentRecord oidAtByteArrayIndex: byteArrayIndex).
			answerIndex _ answerIndex + 1 ]
		until: [ :currentRecord :index :level | answerIndex > countInteger ].
	^answerIndex < countInteger
		ifTrue:
			[ result
				copyFrom: 1
				to: answerIndex - 1 ]
		ifFalse:
			[ result ]
! !

!MaHashIndex methodsFor: 'private building'!
hashRecordSize: numberOfEntriesInteger

	hashRecordSize _ numberOfEntriesInteger
! !

!MaHashIndex methodsFor: 'private building' stamp: 'cmm 1/27/2002 20:23'!
loadHeaderFrom: aByteArray

	self
		keySize: (aByteArray uint: 16 at: 0);
		hashRecordSize: (aByteArray uint: 16 at: 2);
		initializeRecords
! !

!MaHashIndex methodsFor: 'private building' stamp: 'cmm 1/27/2002 20:24'!
populateHeader: aByteArray

	aByteArray
		uint: 16
		at: 0 
		put: keySize.
	aByteArray
		uint: 16
		at: 2 
		put: hashRecordSize
! !

!MaHashIndex methodsFor: 'private building'!
readHeader

	| header |

	header _ ByteArray new: self headerSize.
	file
		maRead: self headerSize
		bytesFromPosition: 1
		of: header
		atFilePosition: 0.
	self loadHeaderFrom: header
! !

!MaHashIndex methodsFor: 'private building'!
selectNewRecordFor: keyInteger
	"We need to make sure we reference the new record from the
	current record."

	self setUpNewRecordFor: keyInteger.
	"Reference new record and write before selecting the new record."
	record
		recordNumberAtSlotForKey: keyInteger
		put: recordFactory preMadeNewRecord recordNumber.
	self
		writeRecord; "replace record that now references newRecord.."
		selectPreMadeNewRecord
! !

!MaHashIndex methodsFor: 'private building'!
writeHeader

	| header |

	header _ ByteArray new: self headerSize.
	self populateHeader: header.
	file
		maWrite: self headerSize
		bytesFromPosition: 1
		of: header
		atFilePosition: 0
! !

!MaHashIndex methodsFor: 'private building'!
writeNewRoot

	self writeRecord
! !

!MaHashIndex methodsFor: 'private framework'!
headerSize
	"Header consists of:
		keySize:  16-bits
		recordSize: 16-bits"

	^4
! !

!MaHashIndex methodsFor: 'testing'!
includesKey: anInteger

	self selectFirstRecordWithKeyEqualOrGreaterThan: anInteger.
	^record hasEntryForKey: anInteger
! !

!MaHashIndex methodsFor: 'testing'!
includesOid: oidInteger at: keyInteger

	| hasEntry key |

	self
		entriesFrom: keyInteger
		do:
			[ :eachRecord :eachByteArrayIndex :level |
			(hasEntry and:
				[ key = keyInteger
					and: [ (eachRecord oidAtByteArrayIndex: eachByteArrayIndex) = oidInteger ] ])
						ifTrue:
							[ ^true ] ]
		until:
			[ :eachRecord :eachByteArrayIndex :level |
			"Until we're on an entry that could not possibly hold keyInteger."
			((hasEntry _ eachRecord hasEntryAtByteArrayIndex: eachByteArrayIndex)
				and: [ (key _ eachRecord keyAtByteArrayIndex: eachByteArrayIndex) > keyInteger ])
					or: [ eachByteArrayIndex > (eachRecord highestByteArrayIndexFor: keyInteger) ] ].
	^false
! !


!MaMagnitudeIndex class methodsFor: 'creation'!
create: aString keySize: numberOfBitsInteger

	^self new
		keySize: numberOfBitsInteger;
		create: aString
! !

!MaMagnitudeIndex class methodsFor: 'creation'!
open: fileNameString

	^self new open: fileNameString
! !


!MaHashIndex class methodsFor: 'creation'!
create: fileNameString keySize: keySizeInteger

	self shouldNotImplement
! !

!MaHashIndex class methodsFor: 'creation'!
create: fileNameString keySize: numberOfBitsInteger hashRecordSize: entriesInteger

	^self new
		keySize: numberOfBitsInteger;
		hashRecordSize: entriesInteger;
		initializeRecords;
		create: fileNameString
! !

!MaHashIndex class methodsFor: 'creation'!
suggestedFileExtension

	^'hdx'
! !


!MaObjectBuffer methodsFor: 'private accessing' stamp: 'cmm 7/10/2002 20:06'!
bufferPositionOfBytesToStore
	"We don't need to store the oid because it is kept in the object table (see the filePositionIndex variable of MaObjectFiler)."

	^9
! !


!MaByteObjectBuffer methodsFor: 'creation'!
linkRepresentationUsing: tempToPermLoidMap

	^(MaByteObjectLinkDescription mainOid: self oid) bytes: self asByteArray
! !

!MaByteObjectBuffer methodsFor: 'building'!
appendGraphUsing: aMaReadStrategy currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet forRepository: aMaObjectRepository

	"Nothing to do for a byte-object."
! !


!MaNormalObjectBuffer methodsFor: 'building'!
appendGraphUsing: aMaReadStrategy currentDepth: currentDepth minDepth: minDepth with: alreadyAppendedSet forRepository: aMaObjectRepository

	1
		to: self logicalInstSize
		do:
			[ :varIndex | | oid |
			(MaOidCalculator isOidForOptimizedObject: (oid _ self maInstVarAt: varIndex))
				ifFalse:
					[ | newMinDepth |
					currentDepth < (
						newMinDepth _
							(aMaReadStrategy
								depthOfAttribute: varIndex
								onClassWithId: self classId) + currentDepth
									max: minDepth)
										ifTrue:
											[ self
												appendGraphNode: oid
												using: aMaReadStrategy
												currentDepth: currentDepth
												minDepth: newMinDepth
												with: alreadyAppendedSet
												forRepository: aMaObjectRepository ] ] ]
! !

!MaNormalObjectBuffer methodsFor: 'creation'!
linkRepresentationUsing: tempToPermLoidMap

	| link |

	link _ MaFirstClassObjectLinkDescription mainOid: self oid.
	self instVarsDoWithIndex:
		[ :eachLinkedLoid :eachInstVarIndex |
		link addLink: (
			tempToPermLoidMap
				at: eachLinkedLoid
				ifAbsent: [ "This should never be a transient loid" eachLinkedLoid ]) ].
	^link
! !


!MaObjectFiler methodsFor: 'accessing'!
allLargeCollectionsLoid

	^self primitiveAttributeAt: 'allLargeCollectionsLoid'
! !

!MaObjectFiler methodsFor: 'accessing'!
allocateSpaceForBuffer: aMaSerializedObjectBuffer

	| filePointer storedSize |

	^memory
		addFrom: (
			filePointer _
				self pointerToContiguousBytes:
					(storedSize _ aMaSerializedObjectBuffer numberOfBytesToStore))
		to: filePointer + storedSize - 1
! !

!MaObjectFiler methodsFor: 'accessing'!
anchorLoid

	^self primitiveAttributeAt: 'anchorLoid'
! !

!MaObjectFiler methodsFor: 'accessing'!
classDefinitionsLoid

	^self primitiveAttributeAt: 'classDefinitionsLoid'
! !

!MaObjectFiler methodsFor: 'accessing'!
classesSetLoid

	^self primitiveAttributeAt: 'classesSetLoid'
! !

!MaObjectFiler methodsFor: 'accessing'!
dataFileName

	^filename asString
! !

!MaObjectFiler methodsFor: 'accessing'!
definitionLoid

	^self primitiveAttributeAt: 'definitionLoid'
! !

!MaObjectFiler methodsFor: 'accessing'!
filePointerForLoid: loidInteger

	^filePositionIndex at: (MaOidCalculator indexPositionForLoid: loidInteger)
! !

!MaObjectFiler methodsFor: 'accessing'!
filePositionIndexFileName

	^(filename copyWithExtension: self class filePositionIndexFileExtension) asString
! !

!MaObjectFiler methodsFor: 'accessing'!
getNextLoid

	^MaOidCalculator loidForFilePositionIndexPosition: filePositionIndex size + 1
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:58'!
open

	| f |
	(FileStream concreteStream isAFileNamed: self dataFileName)
		ifFalse:
			[ MagmaUserError signal: self dataFileName, ' not found.' ].
	f _
		(FileStream concreteStream new
			open: self dataFileName
			forWrite: true) binary.
	self file: f.
	[ self validateSignature ] ifCurtailed: [ file close ].
	[ self validateVersion ] ifCurtailed: [ file close ].
	filePositionIndex _
		[ MaLargeCollectionOfIntegers open: self filePositionIndexFileName ] ifCurtailed: [ f close ].
	^self
! !

!MaObjectFiler methodsFor: 'accessing' stamp: 'cmm 7/15/2002 23:46'!
physicalSizeOfObjectAt: filePointer
	"Used to determine how much space we can deallocate from my 'memory' because an object, most likely an OrderedCollection, residing at filePointer has grown and needs to be relocated."

	| byteArray buffer |

	byteArray _ ByteArray new: MaNormalObjectBuffer headerSize.
	buffer _
		MaNormalObjectBuffer
			byteArray: byteArray
			startPos: 0.
	self file
		maRead: byteArray size - buffer bufferPositionOfBytesToStore + 1
		bytesFromPosition: buffer bufferPositionOfBytesToStore
		of: byteArray
		atFilePosition: filePointer.
	^buffer numberOfBytesToStore
! !

!MaObjectFiler methodsFor: 'accessing'!
primitiveAttributeAt: aString

	| assoc |

	^self
		uint: (assoc _ self primitiveAttributeAddressesMap at: aString) value
		at: assoc key
! !

!MaObjectFiler methodsFor: 'accessing'!
signature

	^self primitiveAttributeAt: 'signature'
! !

!MaObjectFiler methodsFor: 'building'!
allLargeCollectionsLoid: anInteger

	self
		primitiveAttributeAt: 'allLargeCollectionsLoid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'building'!
anchorLoid: anInteger

	^self
		primitiveAttributeAt: 'anchorLoid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'building'!
classDefinitionsLoid: anInteger

	self
		primitiveAttributeAt: 'classDefinitionsLoid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'building'!
classesSetLoid: anInteger

	^self
		primitiveAttributeAt: 'classesSetLoid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'building'!
definitionLoid: anInteger

	^self
		primitiveAttributeAt: 'definitionLoid'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'building'!
memory: aMaIntervalCollection

	memory _ aMaIntervalCollection
! !

!MaObjectFiler methodsFor: 'private actions' stamp: 'cmm 2/16/2002 16:01'!
append: aMaObjectBuffer to: aMaSerializedGraphBuffer withDataAt: filePositionInteger

	| physicalSize startPos |

	startPos _ aMaSerializedGraphBuffer bufferSize.
	self
		ensureByteArrayIn: aMaObjectBuffer
		and: aMaSerializedGraphBuffer
		canAccomodate: self trackSize + MaAbstractObjectBuffer addressSize
		bytesFrom: startPos + 1.
	self
		read: self trackSize
		bytesInto: aMaObjectBuffer
		startingAt: startPos
		filePosition: filePositionInteger.
	"See if we have read enough, if not read the rest of the buffer."
	(physicalSize _ aMaObjectBuffer physicalSize) > self trackSize
		ifTrue:
			[ self
				ensureByteArrayIn: aMaObjectBuffer
				and: aMaSerializedGraphBuffer
				canAccomodate: physicalSize
				bytesFrom: startPos.
			self file
				next: physicalSize - self trackSize
				into: aMaSerializedGraphBuffer byteArray
				startingAt: startPos + self trackSize + aMaObjectBuffer bufferPositionOfBytesToStore ].
	aMaSerializedGraphBuffer increaseBufferSizeBy: physicalSize
! !

!MaObjectFiler methodsFor: 'private actions'!
deallocateSpaceForBufferWithLoid: anInteger

	| filePointer |

	self memory
		removeFrom: ((filePointer _ self filePointerForLoid: anInteger) - 1)
		to: filePointer + (self physicalSizeOfObjectAt: filePointer) - 1
! !

!MaObjectFiler methodsFor: 'private actions' stamp: 'cmm 7/15/2002 23:40'!
ensureByteArrayIn: aMaObjectBuffer and: aMaSerializedGraphBuffer canAccomodate: anInteger bytesFrom: startPos

	(startPos + anInteger) > aMaObjectBuffer byteArray size
		ifTrue:
			[ | bigByteArray beforeSize afterSize |
			beforeSize _ aMaObjectBuffer byteArray size.
			afterSize _ aMaObjectBuffer byteArray size * 2.
self maMarked: 'dev'.  "Need to signal inefficiency warning exceptions.."
"			Inefficiency signal:
				'Had to grow server byteArray from ' , beforeSize printString , ' to ' ,
					afterSize printString."
			bigByteArray _ ByteArray new: afterSize.
			bigByteArray
				replaceFrom: 1
				to: beforeSize
				with: aMaSerializedGraphBuffer byteArray
				startingAt: 1.
			aMaObjectBuffer byteArray: bigByteArray.
			aMaSerializedGraphBuffer byteArray: bigByteArray ]
! !

!MaObjectFiler methodsFor: 'private actions' stamp: 'cmm 7/17/2002 22:37'!
moveBuffer: aMaSerializedObjectBuffer

	^self
		deallocateSpaceForBufferWithLoid: aMaSerializedObjectBuffer loid;
		allocateSpaceForBuffer: aMaSerializedObjectBuffer
! !

!MaObjectFiler methodsFor: 'private actions'!
primitiveAttributeAt: aString put: anInteger

	| assoc |

	self
		uint: (assoc _ self primitiveAttributeAddressesMap at: aString) value
		at: assoc key
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private actions' stamp: 'cmm 1/27/2002 22:55'!
read: numberOfBytes bytesInto: aMaObjectBuffer startingAt: byteArrayStartPos filePosition: anInteger
	"byteArrayStartPos is 1-based"

	self file
		maRead: numberOfBytes
		bytesFromPosition: byteArrayStartPos + aMaObjectBuffer bufferPositionOfBytesToStore
		of: aMaObjectBuffer byteArray
		atFilePosition: anInteger
! !

!MaObjectFiler methodsFor: 'private actions'!
signature: anInteger

	self
		primitiveAttributeAt: 'signature'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private actions'!
uint: bits at: filePointer put: anInteger

	| ba bytes |

	ba _ self usedByteArray: (bytes _ bits / 8).
	ba
		uint: bits
		at: 0
		put: anInteger.
	self file
		maWrite: bytes
		bytesFromPosition: 1
		of: ba
		atFilePosition: filePointer
! !

!MaObjectFiler methodsFor: 'private actions' stamp: 'cmm 1/27/2002 22:56'!
write: aMaObjectBuffer at: filePosition
	"Note that the loid is stored in the loidToFilePositions map, so there is no need to store it in the data file too.  The loid is the first 8-bytes of the buffer."

	self file
		maWrite: aMaObjectBuffer numberOfBytesToStore
		bytesFromPosition:
			aMaObjectBuffer startPos + aMaObjectBuffer bufferPositionOfBytesToStore
		of: aMaObjectBuffer byteArray
		atFilePosition: filePosition
! !

!MaObjectFiler methodsFor: 'actions'!
appendObject: loidInteger into: aMaSerializedGraphBuffer
	"Read a single object into aMaSerializedGraphBuffers
	byteArray and adjust its bufferSize accordingly."

	| buffer |

	preMadeObjectBuffer
		byteArray: aMaSerializedGraphBuffer byteArray;
		startPos: aMaSerializedGraphBuffer bufferSize.
	self
		append: preMadeObjectBuffer
		to: aMaSerializedGraphBuffer
		withDataAt: (self filePointerForLoid: loidInteger).
	buffer _ preMadeObjectBuffer asSentientBuffer.
	"Set oid only after append because that is where the need for growth is checked."
	buffer oid: loidInteger.
	^buffer
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 6/23/2002 11:14'!
close

	self file ifNotNil:
		[ file close.
		file _ nil ].
	filePositionIndex ifNotNil:
		[ filePositionIndex close.
		filePositionIndex _ nil ]
! !

!MaObjectFiler methodsFor: 'actions'!
finalize

	self close
! !

!MaObjectFiler methodsFor: 'actions'!
index: loidInteger at: filePositionInteger

	^filePositionIndex
		at: (MaOidCalculator indexPositionForLoid: loidInteger)
		put: filePositionInteger
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 7/16/2002 00:01'!
validateSignature

	self signature = MaObjectRepository recognitionSignature
		ifFalse:
			[ MagmaUserError signal: 'This does not appear to be a Magma database.' ]
! !

!MaObjectFiler methodsFor: 'actions' stamp: 'cmm 7/16/2002 21:55'!
validateVersion

	self version = MagmaSession magmaVersion
		ifFalse:
			[ MagmaUserError signal: 'This database requires code version ', self version printString, '.  You are running version ', MagmaSession magmaVersion printString ]! !

!MaObjectFiler methodsFor: 'actions'!
write: aMaObjectBuffer index: aBoolean
	"write a single object encapsulated by aMaObjectBuffer."

	| filePosition |

	filePosition _
		aBoolean
			ifTrue:
				[ self
					index: aMaObjectBuffer oid
					at: (self allocateSpaceForBuffer: aMaObjectBuffer) ]
			ifFalse:
				[ aMaObjectBuffer didGrow
					ifTrue:
						[ self
							index: aMaObjectBuffer oid
							at: (self moveBuffer: aMaObjectBuffer) ]
					ifFalse:
						[ self filePointerForLoid: aMaObjectBuffer loid ] ].
	self
		write: aMaObjectBuffer
		at: filePosition
! !

!MaObjectFiler methodsFor: 'private initializing' stamp: 'cmm 7/16/2002 00:07'!
initialize

	super initialize.
	preMadeObjectBuffer _ MaObjectBuffer new.
	usedByteArrays _ (1 to: 8) collect: [ :each | ByteArray new: each ]! !

!MaObjectFiler methodsFor: 'private creation'!
create: aMaFilename

	self
		filename: aMaFilename;
		createDataFile;
		createFilePositionIndex.
	^self
! !

!MaObjectFiler methodsFor: 'private creation' stamp: 'cmm 7/15/2002 23:50'!
createDataFile

	(FileStream concreteStream isAFileNamed: self dataFileName)
		ifTrue:
			[ MagmaUserError signal: self dataFileName, ' already exists.' ].
	self file: (
		FileStream concreteStream new
			open: self dataFileName
			forWrite: true) binary.
	file
		next: self class sizeOfEmptyRepository
		putAll: (ByteArray new: self class sizeOfEmptyRepository)
		startingAt: 1.
	self
		classesSetLoid: MaOidCalculator oidForNil;
		classDefinitionsLoid: MaOidCalculator oidForNil;
		allLargeCollectionsLoid: MaOidCalculator oidForNil;
		definitionLoid: MaOidCalculator oidForNil;
		signature: MaObjectRepository recognitionSignature;
		version: MagmaSession magmaVersion! !

!MaObjectFiler methodsFor: 'private creation'!
createFilePositionIndex

	filePositionIndex _
		MaLargeCollectionOfIntegers
			create: self filePositionIndexFileName
			bitSize: 64
! !

!MaObjectFiler methodsFor: 'private accessing'!
file

	^file
! !

!MaObjectFiler methodsFor: 'private accessing'!
memory

	^memory
! !

!MaObjectFiler methodsFor: 'private accessing'!
pointerToContiguousBytes: anInteger
	"Answer a pointer free space of size anInteger or greater."

	| nextBest positionOfNextBest |

	nextBest _ MaPositive infinity.
	^(memory
		gapsDetect:
			[ :eachFrom :eachTo | | eachSize |
			eachSize _ eachTo - eachFrom.
			eachSize >= anInteger
				ifTrue:
					[ (eachSize < nextBest and:
						[ eachSize >=
							MaNormalObjectBuffer
								headerSize "don't create a hole smaller than the header size since it could never be used." ])
									ifTrue:
										[ nextBest _ eachSize.
										positionOfNextBest _ eachFrom ] ].
			eachSize = anInteger ]
		ifFound: [ :foundFrom :foundTo | foundFrom ]
		ifNone:
			[ positionOfNextBest isNil
				ifTrue:
					[ "if no empty spaces large enough found" memory highest ]
				ifFalse:
					[ positionOfNextBest ] ]) + 1
! !

!MaObjectFiler methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 00:04'!
primitiveAttributeAddressesMap
	self maMarked: 'performance'.  "All constants, could be cached.  Called for every new client connection.."
	^Dictionary new
		at: 'signature' put: (Association key: 0 value: 64);
		at: 0 put: 'signature';
		at: 'version' put: (Association key: 8 value: 16);
		at: 2 put: 'version';
		at: 'booleanFlags' put: (Association key: 10 value: 8);
		at: 10 put: 'booleanFlags';
		at: 'definitionLoid' put: (Association key: 11 value: 64);
		at: 11 put: 'definitionLoid';
		at: 'classesSetLoid' put: (Association key: 19 value: 64);
		at: 19 put: 'classesSetLoid';
		at: 'classDefinitionsLoid' put: (Association key: 27 value: 64);
		at: 27 put: 'classDefinitionsLoid';
		at: 'allLargeCollectionsLoid' put: (Association key: 35 value: 64);
		at: 35 put: 'allLargeCollectionsLoid';
		at: 'anchorLoid' put: (Association key: 43 value: 64);
		at: 43 put: 'anchorLoid';
		yourself
! !

!MaObjectFiler methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 00:04'!
trackSize
	"This is the minimum number of bytes to read from disk for any object.
	This particular value allows up to 32 instVars to be read at once."

	self maMarked: 'performance'.	"Constant value that can be cached."
	^MaAbstractObjectBuffer addressSize * 32 + MaNormalObjectBuffer headerSize! !

!MaObjectFiler methodsFor: 'private accessing'!
uint: bits at: anInteger

	| address bytes |

	address _ self usedByteArray: (bytes _ bits / 8).
	self file
		maRead: bytes
		bytesFromPosition: 1
		of: address
		atFilePosition: anInteger.
	^address
		uint: bits
		at: 0
! !

!MaObjectFiler methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 00:08'!
usedByteArray: size

	^usedByteArrays at: size
! !

!MaObjectFiler methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 21:53'!
version

	^self primitiveAttributeAt: 'version'! !

!MaObjectFiler methodsFor: 'private accessing' stamp: 'cmm 7/16/2002 21:53'!
version: anInteger

	self
		primitiveAttributeAt: 'version'
		put: anInteger
! !

!MaObjectFiler methodsFor: 'private building'!
file: aFileStream

	file _ aFileStream
! !

!MaObjectFiler methodsFor: 'private building'!
filename: aMaFilename

	filename _ aMaFilename
! !


!MaObjectFiler class methodsFor: 'creation'!
create: aMaFilename

	^self new create: aMaFilename
! !

!MaObjectFiler class methodsFor: 'creation'!
open: aMaFilename

	^self new
		filename: aMaFilename;
		open
! !

!MaObjectFiler class methodsFor: 'accessing'!
dataFileFileExtension

	^'magma'
! !

!MaObjectFiler class methodsFor: 'accessing'!
filePositionIndexFileExtension

	^'idx'
! !

!MaObjectFiler class methodsFor: 'accessing'!
sizeOfEmptyRepository
	"Answer in bytes."

	^1024
! !


!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 6/25/2002 22:54'!
abortTransactionFor: sessionId

	^transactionLog abortTransactionEntryFor: sessionId
! !

!MaObjectRepository methodsFor: 'actions'!
assignPermanentLoidFor: aMaObjectBuffer mapUsing: aDictionary andAddNewObjectLoidTo: aSet
	"aMaObjectBuffer is going to written very soon,
	however, none of its loids are permanent (they are all > newOidMinimum).
	This method assigns and populates aDictionary with a map of the temporary
	to the permanent loids for aMaObjectBuffer 
	(not the oids they link, however) as it populates its oid."

	| newLoid |

	aMaObjectBuffer oid: (
		aDictionary
			at: aMaObjectBuffer oid
			put: (newLoid _ self getNextLoid)).
	aSet add: newLoid
! !

!MaObjectRepository methodsFor: 'actions'!
close

	filer close.
	largeCollectionManagers do: [ :each | each close ]
! !

!MaObjectRepository methodsFor: 'actions'!
open: fileNameString

	filename _ MaFilename fromString: fileNameString.
	filer _ MaObjectFiler open: filename.
	nextLoid _ filer getNextLoid.
	filer memory: self repositoryController definition memory
! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 7/23/2002 19:50'!
removeSessionFor: sessionId

	transactionLog
		removeEntryForSessionId: sessionId
		ifAbsent: [ "don't think this can happen" ]! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 7/16/2002 00:10'!
requestClientRefresh: aMaTransactionLogEntry
	"The aMaTransactionLogEntry for a client has exceeded the maximumNumberOfChallengers.  Initially, I was thinking we would somehow notify the client, but now I'm thinking a zero-tolerance for idle clients is a better policy.  Still thinking about it.."

	self maMarked: 'dev'

! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 6/25/2002 22:54'!
submitAll: aMaCommitPackage for: sessionId
	"Save all of the serialized objects in aMaCommitPackage to the repository.
	If any of the objects in aMaCommitPackage have been changed by other transactions
	signal a commit failure."

	| entry |
	"Make sure system connection doesn't exceed maximumNumberOfChallengers"
	((transactionLog isLastEntryFor: self repositoryController sessionId)
		and: [ sessionId ~= self repositoryController sessionId ])
			ifTrue:
				[ self repositoryController refreshView ].
	entry _
		self
			commitEntryFor: aMaCommitPackage
			session: sessionId.
	entry result hasConflicts
		ifFalse:
			[ self
				writeAll: aMaCommitPackage
				recordPermenantLoidsInResultFor: entry ].
	^entry result
! !

!MaObjectRepository methodsFor: 'actions' stamp: 'cmm 7/17/2002 22:22'!
writeMemory

	| graphBuffer newBufferSize |

	newBufferSize _ nil.
	graphBuffer _ self serverSerializer serializeGraph: filer memory intervals.
	"There should only be one buffer, unless our file size is into LargeIntegers yet."
	graphBuffer buffersDo:
		[ :each |
		filer
			write: each
			index: false.
		(newBufferSize isNil and: [ each didGrow ])
			ifTrue:
				[ newBufferSize _ each physicalSize ] ].
	newBufferSize
		notNil "The memory grew, that means writing it out caused IT to change, so it must be written again."
			ifTrue:
				[ self serverSerializer
					physicalBufferSizeFor: filer memory intervals
					is: newBufferSize.
				self writeMemory ].
	self session dontRefresh: filer memory intervals
! !

!MaObjectRepository methodsFor: 'private accessing' stamp: 'cmm 3/30/2002 21:00'!
allLargeCollectionsByteArray
	"When initially creating the repository, before even the system root is
	written, the allLargeCollectionsOid will be a new-object oid."

	| loid |

	^MaOidCalculator oidForNil = (loid _ filer allLargeCollectionsLoid)
		ifTrue:
			[ self serverSerializer
				serializeGraph: self repositoryController definition allLargeCollections.
			self serverSerializer graphBuffer trimFat.
			self serverSerializer byteArray ]
		ifFalse:
			[ self
				byteArrayAt: loid
				using: MaBasicReadStrategy deep "we need it all" ]
! !

!MaObjectRepository methodsFor: 'private accessing' stamp: 'cmm 7/3/2002 00:04'!
collectionManagerFor: oidInteger

	^largeCollectionManagers
		at: oidInteger
		ifAbsent:
			[ MaHardwareError signal:
				'LargeCollection ' , oidInteger printString ,
					' not found.  MaObjectRepository>>collectionManagerFor:' ]
! !

!MaObjectRepository methodsFor: 'private accessing' stamp: 'cmm 6/25/2002 22:54'!
connections

	^transactionLog connections
! !

!MaObjectRepository methodsFor: 'private accessing'!
getNextLoid

	^nextLoid _ nextLoid + 1
! !

!MaObjectRepository methodsFor: 'private accessing' stamp: 'cmm 4/2/2002 23:10'!
graphBufferAt: loidInteger using: aMaReadStrategy
	"Answers a MaSerializedGraphBuffer."

	| buffer |

	self serverSerializer resetByteArray.
	buffer _ self appendObjectWithLoid: loidInteger.
	buffer
		appendGraphUsing: aMaReadStrategy
		forRepository: self.
	^self serverSerializer graphBuffer
! !

!MaObjectRepository methodsFor: 'private accessing' stamp: 'cmm 6/25/2002 22:55'!
hasConnections

	^transactionLog hasEntries
! !

!MaObjectRepository methodsFor: 'private accessing' stamp: 'cmm 3/30/2002 21:05'!
serverSerializer

	^self repositoryController serverSerializer
! !

!MaObjectRepository methodsFor: 'private accessing'!
session

	^self repositoryController session
! !

!MaObjectRepository methodsFor: 'private accessing'!
sessionId

	^self repositoryController sessionId
! !

!MaObjectRepository methodsFor: 'private accessing'!
transactionLog

	^transactionLog! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 3/30/2002 21:00'!
anchorByteArrayUsing: aMaReadStrategy

	| anchorLoid |

	^MaOidCalculator oidForNil = (anchorLoid _ filer anchorLoid)
		ifTrue:
			[ self serverSerializer serializeGraph: MaRootAnchor new.
			self serverSerializer graphBuffer trimFat.
			self serverSerializer byteArray ]
		ifFalse:
			[ self
				byteArrayAt: anchorLoid
				using: aMaReadStrategy ]
! !

!MaObjectRepository methodsFor: 'accessing'!
byteArrayAt: loidInteger using: aMaReadStrategy
	"Do we really need to copy the byteArray each time (via trimFat)?  Or can we transmit from:to: two positions?"

	self maMarked: 'performance'.
	^(self
		graphBufferAt: loidInteger
		using: aMaReadStrategy)
			trimFat;
			byteArray
! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 3/30/2002 21:01'!
classDefinitionsByteArray
	"When initially creating the repository, before even the system root is
	written, the classDefinitionsLoid will be a new-object oid."

	| loid |

	^MaOidCalculator oidForNil = (loid _ filer classDefinitionsLoid)
		ifTrue:
			[ self serverSerializer serializeGraph: self repositoryController definition classDefinitions.
			self serverSerializer graphBuffer trimFat.
			self serverSerializer byteArray ]
		ifFalse:
			[ self
				byteArrayAt: loid
				using: MaBasicReadStrategy deep "we need it all" ]
! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 3/30/2002 21:00'!
classesSetByteArray
	"When initially creating the repository, before even the system root is
	written, the classesSetOid will be a new-object oid."

	| loid |

	^MaOidCalculator oidForNil = (loid _ filer classesSetLoid)
		ifTrue:
			[ self serverSerializer serializeGraph: self repositoryController definition classesSet.
			self serverSerializer graphBuffer trimFat.
			self serverSerializer byteArray ]
		ifFalse:
			[ self
				byteArrayAt: loid
				using: MaBasicReadStrategy deep "we need it all" ]
! !

!MaObjectRepository methodsFor: 'accessing'!
collectionFilenameFor: oidInteger
	"No performance issue here because this is only
	called to open or create."

	^((MaFilename fromString: filename asString)
		path: filename path;
		baseComponent: oidInteger printString;
		extension: MaHashIndex suggestedFileExtension)
			asString
! !

!MaObjectRepository methodsFor: 'accessing' stamp: 'cmm 3/30/2002 21:01'!
definitionByteArray

	| loid |

	^MaOidCalculator oidForNil = (loid _ filer definitionLoid)
		ifTrue:
			[ self serverSerializer serializeGraph: self repositoryController definition.
			self serverSerializer graphBuffer trimFat.
			self serverSerializer byteArray ]
		ifFalse:
			[ self
				byteArrayAt: loid
				using: MaBasicReadStrategy deep "we need it all" ]
! !

!MaObjectRepository methodsFor: 'accessing'!
filename

	^filename! !

!MaObjectRepository methodsFor: 'accessing'!
filer

	^filer
! !

!MaObjectRepository methodsFor: 'accessing'!
largeCollectionManagers

	^largeCollectionManagers! !

!MaObjectRepository methodsFor: 'accessing'!
name
	^self repositoryController name! !

!MaObjectRepository methodsFor: 'accessing'!
repositoryController

	^repositoryController
! !

!MaObjectRepository methodsFor: 'private building' stamp: 'cmm 3/30/2002 20:59'!
appendObjectWithLoid: anInteger

	^filer
		appendObject: anInteger
		into: self serverSerializer graphBuffer
! !

!MaObjectRepository methodsFor: 'private building'!
establishLinksToNewObjectsIn: aMaCommitPackage using: newOidToPermanentOidMap
	"Update all new-object oids in aMaCommitPackage
	with their permanent counter-part.  newOidToPermanentOidMap has an entry for
	them all."

	aMaCommitPackage objectsDo:
		[ :eachBuffer |
		eachBuffer isNormalObjectBuffer
			ifTrue:
				[ eachBuffer instVarsDoWithIndex:
					[ :oid :index |
					(MaOidCalculator isOidForNewObject: oid)
						ifTrue:
							[ eachBuffer
								maInstVarAt: index
								put: (newOidToPermanentOidMap at: oid) ] ] ] ]
! !

!MaObjectRepository methodsFor: 'private actions' stamp: 'cmm 4/21/2002 23:08'!
assignPermanentLoidsIn: aMaCommitPackage andAddNewObjectLoidsTo: aSet

	| tempToPermLoidsMap |

	tempToPermLoidsMap _ Dictionary new: 50.
	aMaCommitPackage newObjectsDo:
		[ :eachBuffer |
		self
			assignPermanentLoidFor: eachBuffer
			mapUsing: tempToPermLoidsMap
			andAddNewObjectLoidTo: aSet ].
	^tempToPermLoidsMap
! !

!MaObjectRepository methodsFor: 'private actions' stamp: 'cmm 6/25/2002 22:54'!
commitEntryFor: aMaCommitPackage session: sessionId

	^transactionLog
		commitObjectsIn: aMaCommitPackage
		for: sessionId
		using: largeCollectionManagers
! !

!MaObjectRepository methodsFor: 'private actions'!
linkNewObjectsIn: aMaCommitPackage recordPermenantLoidsUsing: aMaCommitResult
	"Some of the objects in each graphBuffers object buffers are new objects.
	These need to be assigned a permanent loid and all of the objects that reference them
	need to have their references updated to reflect the new permanent loid."

	| newObjects tempToPermanentLoidsMap |

	tempToPermanentLoidsMap _
		self
			assignPermanentLoidsIn: aMaCommitPackage
			andAddNewObjectLoidsTo: (newObjects _ Set new: 100).
	self
		establishLinksToNewObjectsIn: aMaCommitPackage
		using: tempToPermanentLoidsMap.
	aMaCommitResult permanentLoids: tempToPermanentLoidsMap.
	^newObjects
! !

!MaObjectRepository methodsFor: 'private actions'!
updateLargeCollectionsIn: aMaCommitPackage recordResultsIn: aMaCommitResult
	"The repositoryControllers sessions view of the repository must be
	completely refreshed, it must know about all new collections."

	aMaCommitPackage allLargeCollectionChangesDo:
		[ :each |
		each isNewCollection
			ifTrue:
				[ | permanentLoid |
				permanentLoid _ aMaCommitResult permanentLoids at: each collectionLoid.
				self createNewLargeCollection: permanentLoid.
				each collectionLoid: permanentLoid ].
		(self collectionManagerFor: each collectionLoid)
			process: each
			recordResultsIn: aMaCommitResult ]
! !

!MaObjectRepository methodsFor: 'private actions'!
writeAll: aMaCommitPackage recordPermenantLoidsInResultFor: aMaCommitLogEntry

	| newObjectLoids |

	newObjectLoids _
		self
			writeObjectsIn: aMaCommitPackage
			recordPermenantLoidsIn: aMaCommitLogEntry result.
	aMaCommitLogEntry
		recordSuccessfullyCommittedIn: aMaCommitPackage
		using: newObjectLoids.
	aMaCommitPackage shouldServerRefresh ifTrue: [ self repositoryController refreshView ].
	self
		updateLargeCollectionsIn: aMaCommitPackage
		recordResultsIn: aMaCommitLogEntry result
! !

!MaObjectRepository methodsFor: 'private actions' stamp: 'cmm 4/4/2002 23:51'!
writeObjectsIn: aMaCommitPackage recordPermenantLoidsIn: aMaCommitResult

	| newObjectsLoids |

	newObjectsLoids _
		self
			linkNewObjectsIn: aMaCommitPackage
			recordPermenantLoidsUsing: aMaCommitResult.
	aMaCommitPackage objectsDo:
		[ :eachBuffer |
		filer
			write: eachBuffer
			index: (newObjectsLoids includes: eachBuffer oid) ].
	"When creating a repository, the memory will be a new object.  When so, it can't be written because proper filePositionIndex positions can only be calculated on *permanent* loids, not new-object loids.."
	(MaOidCalculator isOidForNewObject: (self session oidFor: filer memory))
		ifFalse:
			[ self writeMemory ].
	^newObjectsLoids
! !

!MaObjectRepository methodsFor: 'private creation'!
create: aMaFilename

	filename _ aMaFilename.
	filer _ (MaObjectFiler create: aMaFilename)
		memory: self repositoryController definition memory.
	nextLoid _ filer getNextLoid.
	^self
! !

!MaObjectRepository methodsFor: 'private creation' stamp: 'cmm 3/4/2002 21:48'!
createLcMemberIndex: loidInteger
	"Create and then close.  There is some initialization that needs to occur when opening."

	(MaHashIndex
		create: (self collectionFilenameFor: loidInteger)
		keySize: 64
		hashRecordSize: 100) close
! !

!MaObjectRepository methodsFor: 'private creation'!
createNewLargeCollection: loidInteger

	self createLcMemberIndex: loidInteger.
	self repositoryController openLargeCollections
! !

!MaObjectRepository methodsFor: 'private initializing' stamp: 'cmm 4/21/2002 23:08'!
initialize

	super initialize.
	transactionLog _ MaTransactionLog new.
	largeCollectionManagers _ Dictionary new
! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 6/25/2002 22:55'!
newSessionFor: userIdString numberOfChallengers: anInteger
	"Answer an Association whose key is the session id, value is the classMap
	array for that session."

	| id |

	id _
		transactionLog
			newSessionFor: userIdString
			numberOfChallengers: anInteger.
	^(Array new: 4)
		at: 1
			put: id;
		at: 2
			put: self classesSetByteArray;
		at: 3
			put: self classDefinitionsByteArray;
		at: 4
			put: self allLargeCollectionsByteArray;
		yourself
! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 6/25/2002 22:54'!
newTransactionFor: sessionIdInteger

	^transactionLog newTransactionFor: sessionIdInteger
! !

!MaObjectRepository methodsFor: 'building' stamp: 'cmm 3/30/2002 21:22'!
openLargeCollectionIfNecessary: aMagmaCollection

	largeCollectionManagers
		at: (self session oidFor: aMagmaCollection)
		ifAbsentPut:
			[ (MaLargeCollectionManager
				collection: aMagmaCollection
				repository: self
				oidOfIndexesCollection: (self session oidFor: aMagmaCollection indexes))
					open ]
! !

!MaObjectRepository methodsFor: 'building'!
repositoryController: aMaRepositoryController

	repositoryController _ aMaRepositoryController.
	aMaRepositoryController repository == self ifFalse: [ aMaRepositoryController repository: self ]
! !

!MaObjectRepository methodsFor: 'building'!
setFilerMemory: aMaIntervalCollection

	filer memory: aMaIntervalCollection
! !


!MaObjectRepository class methodsFor: 'creation'!
create: fileNameString controller: aMaRepositoryController

	^(self new repositoryController: aMaRepositoryController)
		create: (MaFilename fromString: fileNameString)
! !

!MaObjectRepository class methodsFor: 'creation'!
open: systemRepositoryFileName controller: aMaRepositoryController

	^self new
		repositoryController: aMaRepositoryController;
		open: systemRepositoryFileName
! !

!MaObjectRepository class methodsFor: 'accessing'!
recognitionSignature

	^5191969
! !


!MaRepositoryRequest methodsFor: 'actions'!
process
	"Any persistent objects returned by this should be materialized only by the sessions
	serializer, not the repositoryLink's serializer because the sessions serializer is what
	works with the transaction to mark it read so changes can be detected."

	self subclassResponsibility
! !


!MaAbortTransactionRequest methodsFor: 'actions'!
process

	^self repositoryController abortTransactionFor: self sessionId
! !


!MaAbstractReadRequest methodsFor: 'actions'!
process

	self subclassResponsibility
! !


!MaAnchorRequest methodsFor: 'actions'!
process

	^self repositoryController anchorBufferUsing: self readStrategy
! !


!MaLargeCollectionSizeRequest methodsFor: 'actions'!
process

	^self repositoryController sizeOfLargeCollection: self collectionOid
! !


!MaKeyIntervalInfoRequest methodsFor: 'actions'!
process

	^self repositoryController
		numberOfEntriesFrom: self lowKey
		to: self highKey
		inLargeCollection: self collectionOid
		on: self attribute
! !


!MaReadRequest methodsFor: 'actions'!
process

	^self repositoryController
		byteArrayAt: self oid
		using: self readStrategy
! !


!MaRepositoryConnectionRequest methodsFor: 'actions' stamp: 'cmm 2/16/2002 16:03'!
process

	^self repositoryController
		newSessionFor: self userId
		numberOfChallengers: self maximumNumberOfChallengers
! !


!MaRepositoryDisconnectRequest methodsFor: 'actions'!
process

	^self repositoryController disconnect: self sessionId
! !


!MaSegmentByIndexRequest methodsFor: 'actions'!
process

	^self repositoryController
		upTo: self quantity
		oidsFromIndex: self lowIndex
		inLargeCollection: self collectionLoid
		on: self attribute
		using: self readStrategy
! !


!MaSegmentByKeyRequest methodsFor: 'actions'!
process

	^self repositoryController
		upTo: self quantity
		oidsFrom: self lowKey
		to: self highKey
		inLargeCollection: self collectionLoid
		on: self attribute
		using: self readStrategy
! !


!MaTransactionLog methodsFor: 'actions'!
abortTransactionEntryFor: sessionIdInteger

	^(self
		renewEntryFor: sessionIdInteger
		withNew: MaTransactionLogEntry
		ifAbsent: [ self signalLostSession: sessionIdInteger ])
			result
! !

!MaTransactionLog methodsFor: 'private building' stamp: 'cmm 3/3/2002 19:00'!
challengeEntriesWith: aMaCommitLogEntry
	"We record all objects that were committed to all the entries in the receiver.
	Some of the entries are in transaction, some are not.  The ones that are will
	use aMaCommitLogEntry to verify their commit has no conflicts with this entry.
	The ones that are not will use the result of the receiver to know which objects
	need refreshed."

	entries do:
		[ :each |
		(each isForSameSessionAs: aMaCommitLogEntry)
			ifFalse:
				[ each addChallengingEntry: aMaCommitLogEntry.
				each hasExcessiveNumberOfChallengers
					ifTrue:
						[ self repository requestClientRefresh: each connection ] ] ]
! !

!MaTransactionLog methodsFor: 'private building'!
renewEntryFor: sessionIdInteger withNew: aClass ifAbsent: aBlock
	"aClass should be either MaTransactionLogEntry or MaCommitLogEntry"

	| entry |

	entry _ (self
		removeEntryForSessionId: sessionIdInteger
		ifAbsent: [ ^aBlock value ]).
	entry recordAllChangedObjects.
	entries add: (aClass connection: entry result connection).
	^entry
! !

!MaTransactionLog methodsFor: 'building'!
commitObjectsIn: aMaCommitPackage for: sessionIdInteger using: lcManagersDictionary

	| entry |

	entry _
		self
			renewEntryFor: sessionIdInteger
			withNew: MaTransactionLogEntry
			ifAbsent: [ self signalLostSession: sessionIdInteger ].
	entry isCommitEntry ifFalse: [ self signalAttemptToCommitOutsideOfTransaction ].
	(entry
		determineResultFor: aMaCommitPackage
		using: lcManagersDictionary)
			hasConflicts
				ifFalse:
					[ self challengeEntriesWith: entry ].
	^entry
! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 6/26/2002 00:21'!
newSessionFor: userIdString numberOfChallengers: anInteger

	| id |

	entries add: (
		MaTransactionLogEntry connection: (
			MagmaClientConnection
				userId: userIdString
				sessionId: (id _ self nextAvailableSessionId)
				maximumNumberOfChallengers: anInteger)).
	^id
! !

!MaTransactionLog methodsFor: 'building'!
newTransactionFor: sessionIdInteger

	^(self
		renewEntryFor: sessionIdInteger
		withNew: MaCommitLogEntry
		ifAbsent: [ self signalLostSession: sessionIdInteger ])
			result
! !

!MaTransactionLog methodsFor: 'building' stamp: 'cmm 2/11/2002 00:56'!
removeEntryForSessionId: sessionId ifAbsent: aBlock

	| index |

	^(index _ self indexOfEntryWithSessionId: sessionId) = 0
		ifTrue:
			[ aBlock value ]
		ifFalse:
			[ entries removeAt: index ]
! !

!MaTransactionLog methodsFor: 'accessing'!
connections

	^entries collect: [ :each | each connection ]
! !

!MaTransactionLog methodsFor: 'testing'!
hasEntries

	^entries notEmpty
! !

!MaTransactionLog methodsFor: 'testing'!
isLastEntryFor: sessionId

	^entries notEmpty and: [ entries last connection sessionId = sessionId ]
! !

!MaTransactionLog methodsFor: 'private accessing'!
indexOfEntryWithSessionId: sessionId

	entries doWithIndex: [ :each :index | each sessionId = sessionId ifTrue: [ ^index ] ].
	^0
! !

!MaTransactionLog methodsFor: 'private initializing'!
initialize

	super initialize.
	"An OrderedCollection of MaCommitLogEntrys and MaTransactionLogEntrys.."
	entries _ OrderedCollection new
! !

!MaTransactionLog methodsFor: 'creation'!
nextAvailableSessionId

	^(entries
		inject: 0
		into: [ :highest :each | highest max: each sessionId ]) + 1
! !

!MaTransactionLog methodsFor: 'private actions' stamp: 'cmm 5/1/2002 23:19'!
signalAttemptToCommitOutsideOfTransaction

	MagmaUserError signal: 'No transaction to commit.'
! !

!MaTransactionLog methodsFor: 'private actions' stamp: 'cmm 5/1/2002 23:00'!
signalLostSession: anInteger

	MagmaUserError signal:
		'Session ' , anInteger printString , ' timed out.  Please reconnect.'
! !


!MaTransactionLogEntry methodsFor: 'building'!
addChallengingEntry: aMaCommitLogEntry

	self challengingEntries add: aMaCommitLogEntry
! !

!MaTransactionLogEntry methodsFor: 'building'!
connection: aMagmaClientConnection

	self result connection: aMagmaClientConnection
! !

!MaTransactionLogEntry methodsFor: 'private accessing'!
challengingEntries

	^challengingEntries! !

!MaTransactionLogEntry methodsFor: 'private accessing'!
result

	^result! !

!MaTransactionLogEntry methodsFor: 'accessing'!
connection

	^self result connection
! !

!MaTransactionLogEntry methodsFor: 'accessing'!
recordAllChangedObjects
	"Record all of the objects that the client will need to refresh."

	self challengingEntries do: [ :each | self result addToBeRefreshed: each committed ]
! !

!MaTransactionLogEntry methodsFor: 'accessing'!
sessionId

	^self result sessionId
! !

!MaTransactionLogEntry methodsFor: 'accessing'!
startTime

	^self result startTime
! !

!MaTransactionLogEntry methodsFor: 'testing'!
hasExcessiveNumberOfChallengers

	^self challengingEntries size > self connection maximumNumberOfChallengers
! !

!MaTransactionLogEntry methodsFor: 'testing'!
isCommitEntry

	^false
! !

!MaTransactionLogEntry methodsFor: 'testing' stamp: 'cmm 3/3/2002 19:00'!
isForSameSessionAs: aMaTransactionLogEntry

	^self connection == aMaTransactionLogEntry connection
! !

!MaTransactionLogEntry methodsFor: 'private initializing'!
initialize
	"of MaTransactionLogEntries or MaCommitLogEntries that challenge me."

	super initialize.
	challengingEntries _ OrderedCollection new.
	self initializeResult
! !

!MaTransactionLogEntry methodsFor: 'private initializing'!
initializeResult

	result _ MaRefreshViewResult new
! !

!MaTransactionLogEntry methodsFor: 'printing' stamp: 'cmm 4/22/2002 22:25'!
maPrintAbbreviatedOn: aStream

	aStream
		maPrint: 'session ';
		maPrint: self sessionId
! !


!MaCommitLogEntry methodsFor: 'private accessing'!
committed

	^committed! !

!MaCommitLogEntry methodsFor: 'building'!
determineResultFor: aMaCommitPackage using: lcManagersDictionary

	self
		recordLargeCollectionConflictsWith: aMaCommitPackage
			using: lcManagersDictionary;
		recordObjectConflictsIn: aMaCommitPackage.
	aMaCommitPackage shouldCheckForDirtyReads ifTrue: [ self recordDirtyReadsIn: aMaCommitPackage ].
	^self result
! !

!MaCommitLogEntry methodsFor: 'building'!
recordSuccessfullyCommittedIn: aMaCommitPackage using: newObjectLoids
	"It is too late to utilize aMaCommitPackage>>newObjectsDo: because it has
	already been assigned its permanent loids and written out.  Now we must utilize
	the newObjectLoids Set to determine which buffers are for new objects."

	aMaCommitPackage objectsDo:
		[ :eachBuffer |
		(newObjectLoids includes: eachBuffer loid)
			ifFalse:
				[ self recordSuccessfulObjectCommit:
					(eachBuffer linkRepresentationUsing: self result permanentLoids) ] ]
! !

!MaCommitLogEntry methodsFor: 'private building' stamp: 'cmm 6/26/2002 22:24'!
failResultWith: aMagmaClientConnection on: oidInteger

	result _
		self result asFailedResult
			recordObjectConflictWith: aMagmaClientConnection
			on: oidInteger
! !

!MaCommitLogEntry methodsFor: 'private building'!
recordDirtyReadsIn: aMaCommitPackage
	"Go through everyone who has challenged me.  Determine if they have changed an object
	that my client has read.  If so, my client is outta luck.."

	aMaCommitPackage readObjectsDo:
		[ :eachOid |
		self challengingEntries do:
			[ :eachEntry |
			(eachEntry hasCommitted: eachOid)
				ifTrue:
					[ self result
						recordDirtyReadWith: eachEntry connection
						on: eachOid ] ] ]
! !

!MaCommitLogEntry methodsFor: 'private building'!
recordObjectConflictsIn: aMaCommitPackage
	"Go through everyone who has challenged me.  Determine if they have a same changed
	oid that I have."

	aMaCommitPackage persistentObjectsDo:
		[ :eachObjectBuffer |
		self challengingEntries do:
			[ :eachEntry |
			(eachEntry hasCommitted: eachObjectBuffer oid)
				ifTrue:
					[ self
						failResultWith: eachEntry connection
						on: eachObjectBuffer oid ] ] ]
! !

!MaCommitLogEntry methodsFor: 'private building'!
recordSuccessfulObjectCommit: aMaObjectLink

	self committed
		at: aMaObjectLink mainOid
		put: aMaObjectLink
! !

!MaCommitLogEntry methodsFor: 'testing'!
hasCommitted: oidInteger

	^self committed includesKey: oidInteger
! !

!MaCommitLogEntry methodsFor: 'testing'!
isCommitEntry

	^true
! !

!MaCommitLogEntry methodsFor: 'private initializing'!
initialize

	super initialize.
	committed _ Dictionary new
! !

!MaCommitLogEntry methodsFor: 'private initializing'!
initializeResult

	result _ MaCommitResult new
! !

!MaCommitLogEntry methodsFor: 'private actions'!
recordLargeCollectionConflictsWith: aMaCommitPackage using: lcManagersDictionary
	"We must ensure that we do not attempt to add or remove any objects from LargeCollections
	whose index COLLECTION object has been changed by another session.  The adds and
	removes for those indexes will have incorrect hashIndex values.  We must also ensure
	that we do not attempt to remove any index from a collection that is read-only."

	aMaCommitPackage allLargeCollectionChangesDo:
		[ :eachChanges |
		"We already know at this point that eachChanges hasChanges, so no need to 
		check again.  Also, everything except adding new indexes should cause a commit
		conflict with changes in any LargeCollections 'indexes' collection.
		For simplicity and speed, we just don't allow any changes simultaneous
		with adding or removing an index (as you know, however, *bulding* the index won't
		cause a problem)."
		self challengingEntries do:
			[ :eachEntry | | collectionManager |
			collectionManager _ lcManagersDictionary at: eachChanges collectionLoid.
			(eachEntry hasCommitted: collectionManager oidOfIndexesCollection)
				ifTrue:
					[ self
						failResultWith: eachEntry connection
						on: collectionManager oidOfIndexesCollection ] ] ]
! !

!MaCommitLogEntry methodsFor: 'accessing'!
stopTime

	^self result stopTime
! !


!MaTransactionLogEntry class methodsFor: 'creation'!
connection: aMagmaClientConnection

	^self new connection: aMagmaClientConnection
! !


!MaTransactionRequest methodsFor: 'actions'!
process
	^self repositoryController newTransactionFor: self sessionId! !


!MaWriteRequest methodsFor: 'actions'!
process

	^self repositoryController
		submitAll: self package
		for: self sessionId
! !


!MagmaRepositoryController methodsFor: 'set-up / shutdown' stamp: 'cmm 6/21/2002 00:55'!
close
	"needed only if you've opened locally.  If you've started with open:processOn:until:, then you need to use one of the 'stop' methods."

	self repository close
! !

!MagmaRepositoryController methodsFor: 'set-up / shutdown'!
maximumNumberOfChallengers: anInteger 
	self session 
		commit: [self definition maximumNumberOfChallengers: anInteger]! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 6/23/2002 15:30'!
definition
	"Answers a MagmaRepositoryDefinition"

	^definition
! !

!MagmaRepositoryController methodsFor: 'accessing' stamp: 'cmm 4/29/2002 21:53'!
maximumNumberOfChallengers
	"See MaRepositoryDefinition for a definition.."

	^self definition maximumNumberOfChallengers
! !

!MagmaRepositoryController methodsFor: 'accessing'!
name

	^self definition name
! !

!MagmaRepositoryController methodsFor: 'accessing'!
name: aString
	"Set the name of your repository."

	self session commit: [ self definition name: aString ]
! !

!MagmaRepositoryController methodsFor: 'accessing'!
sessionId

	^self session id
! !

!MagmaRepositoryController methodsFor: 'class schema upgrades' stamp: 'cmm 7/16/2002 21:46'!
defaultUpgradeBlock

	self maMarked: 'dev'.
	"once VI4 is in place, we'll be able to store CompiledMethods and Blocks, which is required for the 'upgradeBlock' mechanism to work.  Until the, we store nil and just use the default block in every case."
	^nil

"	^MaUpgradeableObject defaultUpgradeBlock"
! !

!MagmaRepositoryController methodsFor: 'class schema upgrades'!
replaceUpgradeOf: aClass with: twoArgBlock
	"Use this in case you specified an incorrect upgradeBlock in upgrade:with:."

	aClass withAllSubclassesDo:
		[ :eachClass |
		self
			upgrade: eachClass
			replace: true
			using: twoArgBlock ]
! !

!MagmaRepositoryController methodsFor: 'class schema upgrades'!
upgrade: aClass with: twoArgBlock
	"Instruct Magma how to upgrade previously stored instances
	of classes whose definitions have changed (e.g., have different instVars).
	twoArgBlock tells how to upgrade the instances.  The first argument is the
	instance in its old format, represented as a MaUpgradeableObject.
	The second is the subsequent version of the class, represented as
	either a MaUpgradeableObject or the actual class (if it is the most current).

	twoArgBlock must answer the upgraded object, which is obtained by sending
	basicNew to the second argument (or basicNew: if it has indexed variables).
	The block should then populate the new instance using *only* the following
	two messages:
		maInstVarNamed: aString put: anObject  <-- sets a value of a named instVar (in the new)
		maInstVarAt:put:  <-- sets a value of a named or indexed instVar (in the new)
			The index of the first indexed instVar is one greater than the index of
			the last named instVar.

	The arguments are the names of the instance variables, as defined in their
	class definition.  Values from the previous version of the object can be obtained
	by sending *only* the following two messages to the first argument of
	twoArgBlock:

		maInstVarNamed: aString  <-- gets a value (in the old)
		maInstVarAt:  <-- gets a value from a named or  indexed instVar (in the old).

	These rules must be strictly followed, or upgrading objects that are more than
	one version back may not work correctly.

	Other messages that can be sent to the OLD object are:
		objectInstSize - the total size of the object "

	aClass withAllSubclasses do:
		[ :eachClass |
		self
			upgrade: eachClass
			replace: false
			using: twoArgBlock ]
! !

!MagmaRepositoryController methodsFor: 'class schema upgrades' stamp: 'cmm 4/18/2002 22:43'!
upgradeUsingDefaultBehavior: aClass
	"Upgrade instances of aClass in the receiver repository by populating each
	instVar with the instVars of the same name from the previous version of
	the class.  The new version of the class must be loaded in the image when
	this method is run."

	self
		upgrade: aClass
		with: self defaultUpgradeBlock
! !

!MagmaRepositoryController methodsFor: 'initializing'!
connect

	self session connectAs: self systemClientUserId.
	self loadDefinition.
	self repository setFilerMemory: self definition memory
! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 6/23/2002 15:33'!
initialize

	super initialize.
	definition _
		MagmaRepositoryDefinition new
			maximumNumberOfChallengers: 1000;
			yourself.
	session _ MagmaSession repositoryController: self.
	"ugly, but the sessions serializer needs to reference the classesSet instance as the definition.."
	self definition classesSet: session serializer classIdManager classesSet.
	self initializeServerSerializer.
	self definition addMinimumClassesForOdbmsUsing: self serverSerializer.
	isAcceptingConnections _ false
! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 3/27/2002 22:00'!
initializeServerSerializer
	"Why is this separate, 'serverSerializer' needed?  Because the session serializer requires a different traversalStrategy.  The serverSerializer needs to be able to fully serialize, to the ends of the graphs, the 'response' objects of various requests."

	serverSerializer _ self session serializer copyWithNewBuffer initializeTraversalStrategy
! !

!MagmaRepositoryController methodsFor: 'initializing' stamp: 'cmm 6/23/2002 15:34'!
loadDefinition

	definition _ self session materializeObject: self repository definitionByteArray
! !

!MagmaRepositoryController methodsFor: 'initializing'!
openLargeCollections
	"Open all indexes for all large collections."

	self definition allLargeCollections 
		do: [:each | self openLargeCollection: each]! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 7/12/2002 23:56'!
processRequest: aMaRepositoryRequest
Transcript cr; show: 'processing ', aMaRepositoryRequest printString.

	aMaRepositoryRequest repositoryController: self.
	^[ aMaRepositoryRequest process ]
		on: MagmaUserError
		do: [ :anError | anError maAsErrorMessage ]
! !

!MagmaRepositoryController methodsFor: 'client/server required methods' stamp: 'cmm 7/25/2002 23:51'!
protocol

	| answer |

	answer _ self class protocol asOrderedCollection.
	answer addAll: MaIndexDefinition allSubclasses.
	(Smalltalk includesKey: #MagmaTestCase)
		ifTrue: [ answer addAll: (Smalltalk at: #MagmaTestCase) additionalProtocolForRepositoryController; yourself ].
	^answer
! !

!MagmaRepositoryController methodsFor: 'client requests'!
abortTransactionFor: sessionId

	^self repository abortTransactionFor: sessionId
! !

!MagmaRepositoryController methodsFor: 'client requests'!
anchorBufferUsing: aMaReadStrategy
	"Answer the root object of the repository serialized into a ByteArray."

	^self repository anchorByteArrayUsing: aMaReadStrategy
! !

!MagmaRepositoryController methodsFor: 'client requests'!
byteArrayAt: loidInteger using: aMaReadStrategy

	^self repository
		byteArrayAt: loidInteger
		using: aMaReadStrategy
! !

!MagmaRepositoryController methodsFor: 'client requests'!
classDefinitionsByteArray

	^self repository classDefinitionsByteArray
! !

!MagmaRepositoryController methodsFor: 'client requests'!
connectAs: aString

	self session connectAs: aString
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 5/1/2002 22:56'!
newSessionFor: userIdString numberOfChallengers: anInteger

	| maxNumberOfChallengers |

	self validateCanCreateNewSessionForUserId: userIdString.
	(anInteger notNil and: [ anInteger > self maximumNumberOfChallengers ])
		ifTrue:
			[ MagmaUserError signal:
				self name , ' currently allows a maximum of ' ,
					self maximumNumberOfChallengers printString ,
					' challengers.  Please lower this value and try again or administrate the database to allow more.' ].
	maxNumberOfChallengers _
		anInteger isNil ifTrue: [ self maximumNumberOfChallengers ] ifFalse: [ anInteger ].
	^self repository
		newSessionFor: userIdString
		numberOfChallengers: maxNumberOfChallengers
! !

!MagmaRepositoryController methodsFor: 'client requests'!
newTransactionFor: sessionId

	^self repository newTransactionFor: sessionId
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 5/1/2002 22:55'!
numberOfEntriesFrom: lowKeyInteger to: highKeyInteger inLargeCollection: collectionOid on: attributeSymbol

	| index |

	index _
		(self largeCollectionManagerFor: collectionOid)
			indexForAttribute: attributeSymbol
			ifNone:
				[ MagmaSoftwareError signal:
					attributeSymbol , ' is not an index of large-collection with oid ' ,
						collectionOid printString , '.' ].
	^index
		numberOfEntriesFrom: lowKeyInteger
		to: highKeyInteger
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 4/30/2002 23:30'!
refreshView

	self session abort
! !

!MagmaRepositoryController methodsFor: 'client requests'!
sizeOfLargeCollection: oidInteger

	^(self largeCollectionManagerFor: oidInteger) size
! !

!MagmaRepositoryController methodsFor: 'client requests'!
submitAll: aMaCommitPackage for: sessionId

	^self repository
		submitAll: aMaCommitPackage
		for: sessionId
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 5/1/2002 22:54'!
upTo: anInteger oidsFrom: lowKey to: highKey inLargeCollection: collectionOid on: attributeSymbol using: aMaReadStrategy

	| index oids buffers |

	index _
		(self largeCollectionManagerFor: collectionOid)
			indexForAttribute: attributeSymbol
			ifNone:
				[ MagmaSoftwareError signal:
					attributeSymbol , ' is not an index of large-collection with oid ' ,
						collectionOid printString , '.' ].
	oids _
		index
			upTo: anInteger
			oidsFrom: lowKey
			to: highKey.
	buffers _
		oids collect:
			[ :each |
			self
				byteArrayAt: each
				using: aMaReadStrategy ].
	^MaSegmentRequestResult new
		objects: buffers;
		lastKnownSize: index size;
		startIndex:
			(index
				indexOfLowest: lowKey
				exactKey: false);
		indexOfHighestKey: (index indexOfHighest: highKey)
! !

!MagmaRepositoryController methodsFor: 'client requests' stamp: 'cmm 5/1/2002 22:54'!
upTo: anInteger oidsFromIndex: startIndex inLargeCollection: collectionOid on: attributeSymbol using: aMaReadStrategy

	| index safeStartIndex oids buffers |

	index _
		(self largeCollectionManagerFor: collectionOid)
			indexForAttribute: attributeSymbol
			ifNone:
				[ MagmaSoftwareError signal:
					attributeSymbol , ' is not an index of large-collection with oid ' ,
						collectionOid printString , '.' ].
	safeStartIndex _ startIndex max: 1.
	oids _
		index
			upTo: anInteger
			oidsFromIndex: safeStartIndex.
	buffers _
		oids collect:
			[ :each |
			self
				byteArrayAt: each
				using: aMaReadStrategy ].
	^MaSegmentRequestResult new
		lastKnownSize: index size;
		startIndex: safeStartIndex;
		objects: buffers;
		indexOfHighestKey: safeStartIndex + oids size - 1
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 7/18/2002 00:02'!
administer: fileNameString
	"There should be no reason to load large collections when administrating."

	[ self privateOpen: fileNameString ]
		on: MagmaClassConflictNotification
		do: [ :notification | notification resume ]
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 4/4/2002 23:56'!
createRepositoryAt: fileNameString

	| anchor |

	self
		repository: (
			MaObjectRepository
				create: fileNameString
				controller: self);
		connect;
		forceWrite: (anchor _ MaRootAnchor new);
		forceWrite: self definition.
	self repository writeMemory.
	self repository filer
		anchorLoid: (self session oidFor: anchor);
		classesSetLoid: (self session oidFor: self definition classesSet);
		classDefinitionsLoid: (self session oidFor: self definition classDefinitions);
		allLargeCollectionsLoid: (self session oidFor: self definition allLargeCollections);
		definitionLoid: (self session oidFor: self definition).
	self close
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 7/16/2002 21:59'!
disconnect: sessionId

	self repository removeSessionFor: sessionId.
	^nil "answer nil to minimize the serialized response."
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 4/30/2002 23:29'!
forceWrite: anObject
	"This is somewhat of a hacking method to enable us to write objects needed
	for the repository to operate (i.e., commit transactions) during initial creation."

	| commitPackage |

	"protect the classDefinitions because we haven't written the repositoryDefinition yet.."
	self session
		dontRefresh: self definition classesSet;
		dontRefresh: self definition classDefinitions.
	self session begin.  "Begin tran BEFORE we serialize.."
	commitPackage _ MaCommitPackage new.
	self session serializer
		serializeGraph: anObject
		do: [ :eachObject | commitPackage addObject: eachObject ].
	commitPackage copy serializeObjectsUsing: self session.
	commitPackage serializeObjectsUsing: self session.
	self session
		refreshViewUsing: (
			self
				submitAll: commitPackage
				for: self session id);
		dontRefresh: self definition memory intervals "This is hacky.."
! !

!MagmaRepositoryController methodsFor: 'private'!
largeCollectionManagerFor: collectionOidInteger

	^self repository largeCollectionManagers at: collectionOidInteger
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/23/2002 11:04'!
open: fileNameString

	self
		privateOpen: fileNameString;
		openLargeCollections.
	MaReadStrategy initializeSystemReadStrategyUsing: self serverSerializer classIdManager.
	self startAcceptingNewConnections.
	self session begin "be ready to commit any further definition changes.."
! !

!MagmaRepositoryController methodsFor: 'private'!
openLargeCollection: aMagmaCollection

	self repository openLargeCollectionIfNecessary: aMagmaCollection
! !

!MagmaRepositoryController methodsFor: 'private'!
privateOpen: fileNameString

	MaReadStrategy initialize.
	self
		repository: (
			MaObjectRepository
				open: fileNameString
				controller: self);
		connect
! !

!MagmaRepositoryController methodsFor: 'private'!
repository

	^repository
! !

!MagmaRepositoryController methodsFor: 'private'!
repository: aMaObjectRepository

	repository _ aMaObjectRepository.
	aMaObjectRepository repositoryController == self
		ifFalse:
			[ aMaObjectRepository repositoryController: self ]
! !

!MagmaRepositoryController methodsFor: 'private'!
serverSerializer
	"The serverSerializer is used for processing client requests.  It is also
	used during administration and possibly needed during initial creation of a
	repository."

	^serverSerializer
! !

!MagmaRepositoryController methodsFor: 'private'!
session
	"The server-side session is needed for largeCollection updates to be
	processed correctly.  When a client makes a change to a largeCollection, such
	as adding or removing an index, the systemRoot change is reflected upon
	the servers session refreshing its view of the database."

	^session
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 3/30/2002 21:14'!
sessionSerializer

	^self session serializer
! !

!MagmaRepositoryController methodsFor: 'private'!
systemClientUserId

	^'__system'
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 4/29/2002 22:04'!
upgrade: aClass replace: aBoolean using: twoArgBlock

	| definitions |

	self
		validateUpgrade: aClass
		replace: aBoolean
		using: twoArgBlock.
	definitions _
		self definition classDefinitions
			detect: [ :each | each first className = aClass name ]
			ifNone: [ nil ].
	definitions notNil
		ifTrue:
			[ self session commit:
				[ self maMarked: 'dev'.
				"Can't save blocks until VI4.."
				definitions last upgradeBlock: nil.   "twoArgBlock"
				"'Yes'.  classIdManagers classDefinitionsById == self userRoot classDefinitions"
				aBoolean
					ifFalse:
						[ self serverSerializer classIdManager
							addClassDefinition: definitions last newForNextVersion ] ] ]
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 6/23/2002 10:43'!
validateCanCreateNewSessionForUserId: aString

	aString ~= self systemClientUserId
		ifTrue:
			[ isAcceptingConnections
				ifFalse:
					[ MagmaUserError signal: self name , ' is currently not accepting new connections.' ] ]
! !

!MagmaRepositoryController methodsFor: 'private' stamp: 'cmm 5/1/2002 23:19'!
validateUpgrade: aClass replace: aBoolean using: twoArgBlock 
	| definitions |
self maMarked: 'dev'.
"waiting for VI4 to be able to store upgrade blocks.."
twoArgBlock isNil ifTrue: [ ^self ]. "not needed after VI4.."
	definitions _ self definition classDefinitions 
				detect: [:each | each first className = aClass name]
				ifNone: [nil].
	twoArgBlock numArgs = 2 
		ifFalse: 
			[ MagmaUserError signal: 'A two-argument block must be specified.  The first argument is the old-version of the object (represented as an instance of MaUpgradeableObject), the second is the class being upgraded (to which you should send #basicNew before upgrading).'].
	aBoolean 
		ifTrue: 
			[ self maMarked: 'dev'.
			"should we require the definition to already have a definition if they say they're replacing?" ]
		ifFalse: 
			[(definitions notNil and: [definitions last hasSameDefinitionAs: aClass]) 
				ifTrue: 
					[self maSignalUserError: 'An updated version of ' , aClass name 
								, ' was not found in this image.']]! !


!MagmaRepositoryController class methodsFor: 'utilities'!
administer: fileNameString

	^self new administer: fileNameString
! !

!MagmaRepositoryController class methodsFor: 'utilities'!
create: fileNameString

	^self new createRepositoryAt: fileNameString
! !

!MagmaRepositoryController class methodsFor: 'utilities' stamp: 'cmm 8/2/2002 00:42'!
create: fileNameString root: anObject

	| session |
	self new createRepositoryAt: fileNameString.
	session _ MagmaSession openLocal: fileNameString.
	session
		connectAs: 'paula';
		root: anObject;
		disconnect;
		closeRepository! !

!MagmaRepositoryController class methodsFor: 'utilities'!
delete: fileNameString
	"Deletes the repository opened via fileNameString and all of its supporting files."
self maMarked: 'dev'.  "still need to do this.."
! !

!MagmaRepositoryController class methodsFor: 'open' stamp: 'cmm 4/30/2002 21:42'!
newTcpServer

	^self new
! !

!MagmaRepositoryController class methodsFor: 'open'!
open: fileNameString

	^self new open: fileNameString
! !

!MagmaRepositoryController class methodsFor: 'private' stamp: 'cmm 7/8/2002 15:16'!
protocol
	"This is the protocol needed to talk to a magma server."

	^{ 
	"core"
		LargePositiveInteger. MaSerializedGraphBuffer. 
	"part of MaLargeCollectionChanges"
		MaLargeCollectionChanges.  IdentityDictionary.  Association.
	"for when we have an unexpected exception"
		Error.  MaHardwareError.
	"for when we have an expected exception."
		MagmaUserError.  MagmaSoftwareError.
	"various requests"
		MaLargeCollectionSizeRequest. MaAnchorRequest. MaTransactionRequest. MaLargeCollectionSegmentRequest. MaKeyIntervalInfoRequest. MaWriteRequest. MaCommitPackage. MaSegmentByIndexRequest. MaBasicReadStrategy. MaRepositoryDisconnectRequest. MaSegmentByKeyRequest. MaReadRequest. MaAbortTransactionRequest. MaReadStrategy. MaRepositoryConnectionRequest. 
	"various responses"
		MaFailedCommitResult. MagmaClientConnection. MaSegmentRequestResult. MaRefreshViewResult. MaCommitResult. MaByteObjectLinkDescription. MaFirstClassObjectLinkDescription.  MagmaCommitConflict }.
! !


!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 5/29/2002 22:43'!
allLargeCollections

	^allLargeCollections! !

!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 5/29/2002 22:43'!
classDefinitions
	"Key = classId, value = anOrderedCollection of MaClassDefinitions."

	^classDefinitions
! !

!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 5/29/2002 22:43'!
classesSet

	^classesSet! !

!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 5/29/2002 22:43'!
maximumNumberOfChallengers
	"Answer the maximum number of commit entry's Magma should allow in each users session before that session will be terminated.  Commit entry's are records stored in the servers memory that record the objects changed by each user.  When a session is in a transaction, these entries 'pile up', consuming server memory.  Only when the client crosses a transaction boundary (i.e., begin, commit or abort) is the log for that session cleared."

	^maximumNumberOfChallengers
! !

!MagmaRepositoryDefinition methodsFor: 'accessing' stamp: 'cmm 5/29/2002 22:43'!
name

	^self definition name
! !

!MagmaRepositoryDefinition methodsFor: 'building' stamp: 'cmm 5/29/2002 22:43'!
maximumNumberOfChallengers: anInteger

	maximumNumberOfChallengers _ anInteger
! !

!MagmaRepositoryDefinition methodsFor: 'building' stamp: 'cmm 5/29/2002 22:43'!
name: aString

	self name: aString
! !

!MagmaRepositoryDefinition methodsFor: 'private accessing' stamp: 'cmm 5/29/2002 22:43'!
memory

	^memory! !

!MagmaRepositoryDefinition methodsFor: 'private accessing' stamp: 'cmm 5/29/2002 23:08'!
minimumClassesToCreateRepository
	"We need Dictionary and Bag to properly prepare their permanent
	ReadStrategy's in MaBasicReadStrategy class.
	In there, we set their readDepth to +1 because collections are almost always
	enumerated and it would perform poorly to materalize one at a time.
	Blocks and CompiledMethods need to always be read full depth."

	^#(
	"all collections minimumDepth is set to 2, otherwise enumeration would cause proxies to materialize one-by-one, a performance issue"
	OrderedCollection Bag IdentityBag Set IdentitySet Dictionary IdentityDictionary Array

	"don't proxy any part of these things out, it causes problems"
	CompiledMethod BlockContext

	"needed for Magma-clients"
	MaOdbmsClassDefinition)
! !

!MagmaRepositoryDefinition methodsFor: 'private building' stamp: 'cmm 5/29/2002 22:43'!
addClassNamed: aSymbol to: aMaObjectSerializer
	"The aMaObjectSerializers classIdManager (anMaOdbmsClassIdManager)
	shares its classesSet with the receiver."

	aMaObjectSerializer classIdManager addNewClass: (Smalltalk classNamed: aSymbol)
! !

!MagmaRepositoryDefinition methodsFor: 'private building' stamp: 'cmm 5/29/2002 22:43'!
classDefinitions: aDictionary

	classDefinitions _ aDictionary
! !

!MagmaRepositoryDefinition methodsFor: 'private building' stamp: 'cmm 5/29/2002 22:43'!
classesSet: aSet

	classesSet _ aSet
! !

!MagmaRepositoryDefinition methodsFor: 'private initializing' stamp: 'cmm 5/29/2002 22:43'!
addMinimumClassesForOdbmsUsing: aMaObjectSerializer
	"These are the minimum required classes for a client to communicate with the
	repositoryController."

	self minimumClassesToCreateRepository
		do:
			[ :each |
			self
				addClassNamed: each
				to: aMaObjectSerializer ].
	self classDefinitions: aMaObjectSerializer classIdManager classDefinitionsById
! !

!MagmaRepositoryDefinition methodsFor: 'private initializing' stamp: 'cmm 5/29/2002 22:43'!
initialize

	super initialize.
	self classDefinitions: Dictionary new.
	allLargeCollections _ Set new.
	memory _
		(MaIntervalCollection proximityThreshold: 1)
			addFrom: 0
				to: (MaObjectFiler sizeOfEmptyRepository - 1);
			yourself
! !


!MagmaSession class methodsFor: 'creation' stamp: 'cmm 4/30/2002 21:27'!
openLocal: fileNameString

	^self repositoryController: (MagmaRepositoryController open: fileNameString)
! !

!MagmaSession class methodsFor: 'creation' stamp: 'cmm 4/25/2002 00:01'!
repositoryController: aMaRepositoryController
	"Use this constructor only for *additional* local connections, i.e., two or more sessions connected to the same local repository.  Get the controller from your other session using #getRepositoryController.."

	| newSession |
	^(newSession _ self new) facade: 
		(MaRepositoryControllerFacade
			session: newSession
			link:
				(MaLocalServerLink localRequestServer:
					(MaLocalRequestServer requestProcessor: aMaRepositoryController)))
! !


!Set methodsFor: 'building' stamp: 'cmm 3/30/2002 21:19'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession

	| hasProxies aUniqueObject |
	aUniqueObject _ ''.
	hasProxies _ aMaObjectLinkDescription linkedOids maIncludesWhere:
		[ :eachOid |
		(aMagmaSession serializer
			objectWithOid: eachOid
			ifAbsent: [ aUniqueObject ]) == aUniqueObject ].
	hasProxies
		ifTrue:
			[ aMagmaSession readStrategy: (MaBasicReadStrategy minimumDepth: 2).
			aMagmaSession realObjectFor: (aMagmaSession oidFor: self) ].
	self removeAll: self copy.
	aMaObjectLinkDescription linkedOids do:
		[ :each |
		self add: (
			aMagmaSession serializer
				objectWithOid: each
				ifAbsent: [ aMagmaSession realObjectFor: each ]) ]
! !


!SortedCollection methodsFor: 'building' stamp: 'cmm 3/30/2002 21:19'!
maRefreshTo: aMaObjectLinkDescription using: aMagmaSession

	| hasProxies aUniqueObject |
	aUniqueObject _ ''.
	hasProxies _ aMaObjectLinkDescription linkedOids maIncludesWhere:
		[ :eachOid |
		(aMagmaSession serializer
			objectWithOid: eachOid
			ifAbsent: [ aUniqueObject ]) == aUniqueObject ].
	hasProxies
		ifTrue:
			[ aMagmaSession readStrategy: (MaBasicReadStrategy minimumDepth: 2).
			aMagmaSession realObjectFor: (aMagmaSession oidFor: self) ].
	self removeAll: self copy.
	aMaObjectLinkDescription linkedOids do:
		[ :each |
		self add: (
			aMagmaSession serializer
				objectWithOid: each
				ifAbsent: [ aMagmaSession realObjectFor: each ]) ]
! !


!MagmaRepositoryController class reorganize!
('utilities' administer: create: create:root: delete:)
('open' newTcpServer open:)
('private' protocol)
!

